--[[
-- Orca, a free and open-source Roblox script hub.
-- This script was generated by ci/bundle.lua, and is not intended to be modified.
-- To view the source code, see the 'src' folder on GitHub!
--
-- Author: 0866
-- License: MIT
-- Version: "1.0.0"
-- GitHub: https://github.com/richie0866/orca
--]]

-- Runtime module

---@class Module
---@field fn function
---@field isLoaded boolean
---@field value any

---@type table<string, Instance>
local instanceFromId = {}

---@type table<Instance, string>
local idFromInstance = {}

---@type table<Instance, Module>
local modules = {}

---Stores currently loading modules.
---@type table<LocalScript | ModuleScript, ModuleScript>
local currentlyLoading = {}

-- Module resolution

---@param module LocalScript | ModuleScript
---@param caller? LocalScript | ModuleScript
---@return function | nil cleanup
local function validateRequire(module, caller)
	currentlyLoading[caller] = module

	local currentModule = module
	local depth = 0

	-- If the module is loaded, requiring it will not cause a circular dependency.
	if not modules[module] then
		while currentModule do
			depth = depth + 1
			currentModule = currentlyLoading[currentModule]

			if currentModule == module then
				local str = currentModule.Name -- Get the string traceback

				for _ = 1, depth do
					currentModule = currentlyLoading[currentModule]
					str = str .. "  ⇒ " .. currentModule.Name
				end

				error("Failed to load '" .. module.Name .. "'; Detected a circular dependency chain: " .. str, 2)
			end
		end
	end

	return function ()
		if currentlyLoading[caller] == module then -- Thread-safe cleanup!
			currentlyLoading[caller] = nil
		end
	end
end

---@param obj LocalScript | ModuleScript
---@param this? LocalScript | ModuleScript
---@return any
local function loadModule(obj, this)
	local cleanup = this and validateRequire(obj, this)
	local module = modules[obj]

	if module.isLoaded then
		if cleanup then
			cleanup()
		end
		return module.value
	else
		local data = module.fn()
		module.value = data
		module.isLoaded = true
		if cleanup then
			cleanup()
		end
		return data
	end
end

---@param target ModuleScript
---@param this? LocalScript | ModuleScript
---@return any
local function requireModuleInternal(target, this)
	if modules[target] and target:IsA("ModuleScript") then
		return loadModule(target, this)
	else
		return require(target)
	end
end

-- Instance creation

---@param id string
---@return table<string, any> environment
local function newEnv(id)
	return setmetatable({
		VERSION = "1.0.0",
		script = instanceFromId[id],
		require = function (module)
			return requireModuleInternal(module, instanceFromId[id])
		end,
	}, {
		__index = getfenv(0),
		__metatable = "This metatable is locked",
	})
end

---@param name string
---@param className string
---@param path string
---@param parent string | nil
---@param fn function
local function newModule(name, className, path, parent, fn)
	local instance = Instance.new(className)
	instance.Name = name
	instance.Parent = instanceFromId[parent]

	instanceFromId[path] = instance
	idFromInstance[instance] = path

	modules[instance] = {
		fn = fn,
		isLoaded = false,
		value = nil,
	}
end

---@param name string
---@param className string
---@param path string
---@param parent string | nil
local function newInstance(name, className, path, parent)
	local instance = Instance.new(className)
	instance.Name = name
	instance.Parent = instanceFromId[parent]

	instanceFromId[path] = instance
	idFromInstance[instance] = path
end

-- Runtime

local function init()
	for object in pairs(modules) do
		if object:IsA("LocalScript") and not object.Disabled then
			task.spawn(loadModule, object)
		end
	end
end


newInstance("Orca","Folder","Orca",nil)newModule("App","ModuleScript","Orca.App","Orca",function()return setfenv(function()local a=require(script.Parent.include.RuntimeLib)local b=a.import(script,a.getModule(script,"@rbxts","roact").src)local c=a.import(script,script.Parent,"views","Dashboard").default;local d=7;local function e()return b.createElement("ScreenGui",{IgnoreGuiInset=true,ResetOnSpawn=false,ZIndexBehavior="Sibling",DisplayOrder=d},{b.createElement(c)})end;local f=e;return{default=f}end,newEnv("Orca.App"))()end)newInstance("components","Folder","Orca.components","Orca")newModule("Acrylic","ModuleScript","Orca.components.Acrylic","Orca.components",function()return setfenv(function()local a=require(script.Parent.Parent.include.RuntimeLib)local g={}g.default=a.import(script,script,"Acrylic").default;return g end,newEnv("Orca.components.Acrylic"))()end)newModule("Acrylic","ModuleScript","Orca.components.Acrylic.Acrylic","Orca.components.Acrylic",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.include.RuntimeLib)local b=a.import(script,a.getModule(script,"@rbxts","roact").src)local h=a.import(script,a.getModule(script,"@rbxts","roact-hooked").out)local i=h.hooked;local j=h.useCallback;local k=h.useEffect;local l=h.useMemo;local m=h.useMutable;local n=a.import(script,a.getModule(script,"@rbxts","services")).Workspace;local o=a.import(script,script.Parent,"acrylic-instance").acrylicInstance;local p=a.import(script,script.Parent.Parent.Parent,"hooks","common","rodux-hooks").useAppSelector;local q=a.import(script,script.Parent.Parent.Parent,"utils","number-util").map;local r=a.import(script,script.Parent.Parent.Parent,"utils","udim2").scale;local s=CFrame.Angles(0,math.rad(90),0)local function t(u,v)local w=n.CurrentCamera:ScreenPointToRay(u.X,u.Y)local x=w.Origin;local y=w.Direction*v;return x+y end;local function z()return q(n.CurrentCamera.ViewportSize.Y,0,2560,8,56)end;local A;local function B(C)local D=C.radius;local v=C.distance;local E=p(function(F)return F.options.acrylicBlurEnabled end)return E and b.createElement(A,{radius=D,distance=v})or b.createElement("Frame",{BackgroundTransparency=1})end;local f=i(B)local function G(C)local D=C.radius;if D==nil then D=0 end;local v=C.distance;if v==nil then v=0.001 end;local H=m({topleft2d=Vector2.new(),topright2d=Vector2.new(),bottomright2d=Vector2.new(),topleftradius2d=Vector2.new()})local I=l(function()local J=o:Clone()J.Parent=n;return J end,{})k(function()return function()return I:Destroy()end end,{})local K=j(function(L,M)local y=L/2;local N=M-y;local O=H.current;O.topleft2d=Vector2.new(math.ceil(N.X),math.ceil(N.Y))local P=O.topleft2d;local Q=Vector2.new(L.X,0)O.topright2d=P+Q;O.bottomright2d=O.topleft2d+L;local R=O.topleft2d;local S=Vector2.new(D,0)O.topleftradius2d=R+S end,{v,D})local T=j(function()local U=H.current;local V=U.topleft2d;local W=U.topright2d;local X=U.bottomright2d;local Y=U.topleftradius2d;local Z=t(V,v)local _=t(W,v)local a0=t(X,v)local a1=t(Y,v)local a2=(a1-Z).Magnitude;local a3=(_-Z).Magnitude;local a4=(_-a0).Magnitude;local a5=CFrame.fromMatrix((Z+a0)/2,n.CurrentCamera.CFrame.XVector,n.CurrentCamera.CFrame.YVector,n.CurrentCamera.CFrame.ZVector)if D~=nil and D>0 then I.Horizontal.CFrame=a5;I.Horizontal.Mesh.Scale=Vector3.new(a3-a2*2,a4,0)I.Vertical.CFrame=a5;I.Vertical.Mesh.Scale=Vector3.new(a3,a4-a2*2,0)else I.Horizontal.CFrame=a5;I.Horizontal.Mesh.Scale=Vector3.new(a3,a4,0)end;if D~=nil and D>0 then I.TopLeft.Mesh.Scale=Vector3.new(0,a2*2,a2*2)I.TopRight.Mesh.Scale=Vector3.new(0,a2*2,a2*2)I.BottomLeft.Mesh.Scale=Vector3.new(0,a2*2,a2*2)I.BottomRight.Mesh.Scale=Vector3.new(0,a2*2,a2*2)local a6=CFrame.new(-a3/2+a2,a4/2-a2,0)I.TopLeft.CFrame=a5*a6*s;local a7=CFrame.new(a3/2-a2,a4/2-a2,0)I.TopRight.CFrame=a5*a7*s;local a8=CFrame.new(-a3/2+a2,-a4/2+a2,0)I.BottomLeft.CFrame=a5*a8*s;local a9=CFrame.new(a3/2-a2,-a4/2+a2,0)I.BottomRight.CFrame=a5*a9*s end end,{D,v})k(function()T()local aa=n.CurrentCamera:GetPropertyChangedSignal("CFrame"):Connect(T)local ab=n.CurrentCamera:GetPropertyChangedSignal("FieldOfView"):Connect(T)local ac=n.CurrentCamera:GetPropertyChangedSignal("ViewportSize"):Connect(T)return function()aa:Disconnect()ab:Disconnect()ac:Disconnect()end end,{T})return b.createElement("Frame",{[b.Change.AbsoluteSize]=function(ad)local ae=z()local af=ad.AbsoluteSize;local Q=Vector2.new(ae,ae)local L=af-Q;local ag=ad.AbsolutePosition;local y=ad.AbsoluteSize/2;local M=ag+y;K(L,M)task.spawn(T)end,[b.Change.AbsolutePosition]=function(ad)local ae=z()local af=ad.AbsoluteSize;local Q=Vector2.new(ae,ae)local L=af-Q;local ag=ad.AbsolutePosition;local y=ad.AbsoluteSize/2;local M=ag+y;K(L,M)task.spawn(T)end,Size=r(1,1),BackgroundTransparency=1})end;A=i(G)return{default=f}end,newEnv("Orca.components.Acrylic.Acrylic"))()end)newModule("Acrylic.story","ModuleScript","Orca.components.Acrylic.Acrylic.story","Orca.components.Acrylic",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.include.RuntimeLib)local b=a.import(script,a.getModule(script,"@rbxts","roact").src)local ah=a.import(script,a.getModule(script,"@rbxts","roact-rodux-hooked").out).Provider;local B=a.import(script,script.Parent,"Acrylic").default;local ai=a.import(script,script.Parent.Parent.Parent,"store","models","dashboard.model").DashboardPage;local aj=a.import(script,script.Parent.Parent.Parent,"store","store").configureStore;local ak=a.import(script,script.Parent.Parent.Parent,"utils","color3").hex;local al=a.import(script,script.Parent.Parent.Parent,"utils","udim2")local am=al.px;local r=al.scale;return function(an)local ao=b.mount(b.createElement(ah,{store=aj({dashboard={isOpen=true,page=ai.Apps,hint=nil,apps={}}})},{b.createElement("Frame",{AnchorPoint=Vector2.new(0.5,0.5),Position=r(0.3,0.7),Size=am(250,350),BackgroundColor3=ak("#000000"),BackgroundTransparency=0.5,BorderSizePixel=0},{b.createElement("UICorner",{CornerRadius=UDim.new(0,64)}),b.createElement(B,{radius=52})})}),an,"Acrylic")return function()return b.unmount(ao)end end end,newEnv("Orca.components.Acrylic.Acrylic.story"))()end)newModule("acrylic-instance","ModuleScript","Orca.components.Acrylic.acrylic-instance","Orca.components.Acrylic",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.include.RuntimeLib)local ap=a.import(script,a.getModule(script,"@rbxts","make"))local aq={Color=Color3.new(0,0,0),Material=Enum.Material.Glass,Size=Vector3.new(1,1,0),Anchored=true,CanCollide=false,Locked=true,CastShadow=false,Transparency=0.999}local ar={Color=Color3.new(0,0,0),Material=Enum.Material.Glass,Size=Vector3.new(0,1,1),Anchored=true,CanCollide=false,Locked=true,CastShadow=false,Transparency=0.999}local as={}local at="Children"local au={Name="Horizontal",Children={ap("SpecialMesh",{MeshType=Enum.MeshType.Brick,Offset=Vector3.new(0,0,-0.000001)})}}for av,aw in pairs(aq)do au[av]=aw end;local ax=ap("Part",au)local ay={Name="Vertical",Children={ap("SpecialMesh",{MeshType=Enum.MeshType.Brick,Offset=Vector3.new(0,0,0.000001)})}}for av,aw in pairs(aq)do ay[av]=aw end;local az=ap("Part",ay)local aA={Name="TopRight",Children={ap("SpecialMesh",{MeshType=Enum.MeshType.Cylinder})}}for av,aw in pairs(ar)do aA[av]=aw end;local aB=ap("Part",aA)local aC={Name="TopLeft",Children={ap("SpecialMesh",{MeshType=Enum.MeshType.Cylinder})}}for av,aw in pairs(ar)do aC[av]=aw end;local aD=ap("Part",aC)local aE={Name="BottomRight",Children={ap("SpecialMesh",{MeshType=Enum.MeshType.Cylinder})}}for av,aw in pairs(ar)do aE[av]=aw end;local aF=ap("Part",aE)local aG={Name="BottomLeft",Children={ap("SpecialMesh",{MeshType=Enum.MeshType.Cylinder})}}for av,aw in pairs(ar)do aG[av]=aw end;as[at]={ax,az,aB,aD,aF,ap("Part",aG)}local o=ap("Model",as)return{acrylicInstance=o}end,newEnv("Orca.components.Acrylic.acrylic-instance"))()end)newModule("ActionButton","ModuleScript","Orca.components.ActionButton","Orca.components",function()return setfenv(function()local a=require(script.Parent.Parent.include.RuntimeLib)local b=a.import(script,a.getModule(script,"@rbxts","roact").src)local h=a.import(script,a.getModule(script,"@rbxts","roact-hooked").out)local i=h.hooked;local aH=h.useState;local aI=a.import(script,script.Parent,"BrightButton").default;local aJ=a.import(script,script.Parent.Parent,"hooks","common","rodux-hooks")local aK=aJ.useAppDispatch;local p=aJ.useAppSelector;local aL=a.import(script,script.Parent.Parent,"hooks","common","use-spring").useSpring;local aM=a.import(script,script.Parent.Parent,"store","actions","dashboard.action")local aN=aM.clearHint;local aO=aM.setHint;local aP=a.import(script,script.Parent.Parent,"store","actions","jobs.action").setJobActive;local am=a.import(script,script.Parent.Parent,"utils","udim2").px;local function aQ(C)local aR=C.action;local aS=C.hint;local aT=C.theme;local aU=C.image;local M=C.position;local aV=C.canDeactivate;local aW=aK()local aX=p(function(F)return F.jobs[aR].active end)local U=aH(false)local aY=U[1]local aZ=U[2]local a_=aT.highlight[aR]~=nil and aT.highlight[aR]or aT.background;if not(aT.highlight[aR]~=nil)then warn("ActionButton: "..aR.." is not in theme.highlight")end;local b0;if aX then b0=a_ else local b1;if aY then local b2=aT.button.backgroundHovered;if b2==nil then b2=aT.button.background:Lerp(a_,0.1)end;b1=b2 else b1=aT.button.background end;b0=b1 end;local b3=aL(b0,{})local b4=aL(aX and aT.button.foregroundAccent and aT.button.foregroundAccent or aT.button.foreground,{})return b.createElement(aI,{onActivate=function()if aX and aV then aW(aP(aR,false))elseif not aX then aW(aP(aR,true))end end,onHover=function(aY)if aY then aZ(true)aW(aO(aS))else aZ(false)aW(aN())end end,size=am(61,49),position=M,radius=8,color=b3,borderEnabled=aT.button.outlined,borderColor=b4,transparency=aT.button.backgroundTransparency},{b.createElement("ImageLabel",{Image=aU,ImageColor3=b4,ImageTransparency=aL(aX and 0 or(aY and aT.button.foregroundTransparency-0.25 or aT.button.foregroundTransparency),{}),Size=am(36,36),Position=am(12,6),BackgroundTransparency=1})})end;local f=i(aQ)return{default=f}end,newEnv("Orca.components.ActionButton"))()end)newModule("Border","ModuleScript","Orca.components.Border","Orca.components",function()return setfenv(function()local a=require(script.Parent.Parent.include.RuntimeLib)local b=a.import(script,a.getModule(script,"@rbxts","roact").src)local i=a.import(script,a.getModule(script,"@rbxts","roact-hooked").out).hooked;local b5=a.import(script,script.Parent.Parent,"utils","binding-util")local b6=b5.asBinding;local b7=b5.mapBinding;local ak=a.import(script,script.Parent.Parent,"utils","color3").hex;local am=a.import(script,script.Parent.Parent,"utils","udim2").px;local function b8(C)local L=C.size;if L==nil then L=1 end;local D=C.radius;if D==nil then D=0 end;local b9=C.color;if b9==nil then b9=ak("#ffffff")end;local ba=C.transparency;if ba==nil then ba=0 end;local bb=C[b.Children]local bc={Size=b7(L,function(bd)return UDim2.new(1,-bd*2,1,-bd*2)end),Position=b7(L,function(bd)return am(bd,bd)end),BackgroundTransparency=1}local be={}local bf=#be;local bg={Thickness=L,Color=b9,Transparency=ba}local bh={}local bi=#bh;if bb then for av,aw in pairs(bb)do if type(av)=="number"then bh[bi+av]=aw else bh[av]=aw end end end;be[bf+1]=b.createElement("UIStroke",bg,bh)be[bf+2]=b.createElement("UICorner",{CornerRadius=b.joinBindings({radius=b6(D),size=b6(L)}):map(function(bj)local D=bj.radius;local L=bj.size;return D=="circular"and UDim.new(1,0)or UDim.new(0,D-L*2)end)})return b.createElement("Frame",bc,be)end;local f=i(b8)return{default=f}end,newEnv("Orca.components.Border"))()end)newModule("BrightButton","ModuleScript","Orca.components.BrightButton","Orca.components",function()return setfenv(function()local a=require(script.Parent.Parent.include.RuntimeLib)local b=a.import(script,a.getModule(script,"@rbxts","roact").src)local i=a.import(script,a.getModule(script,"@rbxts","roact-hooked").out).hooked;local b8=a.import(script,script.Parent,"Border").default;local bk=a.import(script,script.Parent,"Canvas").default;local bl=a.import(script,script.Parent,"Fill").default;local bm=a.import(script,script.Parent,"Glow")local bn=bm.default;local bo=bm.GlowRadius;local ak=a.import(script,script.Parent.Parent,"utils","color3").hex;local al=a.import(script,script.Parent.Parent,"utils","udim2")local am=al.px;local r=al.scale;local function aI(C)local L=C.size;if L==nil then L=am(100,100)end;local M=C.position;if M==nil then M=am(0,0)end;local D=C.radius;if D==nil then D=8 end;local b9=C.color;if b9==nil then b9=ak("#FFFFFF")end;local bp=C.borderEnabled;local bq=C.borderColor;if bq==nil then bq=ak("#FFFFFF")end;local ba=C.transparency;if ba==nil then ba=0 end;local br=C.onActivate;local bs=C.onPress;local bt=C.onRelease;local bu=C.onHover;local bb=C[b.Children]local bc={size=L,position=M}local be={b.createElement(bn,{radius=bo.Size70,color=b9,size=UDim2.new(1,36,1,36),position=am(-18,5-18),transparency=ba}),b.createElement(bl,{color=b9,radius=D,transparency=ba})}local bf=#be;local bv=bp and b.createElement(b8,{color=bq,radius=D,transparency=0.8})if bv then if bv.elements~=nil or bv.props~=nil and bv.component~=nil then be[bf+1]=bv else for av,aw in ipairs(bv)do be[bf+av]=aw end end end;bf=#be;be[bf+1]=b.createElement("TextButton",{Text="",AutoButtonColor=false,Size=r(1,1),BackgroundTransparency=1,[b.Event.Activated]=function()local b0=br;if b0~=nil then b0=b0()end;return b0 end,[b.Event.MouseButton1Down]=function()local b0=bs;if b0~=nil then b0=b0()end;return b0 end,[b.Event.MouseButton1Up]=function()local b0=bt;if b0~=nil then b0=b0()end;return b0 end,[b.Event.MouseEnter]=function()local b0=bu;if b0~=nil then b0=b0(true)end;return b0 end,[b.Event.MouseLeave]=function()local b0=bu;if b0~=nil then b0=b0(false)end;return b0 end})if bb then for av,aw in pairs(bb)do if type(av)=="number"then be[bf+1+av]=aw else be[av]=aw end end end;return b.createElement(bk,bc,be)end;local f=i(aI)return{default=f}end,newEnv("Orca.components.BrightButton"))()end)newModule("BrightSlider","ModuleScript","Orca.components.BrightSlider","Orca.components",function()return setfenv(function()local a=require(script.Parent.Parent.include.RuntimeLib)local bw=a.import(script,a.getModule(script,"@rbxts","flipper").src).Spring;local b=a.import(script,a.getModule(script,"@rbxts","roact").src)local h=a.import(script,a.getModule(script,"@rbxts","roact-hooked").out)local i=h.hooked;local j=h.useCallback;local k=h.useEffect;local aH=h.useState;local bx=a.import(script,a.getModule(script,"@rbxts","services")).UserInputService;local by=a.import(script,script.Parent.Parent,"hooks","common","flipper-hooks")local bz=by.getBinding;local bA=by.useMotor;local al=a.import(script,script.Parent.Parent,"utils","udim2")local am=al.px;local r=al.scale;local b8=a.import(script,script.Parent,"Border").default;local bk=a.import(script,script.Parent,"Canvas").default;local bl=a.import(script,script.Parent,"Fill").default;local bm=a.import(script,script.Parent,"Glow")local bn=bm.default;local bo=bm.GlowRadius;local bB={frequency=8}local bC;local function bD(C)local bE=C.min;local bF=C.max;local bG=C.initialValue;local L=C.size;local M=C.position;local D=C.radius;local b9=C.color;local bH=C.accentColor;local bp=C.borderEnabled;local bq=C.borderColor;local ba=C.transparency;local bI=C.indicatorTransparency;local bJ=C.onValueChanged;local bt=C.onRelease;local bb=C[b.Children]local bK=bA(bG)local bL=bz(bK)k(function()local b0=bJ;if b0~=nil then b0(bG)end end,{})k(function()return function()return bK:destroy()end end,{})local bc={size=L,position=M}local be={b.createElement(bn,{radius=bo.Size70,color=bH,size=bL:map(function(bM)return UDim2.new((bM-bE)/(bF-bE),36,1,36)end),position=am(-18,5-18),transparency=0,maintainCornerRadius=true}),b.createElement(bl,{color=b9,radius=D,transparency=ba}),b.createElement(bk,{size=bL:map(function(bM)return r((bM-bE)/(bF-bE),1)end),clipsDescendants=true},{b.createElement("Frame",{Size=L,BackgroundColor3=bH,BackgroundTransparency=bI},{b.createElement("UICorner",{CornerRadius=UDim.new(0,D)})})})}local bf=#be;local bv=bp and b.createElement(b8,{color=bq,radius=D,transparency=0.8})if bv then if bv.elements~=nil or bv.props~=nil and bv.component~=nil then be[bf+1]=bv else for av,aw in ipairs(bv)do be[bf+av]=aw end end end;bf=#be;be[bf+1]=b.createElement(bC,{onChange=function(bN)bK:setGoal(bw.new(bN*(bF-bE)+bE,bB))local b0=bJ;if b0~=nil then b0(bN*(bF-bE)+bE)end end,onRelease=function(bN)local b0=bt;if b0~=nil then b0=b0(bN*(bF-bE)+bE)end;return b0 end})if bb then for av,aw in pairs(bb)do if type(av)=="number"then be[bf+1+av]=aw else be[av]=aw end end end;return b.createElement(bk,bc,be)end;local f=i(bD)local function bO(C)local bP=C.onChange;local bt=C.onRelease;local U=aH()local bQ=U[1]local bR=U[2]local bS=j(function(bN)bN=math.clamp(bN,0,1)bP(bN)end,{})local bT=j(function(bU,ad)return(bU-ad.AbsolutePosition.X)/ad.AbsoluteSize.X end,{})k(function()return function()local b0=bQ;if b0~=nil then b0:Disconnect()end end end,{})return b.createElement("Frame",{Active=true,Size=r(1,1),BackgroundTransparency=1,[b.Event.InputBegan]=function(ad,bV)if bV.UserInputType==Enum.UserInputType.MouseButton1 then local b0=bQ;if b0~=nil then b0:Disconnect()end;local ao=bx.InputChanged:Connect(function(bV)if bV.UserInputType==Enum.UserInputType.MouseMovement then bS(bT(bV.Position.X,ad))end end)bR(ao)bS(bT(bV.Position.X,ad))end end,[b.Event.InputEnded]=function(ad,bV)if bV.UserInputType==Enum.UserInputType.MouseButton1 then local b0=bQ;if b0~=nil then b0:Disconnect()end;bR(nil)bt(bT(bV.Position.X,ad))end end})end;bC=i(bO)return{default=f}end,newEnv("Orca.components.BrightSlider"))()end)newModule("Canvas","ModuleScript","Orca.components.Canvas","Orca.components",function()return setfenv(function()local a=require(script.Parent.Parent.include.RuntimeLib)local b=a.import(script,a.getModule(script,"@rbxts","roact").src)local i=a.import(script,a.getModule(script,"@rbxts","roact-hooked").out).hooked;local b7=a.import(script,script.Parent.Parent,"utils","binding-util").mapBinding;local r=a.import(script,script.Parent.Parent,"utils","udim2").scale;local function bk(C)local L=C.size;if L==nil then L=r(1,1)end;local M=C.position;if M==nil then M=r(0,0)end;local bW=C.anchor;local bX=C.padding;local bY=C.clipsDescendants;local bZ=C.zIndex;local bP=C.onChange;if bP==nil then bP={}end;local bb=C[b.Children]local bc={Size=L,Position=M,AnchorPoint=bW,ClipsDescendants=bY,BackgroundTransparency=1,ZIndex=bZ}for av,aw in pairs(bP)do bc[b.Change[av]]=aw end;local be={}local bf=#be;local bv=bX~=nil and b.createElement("UIPadding",{PaddingTop=b7(bX.top,function(am)return UDim.new(0,am)end),PaddingRight=b7(bX.right,function(am)return UDim.new(0,am)end),PaddingBottom=b7(bX.bottom,function(am)return UDim.new(0,am)end),PaddingLeft=b7(bX.left,function(am)return UDim.new(0,am)end)})or nil;if bv then if bv.elements~=nil or bv.props~=nil and bv.component~=nil then be[bf+1]=bv else for av,aw in ipairs(bv)do be[bf+av]=aw end end end;bf=#be;if bb then for av,aw in pairs(bb)do if type(av)=="number"then be[bf+av]=aw else be[av]=aw end end end;return b.createElement("Frame",bc,be)end;local f=i(bk)return{default=f}end,newEnv("Orca.components.Canvas"))()end)newModule("Card","ModuleScript","Orca.components.Card","Orca.components",function()return setfenv(function()local a=require(script.Parent.Parent.include.RuntimeLib)local b=a.import(script,a.getModule(script,"@rbxts","roact").src)local i=a.import(script,a.getModule(script,"@rbxts","roact-hooked").out).hooked;local B=a.import(script,script.Parent,"Acrylic").default;local b8=a.import(script,script.Parent,"Border").default;local bk=a.import(script,script.Parent,"Canvas").default;local bl=a.import(script,script.Parent,"Fill").default;local bm=a.import(script,script.Parent,"Glow")local bn=bm.default;local bo=bm.GlowRadius;local b_=a.import(script,script.Parent.Parent,"hooks","common","use-delayed-state").useDelayedState;local aL=a.import(script,script.Parent.Parent,"hooks","common","use-spring").useSpring;local c0=a.import(script,script.Parent.Parent,"hooks","use-current-page").useIsPageOpen;local am=a.import(script,script.Parent.Parent,"utils","udim2").px;local function c1(C)local c2=C.index;local c3=C.page;local aT=C.theme;local L=C.size;local M=C.position;local bb=C[b.Children]local c4=c0(c3)local c5=b_(c4,c2*40)local c6=UDim2.new(UDim.new(),M.Y)local y=am((L.X.Offset+48)*2-M.X.Offset,0)local c7=am(L.X.Offset+48*2,0)local c8=c6-y-c7;local bc={anchor=Vector2.new(0,1),size=L,position=aL(c5 and M or c8,{frequency=2,dampingRatio=0.8})}local be={b.createElement(bn,{radius=bo.Size198,size=UDim2.new(1,100,1,96),position=am(-50,-28),color=aT.dropshadow,gradient=aT.dropshadowGradient,transparency=aT.dropshadowTransparency}),b.createElement(bl,{color=aT.background,gradient=aT.backgroundGradient,transparency=aT.transparency,radius=16})}local bf=#be;if bb then for av,aw in pairs(bb)do if type(av)=="number"then be[bf+av]=aw else be[av]=aw end end end;bf=#be;local bv=aT.acrylic and b.createFragment({acrylic=b.createElement(B)})or nil;if bv then if bv.elements~=nil or bv.props~=nil and bv.component~=nil then be[bf+1]=bv else for av,aw in ipairs(bv)do be[bf+av]=aw end end end;bf=#be;local c9=aT.outlined and b.createElement(b8,{color=aT.foreground,radius=16,transparency=0.8})if c9 then if c9.elements~=nil or c9.props~=nil and c9.component~=nil then be[bf+1]=c9 else for av,aw in ipairs(c9)do be[bf+av]=aw end end end;return b.createElement(bk,bc,be)end;local f=i(c1)return{default=f}end,newEnv("Orca.components.Card"))()end)newModule("Fill","ModuleScript","Orca.components.Fill","Orca.components",function()return setfenv(function()local a=require(script.Parent.Parent.include.RuntimeLib)local b=a.import(script,a.getModule(script,"@rbxts","roact").src)local i=a.import(script,a.getModule(script,"@rbxts","roact-hooked").out).hooked;local b7=a.import(script,script.Parent.Parent,"utils","binding-util").mapBinding;local ak=a.import(script,script.Parent.Parent,"utils","color3").hex;local r=a.import(script,script.Parent.Parent,"utils","udim2").scale;local function bl(C)local b9=C.color;if b9==nil then b9=ak("#ffffff")end;local ca=C.gradient;local ba=C.transparency;if ba==nil then ba=0 end;local D=C.radius;if D==nil then D=0 end;local bb=C[b.Children]local bc={Size=r(1,1),BackgroundColor3=b9,BackgroundTransparency=ba}local be={}local bf=#be;local bv=ca and b.createFragment({gradient=b.createElement("UIGradient",{Color=ca.color,Transparency=ca.transparency,Rotation=ca.rotation})})or nil;if bv then if bv.elements~=nil or bv.props~=nil and bv.component~=nil then be[bf+1]=bv else for av,aw in ipairs(bv)do be[bf+av]=aw end end end;bf=#be;local c9=D~=nil and b.createFragment({corner=b.createElement("UICorner",{CornerRadius=b7(D,function(cb)return cb=="circular"and UDim.new(1,0)or UDim.new(0,cb)end)})})or nil;if c9 then if c9.elements~=nil or c9.props~=nil and c9.component~=nil then be[bf+1]=c9 else for av,aw in ipairs(c9)do be[bf+av]=aw end end end;bf=#be;if bb then for av,aw in pairs(bb)do if type(av)=="number"then be[bf+av]=aw else be[av]=aw end end end;return b.createElement("Frame",bc,be)end;local f=i(bl)return{default=f}end,newEnv("Orca.components.Fill"))()end)newModule("Glow","ModuleScript","Orca.components.Glow","Orca.components",function()return setfenv(function()local a=require(script.Parent.Parent.include.RuntimeLib)local b=a.import(script,a.getModule(script,"@rbxts","roact").src)local h=a.import(script,a.getModule(script,"@rbxts","roact-hooked").out)local i=h.hooked;local cc=h.useBinding;local cd=a.import(script,script.Parent.Parent,"hooks","use-scale").useScale;local b6=a.import(script,script.Parent.Parent,"utils","binding-util").asBinding;local q=a.import(script,script.Parent.Parent,"utils","number-util").map;local al=a.import(script,script.Parent.Parent,"utils","udim2")local ce=al.applyUDim2;local am=al.px;local bk=a.import(script,script.Parent,"Canvas").default;local bo;do local cf={}bo=setmetatable({},{__index=cf})bo.Size70="rbxassetid://8992230903"cf["rbxassetid://8992230903"]="Size70"bo.Size146="rbxassetid://8992584561"cf["rbxassetid://8992584561"]="Size146"bo.Size198="rbxassetid://8992230677"cf["rbxassetid://8992230677"]="Size198"end;local cg={[bo.Size70]=70/2,[bo.Size146]=146/2,[bo.Size198]=198/2}local function bn(C)local D=C.radius;local L=C.size;local M=C.position;local b9=C.color;local ca=C.gradient;local ba=C.transparency;if ba==nil then ba=0 end;local ch=C.maintainCornerRadius;local bb=C[b.Children]local U=cc(Vector2.new())local ci=U[1]local cj=U[2]local ck=cd()local cl=cg[D]local cm=ch and b.joinBindings({absoluteSize=ci,scaleFactor=ck,size=b6(L)}):map(function(bj)local ci=bj.absoluteSize;local L=bj.size;local ck=bj.scaleFactor;local cn=ce(ci,L,ck)return am(math.max(cn.X,cl*2),math.max(cn.Y,cl*2))end)or L;local co=ch and b.joinBindings({absoluteSize=ci,scaleFactor=ck,size=b6(L),transparency=b6(ba)}):map(function(bj)local ci=bj.absoluteSize;local L=bj.size;local ba=bj.transparency;local ck=bj.scaleFactor;local cp=cl*2;local cn=ce(ci,UDim2.fromScale(L.X.Scale,L.Y.Scale),ck).X;if cn<cp then return 1-(1-ba)*q(cn,0,cp,0,1)else return ba end end)or ba;local bc={onChange={AbsoluteSize=ch and function(ad)return cj(ad.AbsoluteSize)end or nil}}local be={}local bf=#be;local bg={Image=D,ImageColor3=b9,ImageTransparency=co,ScaleType="Slice",SliceCenter=Rect.new(Vector2.new(cl,cl),Vector2.new(cl,cl)),SliceScale=ck:map(function(cq)return cq*0.1+0.9 end),Size=cm,Position=M,BackgroundTransparency=1}local bh={}local bi=#bh;local bv=ca and b.createElement("UIGradient",{Color=ca.color,Transparency=ca.transparency,Rotation=ca.rotation})or nil;if bv then if bv.elements~=nil or bv.props~=nil and bv.component~=nil then bh[bi+1]=bv else for av,aw in ipairs(bv)do bh[bi+av]=aw end end end;bi=#bh;if bb then for av,aw in pairs(bb)do if type(av)=="number"then bh[bi+av]=aw else bh[av]=aw end end end;be[bf+1]=b.createElement("ImageLabel",bg,bh)return b.createElement(bk,bc,be)end;local f=i(bn)return{GlowRadius=bo,RADIUS_TO_CENTER_OFFSET=cg,default=f}end,newEnv("Orca.components.Glow"))()end)newModule("ParallaxImage","ModuleScript","Orca.components.ParallaxImage","Orca.components",function()return setfenv(function()local a=require(script.Parent.Parent.include.RuntimeLib)local b=a.import(script,a.getModule(script,"@rbxts","roact").src)local b7=a.import(script,script.Parent.Parent,"utils","binding-util").mapBinding;local r=a.import(script,script.Parent.Parent,"utils","udim2").scale;local function cr(C)local aU=C.image;local cs=C.imageSize;local ct=C.offset;local bX=C.padding;local bb=C[b.Children]local bc={Image=aU}local y=bX*2;bc.ImageRectSize=cs-y;bc.ImageRectOffset=b7(ct,function(cu)local c7=cu*bX;return bX+c7 end)bc.ScaleType="Crop"bc.Size=r(1,1)bc.BackgroundTransparency=1;local be={}local bf=#be;if bb then for av,aw in pairs(bb)do if type(av)=="number"then be[bf+av]=aw else be[av]=aw end end end;return b.createElement("ImageLabel",bc,be)end;local f=cr;return{default=f}end,newEnv("Orca.components.ParallaxImage"))()end)newModule("constants","ModuleScript","Orca.constants","Orca",function()return setfenv(function()local cv=getgenv==nil;local b2=VERSION;if b2==nil then b2="studio"end;local cw=b2;return{IS_DEV=cv,VERSION_TAG=cw}end,newEnv("Orca.constants"))()end)newInstance("context","Folder","Orca.context","Orca")newModule("scale-context","ModuleScript","Orca.context.scale-context","Orca.context",function()return setfenv(function()local a=require(script.Parent.Parent.include.RuntimeLib)local b=a.import(script,a.getModule(script,"@rbxts","roact").src)local cx=b.createContext(b.createBinding(1))return{ScaleContext=cx}end,newEnv("Orca.context.scale-context"))()end)newInstance("hooks","Folder","Orca.hooks","Orca")newInstance("common","Folder","Orca.hooks.common","Orca.hooks")newModule("flipper-hooks","ModuleScript","Orca.hooks.common.flipper-hooks","Orca.hooks.common",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.include.RuntimeLib)local g={}g.getBinding=a.import(script,script,"get-binding").getBinding;g.useGoal=a.import(script,script,"use-goal").useGoal;g.useInstant=a.import(script,script,"use-instant").useInstant;g.useLinear=a.import(script,script,"use-linear").useLinear;g.useMotor=a.import(script,script,"use-motor").useMotor;g.useSpring=a.import(script,script,"use-spring").useSpring;return g end,newEnv("Orca.hooks.common.flipper-hooks"))()end)newModule("get-binding","ModuleScript","Orca.hooks.common.flipper-hooks.get-binding","Orca.hooks.common.flipper-hooks",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.Parent.include.RuntimeLib)local cy=a.import(script,a.getModule(script,"@rbxts","flipper").src).isMotor;local cz=a.import(script,a.getModule(script,"@rbxts","roact").src).createBinding;local cA=setmetatable({},{__tostring=function()return"AssignedBinding"end})local function bz(cB)assert(cB,"Missing argument #1: motor")local y=cy(cB)assert(y,"Provided value is not a motor")if cB[cA]~=nil then return cB[cA]end;local cC,cD=cz(cB:getValue())cB:onStep(cD)cB[cA]=cC;return cC end;return{getBinding=bz}end,newEnv("Orca.hooks.common.flipper-hooks.get-binding"))()end)newModule("use-goal","ModuleScript","Orca.hooks.common.flipper-hooks.use-goal","Orca.hooks.common.flipper-hooks",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.Parent.include.RuntimeLib)local bz=a.import(script,script.Parent,"get-binding").getBinding;local bA=a.import(script,script.Parent,"use-motor").useMotor;local function cE(cF)local cB=bA(cF._targetValue)cB:setGoal(cF)return bz(cB)end;return{useGoal=cE}end,newEnv("Orca.hooks.common.flipper-hooks.use-goal"))()end)newModule("use-instant","ModuleScript","Orca.hooks.common.flipper-hooks.use-instant","Orca.hooks.common.flipper-hooks",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.Parent.include.RuntimeLib)local cG=a.import(script,a.getModule(script,"@rbxts","flipper").src).Instant;local cE=a.import(script,script.Parent,"use-goal").useGoal;local function cH(cI)return cE(cG.new(cI))end;return{useInstant=cH}end,newEnv("Orca.hooks.common.flipper-hooks.use-instant"))()end)newModule("use-linear","ModuleScript","Orca.hooks.common.flipper-hooks.use-linear","Orca.hooks.common.flipper-hooks",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.Parent.include.RuntimeLib)local cJ=a.import(script,a.getModule(script,"@rbxts","flipper").src).Linear;local cE=a.import(script,script.Parent,"use-goal").useGoal;local function cK(cI,cL)return cE(cJ.new(cI,cL))end;return{useLinear=cK}end,newEnv("Orca.hooks.common.flipper-hooks.use-linear"))()end)newModule("use-motor","ModuleScript","Orca.hooks.common.flipper-hooks.use-motor","Orca.hooks.common.flipper-hooks",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.Parent.include.RuntimeLib)local cM=a.import(script,a.getModule(script,"@rbxts","flipper").src)local cN=cM.GroupMotor;local cO=cM.SingleMotor;local m=a.import(script,a.getModule(script,"@rbxts","roact-hooked").out.hooks).useMutable;local function cP(bG)if type(bG)=="number"then return cO.new(bG)elseif type(bG)=="table"then return cN.new(bG)else error("Invalid type for initialValue. Expected 'number' or 'table', got '"..tostring(bG).."'")end end;local function bA(bG)return m(cP(bG)).current end;return{useMotor=bA}end,newEnv("Orca.hooks.common.flipper-hooks.use-motor"))()end)newModule("use-spring","ModuleScript","Orca.hooks.common.flipper-hooks.use-spring","Orca.hooks.common.flipper-hooks",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.Parent.include.RuntimeLib)local bw=a.import(script,a.getModule(script,"@rbxts","flipper").src).Spring;local cE=a.import(script,script.Parent,"use-goal").useGoal;local function aL(cI,cL)return cE(bw.new(cI,cL))end;return{useSpring=aL}end,newEnv("Orca.hooks.common.flipper-hooks.use-spring"))()end)newModule("rodux-hooks","ModuleScript","Orca.hooks.common.rodux-hooks","Orca.hooks.common",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.include.RuntimeLib)local cQ=a.import(script,a.getModule(script,"@rbxts","roact-rodux-hooked").out)local cR=cQ.useDispatch;local cS=cQ.useSelector;local cT=cQ.useStore;local p=cS;local aK=function()return cR()end;local cU=function()return cT()end;return{useAppSelector=p,useAppDispatch=aK,useAppStore=cU}end,newEnv("Orca.hooks.common.rodux-hooks"))()end)newModule("use-delayed-state","ModuleScript","Orca.hooks.common.use-delayed-state","Orca.hooks.common",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.include.RuntimeLib)local h=a.import(script,a.getModule(script,"@rbxts","roact-hooked").out)local k=h.useEffect;local m=h.useMutable;local aH=h.useState;local cV=a.import(script,script.Parent.Parent.Parent,"utils","timeout")local cW=cV.clearTimeout;local cX=cV.setTimeout;local function cY(cZ)for c_,d0 in ipairs(cZ.current)do cW(d0)end;table.clear(cZ.current)end;local function b_(d1,d2,d3)local U=aH(d1)local d4=U[1]local d5=U[2]local cZ=m({})k(function()local b0=d3;if b0~=nil then b0=b0(d1)end;if b0 then cY(cZ)d5(d1)return nil end;local d0;d0=cX(function()d5(d1)local d6=cZ.current;local y=(table.find(cZ.current,d0)or 0)-1;table.remove(d6,y+1)end,d2)local d6=cZ.current;d6[#d6+1]=d0 end,{d1})k(function()return function()return cY(cZ)end end,{})return d4 end;return{useDelayedState=b_}end,newEnv("Orca.hooks.common.use-delayed-state"))()end)newModule("use-did-mount","ModuleScript","Orca.hooks.common.use-did-mount","Orca.hooks.common",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.include.RuntimeLib)local h=a.import(script,a.getModule(script,"@rbxts","roact-hooked").out)local k=h.useEffect;local m=h.useMutable;local function d7(d8)local d9=m(d8)k(function()if d9.current then d9.current()end end,{})return d9 end;local function da()local d9=m(true)k(function()d9.current=false end,{})return d9.current end;return{useDidMount=d7,useIsMount=da}end,newEnv("Orca.hooks.common.use-did-mount"))()end)newModule("use-forced-update","ModuleScript","Orca.hooks.common.use-forced-update","Orca.hooks.common",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.include.RuntimeLib)local h=a.import(script,a.getModule(script,"@rbxts","roact-hooked").out)local j=h.useCallback;local aH=h.useState;local function db()local U=aH(0)local dc=U[2]return j(function()return dc(function(F)return F+1 end)end,{})end;return{useForcedUpdate=db}end,newEnv("Orca.hooks.common.use-forced-update"))()end)newModule("use-interval","ModuleScript","Orca.hooks.common.use-interval","Orca.hooks.common",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.include.RuntimeLib)local h=a.import(script,a.getModule(script,"@rbxts","roact-hooked").out)local k=h.useEffect;local m=h.useMutable;local cV=a.import(script,script.Parent.Parent.Parent,"utils","timeout")local dd=cV.clearInterval;local de=cV.setInterval;local function df(d8,d2)local dg=m(d8)dg.current=d8;k(function()if d2==nil then return nil end;local dh=de(function()return dg.current()end,d2)return function()return dd(dh)end end,{d2})end;return{useInterval=df}end,newEnv("Orca.hooks.common.use-interval"))()end)newModule("use-mouse-location","ModuleScript","Orca.hooks.common.use-mouse-location","Orca.hooks.common",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.include.RuntimeLib)local h=a.import(script,a.getModule(script,"@rbxts","roact-hooked").out)local cc=h.useBinding;local k=h.useEffect;local bx=a.import(script,a.getModule(script,"@rbxts","services")).UserInputService;local function di(bP)local U=cc(bx:GetMouseLocation())local u=U[1]local dj=U[2]k(function()local ao=bx.InputChanged:Connect(function(bV)if bV.UserInputType==Enum.UserInputType.MouseMovement then dj(Vector2.new(bV.Position.X,bV.Position.Y))local b0=bP;if b0~=nil then b0(Vector2.new(bV.Position.X,bV.Position.Y))end end end)return function()ao:Disconnect()end end,{})return u end;return{useMouseLocation=di}end,newEnv("Orca.hooks.common.use-mouse-location"))()end)newModule("use-promise","ModuleScript","Orca.hooks.common.use-promise","Orca.hooks.common",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.include.RuntimeLib)local h=a.import(script,a.getModule(script,"@rbxts","roact-hooked").out)local k=h.useEffect;local dk=h.useReducer;local function dl(dm)if type(dm)=="function"then return dm()end;return dm end;local dn={pending="pending",rejected="rejected",resolved="resolved"}local dp={err=nil,result=nil,state=dn.pending}local function dq(F,aR)local ax=aR.type;repeat if ax==dn.pending then return dp end;if ax==dn.resolved then return{err=nil,result=aR.payload,state=dn.resolved}end;if ax==dn.rejected then return{err=aR.payload,result=nil,state=dn.rejected}end;return F until true end;local function dr(dm,ds)if ds==nil then ds={}end;local U=dk(dq,dp)local dt=U[1]local du=dt.err;local dv=dt.result;local F=dt.state;local aW=U[2]k(function()dm=dl(dm)if not dm then return nil end;local dw=false;aW({type=dn.pending})local y=function(dv)return not dw and aW({payload=dv,type=dn.resolved})end;local dx=function(du)return not dw and aW({payload=du,type=dn.rejected})end;dm:andThen(y,dx)return function()dw=true end end,ds)return{dv,du,F}end;return{usePromise=dr}end,newEnv("Orca.hooks.common.use-promise"))()end)newModule("use-set-state","ModuleScript","Orca.hooks.common.use-set-state","Orca.hooks.common",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.include.RuntimeLib)local aH=a.import(script,a.getModule(script,"@rbxts","roact-hooked").out).useState;local function dy(dz)local U=aH(dz)local F=U[1]local dc=U[2]local dA=function(aR)return dc(function(bd)local as={}if type(bd)=="table"then for av,aw in pairs(bd)do as[av]=aw end end;local b0;if type(aR)=="function"then b0=aR(bd)else b0=aR end;if type(b0)=="table"then for av,aw in pairs(b0)do as[av]=aw end end;return as end)end;return{F,dA}end;return{default=dy}end,newEnv("Orca.hooks.common.use-set-state"))()end)newModule("use-spring","ModuleScript","Orca.hooks.common.use-spring","Orca.hooks.common",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.include.RuntimeLib)local bw=a.import(script,a.getModule(script,"@rbxts","flipper").src).Spring;local b=a.import(script,a.getModule(script,"@rbxts","roact").src)local by=a.import(script,script.Parent,"flipper-hooks")local bz=by.getBinding;local bA=by.useMotor;local dB=by.useSpring;local dC={number=dB,Color3=function(b9,cL)local cB=bA({b9.R,b9.G,b9.B})cB:setGoal({bw.new(b9.R,cL),bw.new(b9.G,cL),bw.new(b9.B,cL)})return bz(cB):map(function(C)local cb=C[1]local dD=C[2]local dE=C[3]return Color3.new(cb,dD,dE)end)end,UDim=function(dF,cL)local cB=bA({dF.Scale,dF.Offset})cB:setGoal({bw.new(dF.Scale,cL),bw.new(dF.Offset,cL)})return bz(cB):map(function(C)local bd=C[1]local cu=C[2]return UDim.new(bd,cu)end)end,UDim2=function(dG,cL)local cB=bA({dG.X.Scale,dG.X.Offset,dG.Y.Scale,dG.Y.Offset})cB:setGoal({bw.new(dG.X.Scale,cL),bw.new(dG.X.Offset,cL),bw.new(dG.Y.Scale,cL),bw.new(dG.Y.Offset,cL)})return bz(cB):map(function(C)local dH=C[1]local dI=C[2]local dJ=C[3]local dK=C[4]return UDim2.new(dH,math.round(dI),dJ,math.round(dK))end)end,Vector2=function(dL,cL)local cB=bA({dL.X,dL.Y})cB:setGoal({bw.new(dL.X,cL),bw.new(dL.Y,cL)})return bz(cB):map(function(C)local dM=C[1]local dN=C[2]return Vector2.new(dM,dN)end)end}local function aL(d1,cL)if not cL then return b.createBinding(d1)end;local aL=dC[typeof(d1)]local dx="useAnySpring: "..typeof(d1).." is not supported"assert(aL,dx)return aL(d1,cL)end;return{useSpring=aL}end,newEnv("Orca.hooks.common.use-spring"))()end)newModule("use-viewport-size","ModuleScript","Orca.hooks.common.use-viewport-size","Orca.hooks.common",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.include.RuntimeLib)local h=a.import(script,a.getModule(script,"@rbxts","roact-hooked").out)local cc=h.useBinding;local k=h.useEffect;local aH=h.useState;local n=a.import(script,a.getModule(script,"@rbxts","services")).Workspace;local function dO(bP)local U=aH(n.CurrentCamera)local dP=U[1]local dQ=U[2]local dt=cc(dP.ViewportSize)local L=dt[1]local dR=dt[2]k(function()local ao=n:GetPropertyChangedSignal("CurrentCamera"):Connect(function()if n.CurrentCamera then dQ(n.CurrentCamera)dR(n.CurrentCamera.ViewportSize)local b0=bP;if b0~=nil then b0(n.CurrentCamera.ViewportSize)end end end)return function()ao:Disconnect()end end,{})k(function()local ao=dP:GetPropertyChangedSignal("ViewportSize"):Connect(function()dR(dP.ViewportSize)local b0=bP;if b0~=nil then b0(dP.ViewportSize)end end)return function()ao:Disconnect()end end,{dP})return L end;return{useViewportSize=dO}end,newEnv("Orca.hooks.common.use-viewport-size"))()end)newModule("use-current-page","ModuleScript","Orca.hooks.use-current-page","Orca.hooks",function()return setfenv(function()local a=require(script.Parent.Parent.include.RuntimeLib)local p=a.import(script,script.Parent,"common","rodux-hooks").useAppSelector;local function dS()return p(function(F)return F.dashboard.page end)end;local function c0(c3)return p(function(F)return F.dashboard.isOpen and F.dashboard.page==c3 end)end;return{useCurrentPage=dS,useIsPageOpen=c0}end,newEnv("Orca.hooks.use-current-page"))()end)newModule("use-friends","ModuleScript","Orca.hooks.use-friends","Orca.hooks",function()return setfenv(function()local a=require(script.Parent.Parent.include.RuntimeLib)local l=a.import(script,a.getModule(script,"@rbxts","roact-hooked").out).useMemo;local dT=a.import(script,a.getModule(script,"@rbxts","services")).Players;local dr=a.import(script,script.Parent,"common","use-promise").usePromise;local function dU(ds)return dr(a.async(function()return dT.LocalPlayer:GetFriendsOnline()end),ds)end;local function dV(ds)local U=dU(ds)local dW=U[1]local du=U[2]local dX=U[3]local dY=dW;if dY~=nil then local y=function(dZ)return dZ.PlaceId~=nil and dZ.GameId~=nil end;local d_={}local bf=0;for av,aw in ipairs(dY)do if y(aw,av-1,dY)==true then bf=bf+1;d_[bf]=aw end end;dY=d_ end;local e0=dY;return{e0,du,dX}end;local function e1(ds)local U=dV(ds)local dW=U[1]local du=U[2]local dX=U[3]local e2=l(function()return{}end,ds)if not dW or#e2>0 then return{e2,du,dX}end;local y=function(dZ)local c7=function(dD)return dD.placeId==dZ.PlaceId end;local b0=nil;for e3,aw in ipairs(e2)do if c7(aw,e3-1,e2)==true then b0=aw;break end end;local e4=b0;if not e4 then e4={friends={dZ},placeId=dZ.PlaceId,thumbnail="https://www.roblox.com/asset-thumbnail/image?assetId="..tostring(dZ.PlaceId).."&width=768&height=432&format=png"}local e5=e4;e2[#e2+1]=e5 else local e6=e4.friends;e6[#e6+1]=dZ end end;for av,aw in ipairs(dW)do y(aw,av-1,dW)end;return{e2,du,dX}end;return{useFriends=dU,useFriendsPlaying=dV,useFriendActivity=e1}end,newEnv("Orca.hooks.use-friends"))()end)newModule("use-scale","ModuleScript","Orca.hooks.use-scale","Orca.hooks",function()return setfenv(function()local a=require(script.Parent.Parent.include.RuntimeLib)local b=a.import(script,a.getModule(script,"@rbxts","roact").src)local e7=a.import(script,a.getModule(script,"@rbxts","roact-hooked").out).useContext;local cx=a.import(script,script.Parent.Parent,"context","scale-context").ScaleContext;local e8=b.createBinding(1)local function cd()local b2=e7(cx)if b2==nil then b2=e8 end;return b2 end;return{useScale=cd}end,newEnv("Orca.hooks.use-scale"))()end)newModule("use-theme","ModuleScript","Orca.hooks.use-theme","Orca.hooks",function()return setfenv(function()local a=require(script.Parent.Parent.include.RuntimeLib)local p=a.import(script,script.Parent,"common","rodux-hooks").useAppSelector;local function e9(ea)return p(function(F)return F.theme.current[ea]end)end;return{useTheme=e9}end,newEnv("Orca.hooks.use-theme"))()end)newModule("jobs","ModuleScript","Orca.jobs","Orca",function()return setfenv(function()local a=require(script.Parent.include.RuntimeLib)local g={}g.setStore=a.import(script,script,"helpers","job-store").setStore;return g end,newEnv("Orca.jobs"))()end)newModule("acrylic","LocalScript","Orca.jobs.acrylic","Orca.jobs",function()return setfenv(function()local a=require(script.Parent.Parent.include.RuntimeLib)local ap=a.import(script,a.getModule(script,"@rbxts","make"))local eb=a.import(script,a.getModule(script,"@rbxts","services")).Lighting;local ec=a.import(script,script.Parent,"helpers","job-store").getStore;local cX=a.import(script,script.Parent.Parent,"utils","timeout").setTimeout;local ed=ap("DepthOfFieldEffect",{FarIntensity=0,InFocusRadius=0.1,NearIntensity=1})local ee={}local function ef()for eg in pairs(ee)do eg.Enabled=false end;ed.Parent=eb end;local function eh()for eg,ei in pairs(ee)do eg.Enabled=ei.enabled end;ed.Parent=nil end;local ej=a.async(function()local ek=a.await(ec())for c_,eg in ipairs(eb:GetChildren())do if eg:IsA("DepthOfFieldEffect")then local dx={enabled=eg.Enabled}ee[eg]=dx end end;local d0;ek.changed:connect(function(el)local b0=d0;if b0~=nil then b0:clear()end;d0=nil;if not el.dashboard.isOpen then d0=cX(eh,500)return nil end;if el.options.acrylicBlurEnabled then ef()else eh()end end)end)ej():catch(function(du)warn("[acrylic-worker] "..tostring(du))end)end,newEnv("Orca.jobs.acrylic"))()end)newInstance("character","Folder","Orca.jobs.character","Orca.jobs")newModule("flight","LocalScript","Orca.jobs.character.flight","Orca.jobs.character",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.include.RuntimeLib)local cM=a.import(script,a.getModule(script,"@rbxts","flipper").src)local cN=cM.GroupMotor;local bw=cM.Spring;local em=a.import(script,a.getModule(script,"@rbxts","services"))local dT=em.Players;local en=em.RunService;local bx=em.UserInputService;local n=em.Workspace;local eo=a.import(script,script.Parent.Parent,"helpers","job-store").onJobChange;local ep=dT.LocalPlayer;local eq={forward=Vector3.new(),backward=Vector3.new(),left=Vector3.new(),right=Vector3.new(),up=Vector3.new(),down=Vector3.new()}local er=false;local es=16;local et;local eu;local ev=cN.new({0,0,0},false)local ew,ex,ey,ez;local ej=a.async(function()a.await(eo("flight",function(eA)er=eA.active;es=eA.value;if er then ew()ex()end end))bx.InputBegan:Connect(function(bV,eB)if eB then return nil end;ey(bV.KeyCode,true)end)bx.InputEnded:Connect(function(bV)ey(bV.KeyCode,false)end)en.Heartbeat:Connect(function(eC)if er and(et and eu)then ez(eC)ev:setGoal({bw.new(eu.X),bw.new(eu.Y),bw.new(eu.Z)})ev:step(eC)local U=ev:getValue()local bU=U[1]local eD=U[2]local eE=U[3]et.AssemblyLinearVelocity=Vector3.new()local eF=n.CurrentCamera.CFrame.Rotation;local eG=Vector3.new(bU,eD,eE)et.CFrame=eF+eG end end)en.RenderStepped:Connect(function()if er and(et and eu)then local eF=n.CurrentCamera.CFrame.Rotation;local eH=et.CFrame.Position;et.CFrame=eF+eH end end)ep.CharacterAdded:Connect(function(eI)local eJ=eI:WaitForChild("HumanoidRootPart",5)if eJ and eJ:IsA("BasePart")then et=eJ end;ew()ex()end)local eK=ep.Character;if eK~=nil then eK=eK:FindFirstChild("HumanoidRootPart")end;local eL=eK;if eL and eL:IsA("BasePart")then et=eL;ew()end end)local function eM()local eN=Vector3.new()for c_,eO in pairs(eq)do eN=eN+eO end;return eN.Magnitude>0 and eN.Unit or eN end;function ew()if not et then return nil end;local U=n.CurrentCamera.CFrame;local eP=U.XVector;local eQ=U.YVector;local eR=U.ZVector;eu=CFrame.fromMatrix(et.Position,eP,eQ,eR)end;function ex()if not eu then return nil end;ev=cN.new({eu.X,eu.Y,eu.Z},false)end;function ez(eC)if not eu then return nil end;local U=n.CurrentCamera.CFrame;local eP=U.XVector;local eQ=U.YVector;local eR=U.ZVector;local eS=eM()if eS.Magnitude>0 then local y=es*eC;local dt=eS*y;local dM=dt.X;local dN=dt.Y;local eT=dt.Z;local ax=CFrame.fromMatrix(eu.Position,eP,eQ,eR)local a6=CFrame.new(dM,dN,eT)eu=ax*a6 else eu=CFrame.fromMatrix(eu.Position,eP,eQ,eR)end end;function ey(eU,eV)repeat if eU==Enum.KeyCode.W then eq.forward=eV and Vector3.new(0,0,-1)or Vector3.new()break end;if eU==Enum.KeyCode.S then eq.backward=eV and Vector3.new(0,0,1)or Vector3.new()break end;if eU==Enum.KeyCode.A then eq.left=eV and Vector3.new(-1,0,0)or Vector3.new()break end;if eU==Enum.KeyCode.D then eq.right=eV and Vector3.new(1,0,0)or Vector3.new()break end;if eU==Enum.KeyCode.Q then eq.up=eV and Vector3.new(0,-1,0)or Vector3.new()break end;if eU==Enum.KeyCode.E then eq.down=eV and Vector3.new(0,1,0)or Vector3.new()break end until true end;ej():catch(function(du)warn("[flight-worker] "..tostring(du))end)end,newEnv("Orca.jobs.character.flight"))()end)newModule("ghost","LocalScript","Orca.jobs.character.ghost","Orca.jobs.character",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.include.RuntimeLib)local em=a.import(script,a.getModule(script,"@rbxts","services"))local dT=em.Players;local n=em.Workspace;local eW=a.import(script,script.Parent.Parent,"helpers","job-store")local ec=eW.getStore;local eo=eW.onJobChange;local ep=dT.LocalPlayer;local eX;local eY;local eZ;local e_,f0,f1,f2;local ej=a.async(function()a.await(eo("ghost",function(eA,F)if F.jobs.refresh.active and eA.active then e_()elseif eA.active then f0():andThen(f1):catch(function(du)warn("[ghost-worker-active] "..tostring(du))e_()end)elseif not F.jobs.refresh.active then f2():catch(function(du)warn("[ghost-worker-inactive] "..tostring(du))end)end end))end)e_=a.async(function()local ek=a.await(ec())ek:dispatch({type="jobs/setJobActive",jobName="ghost",active=false})end)f1=a.async(function()a.await(a.Promise.fromEvent(ep.CharacterAdded,function(eI)return eI~=eX and eI~=eY end))a.await(e_())end)f0=a.async(function()local eI=ep.Character;local f3=eI;if f3~=nil then f3=f3:FindFirstChildWhichIsA("Humanoid")end;local f4=f3;if not eI or not f4 then error("Character or Humanoid is null")end;eI.Archivable=true;eY=eI:Clone()eI.Archivable=false;local f5=eI:FindFirstChild("HumanoidRootPart")local b0=f5;if b0~=nil then b0=b0:IsA("BasePart")end;eZ=b0 and f5.CFrame or nil;eX=eI;local f6=eY:FindFirstChildWhichIsA("Humanoid")for c_,f7 in ipairs(eY:GetDescendants())do if f7:IsA("BasePart")then f7.Transparency=1-(1-f7.Transparency)*0.5 end end;if f6 then f6.DisplayName=utf8.char(128123)end;local b1=eY:FindFirstChild("Animate")if b1~=nil then b1:Destroy()end;local f8=eX:FindFirstChild("Animate")if f8 then f8.Disabled=true;f8.Parent=eY end;eY.Parent=eI.Parent;ep.Character=eY;n.CurrentCamera.CameraSubject=f6;if f8 then f8.Disabled=false end;local ao;ao=f4.Died:Connect(function()ao:Disconnect()e_()end)end)f2=a.async(function()if not eX or not eY then return nil end;local f5=eX:FindFirstChild("HumanoidRootPart")local f9=eY:FindFirstChild("HumanoidRootPart")local b0=f9;if b0~=nil then b0=b0:IsA("BasePart")end;local fa=b0 and f9.CFrame or nil;local f8=eY:FindFirstChild("Animate")if f8 then f8.Disabled=true;f8.Parent=nil end;eY:Destroy()local f4=eX:FindFirstChildWhichIsA("Humanoid")local b1=f4;if b1~=nil then local ax=b1:GetPlayingAnimationTracks()local y=function(fb)return fb:Stop()end;for av,aw in ipairs(ax)do y(aw,av-1,ax)end end;local M=fa or eZ;local fc=f5;if fc~=nil then fc=fc:IsA("BasePart")end;local b2=fc;if b2 then b2=M end;if b2 then f5.CFrame=M end;ep.Character=eX;n.CurrentCamera.CameraSubject=f4;if f8 then f8.Parent=eX;f8.Disabled=false end;eX=nil;eY=nil;eZ=nil end)ej():catch(function(du)warn("[ghost-worker] "..tostring(du))end)end,newEnv("Orca.jobs.character.ghost"))()end)newModule("godmode","LocalScript","Orca.jobs.character.godmode","Orca.jobs.character",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.include.RuntimeLib)local em=a.import(script,a.getModule(script,"@rbxts","services"))local dT=em.Players;local n=em.Workspace;local eW=a.import(script,script.Parent.Parent,"helpers","job-store")local ec=eW.getStore;local eo=eW.onJobChange;local ep=dT.LocalPlayer;local fd;local e_,fe,f1;local ej=a.async(function()local function ff(du)warn("[godmode-worker] "..tostring(du))e_()end;a.await(eo("godmode",function(eA,F)if F.jobs.ghost.active and eA.active then e_()elseif eA.active then fe():andThen(f1):catch(ff)end end))end)e_=a.async(function()local ek=a.await(ec())ek:dispatch({type="jobs/setJobActive",jobName="godmode",active=false})end)f1=a.async(function()local ek=a.await(ec())a.await(a.Promise.fromEvent(ep.CharacterAdded,function(eI)local fg=ek:getState().jobs;return not fg.ghost.active and eI~=fd end))a.await(e_())end)fe=a.async(function()local fh=n.CurrentCamera.CFrame;local eI=ep.Character;if not eI then error("Character is null")end;local f4=eI:FindFirstChildWhichIsA("Humanoid")if not f4 then error("No humanoid found")end;local fi=f4:Clone()fi.Parent=eI;fd=eI;ep.Character=nil;fi:SetStateEnabled(Enum.HumanoidStateType.Dead,false)fi:SetStateEnabled(Enum.HumanoidStateType.Ragdoll,false)fi:SetStateEnabled(Enum.HumanoidStateType.FallingDown,false)fi.BreakJointsOnDeath=true;fi.DisplayDistanceType=Enum.HumanoidDisplayDistanceType.None;f4:Destroy()ep.Character=eI;n.CurrentCamera.CameraSubject=fi;task.defer(function()n.CurrentCamera.CFrame=fh end)local f8=eI:FindFirstChild("Animate")if f8 then f8.Disabled=true;f8.Disabled=false end;fi.MaxHealth=math.huge;fi.Health=fi.MaxHealth end)ej():catch(function(du)warn("[godmode-worker] "..tostring(du))end)end,newEnv("Orca.jobs.character.godmode"))()end)newModule("humanoid","LocalScript","Orca.jobs.character.humanoid","Orca.jobs.character",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.include.RuntimeLib)local dT=a.import(script,a.getModule(script,"@rbxts","services")).Players;local eW=a.import(script,script.Parent.Parent,"helpers","job-store")local ec=eW.getStore;local eo=eW.onJobChange;local fj=349.24;local ep=dT.LocalPlayer;local ei={walkSpeed=16,jumpHeight=7.2}local fk,fl,fm,fn;local ej=a.async(function()local ek=a.await(ec())local f3=ep.Character;if f3~=nil then f3=f3:FindFirstChildWhichIsA("Humanoid")end;local f4=f3;local F=ek:getState()local fo=F.jobs.walkSpeed;local fp=F.jobs.jumpHeight;a.await(eo("walkSpeed",function(eA)if eA.active and not fo.active then fk(f4)end;fo=eA;fl(f4,fo)end))a.await(eo("jumpHeight",function(eA)if eA.active and not fp.active then fm(f4)end;fp=eA;fn(f4,fp)end))ep.CharacterAdded:Connect(function(eI)local fq=eI:WaitForChild("Humanoid",5)if fq and fq:IsA("Humanoid")then f4=fq;fk(fq)fl(fq,fo)fm(fq)fn(fq,fp)end end)fk(f4)fm(f4)end)function fk(f4)if f4 then ei.walkSpeed=f4.WalkSpeed end end;function fm(f4)if f4 then ei.jumpHeight=f4.JumpHeight end end;function fl(f4,fo)if not f4 then return nil end;if fo.active then f4.WalkSpeed=fo.value else f4.WalkSpeed=ei.walkSpeed end end;function fn(f4,fp)if not f4 then return nil end;if fp.active then f4.JumpHeight=fp.value;if f4.UseJumpPower then f4.JumpPower=math.sqrt(fj*fp.value)end else f4.JumpHeight=ei.jumpHeight;if f4.UseJumpPower then f4.JumpPower=math.sqrt(fj*ei.jumpHeight)end end end;ej():catch(function(du)warn("[humanoid-worker] "..tostring(du))end)end,newEnv("Orca.jobs.character.humanoid"))()end)newModule("refresh","LocalScript","Orca.jobs.character.refresh","Orca.jobs.character",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.include.RuntimeLib)local em=a.import(script,a.getModule(script,"@rbxts","services"))local dT=em.Players;local n=em.Workspace;local eW=a.import(script,script.Parent.Parent,"helpers","job-store")local ec=eW.getStore;local eo=eW.onJobChange;local fr=10;local ep=dT.LocalPlayer;local fs;local ej=a.async(function()local ek=a.await(ec())local function e_()ek:dispatch({type="jobs/setJobActive",jobName="refresh",active=false})end;a.await(eo("refresh",function(eA,F)if F.jobs.ghost.active and eA.active then e_()elseif eA.active then fs():catch(function(du)return warn("[refresh-worker-respawn] "..tostring(du))end):finally(function()return e_()end)end end))end)fs=a.async(function()local eI=ep.Character;if not eI then error("Character is null")end;local ft=eI:FindFirstChild("HumanoidRootPart")if ft~=nil then ft=ft.CFrame end;local fu=ft;local f4=eI:FindFirstAncestorWhichIsA("Humanoid")local b0=f4;if b0~=nil then b0:ChangeState(Enum.HumanoidStateType.Dead)end;eI:ClearAllChildren()local fv=Instance.new("Model",n)ep.Character=fv;ep.Character=eI;fv:Destroy()if not fu then return nil end;local fw=a.await(a.Promise.fromEvent(ep.CharacterAdded):timeout(fr,"CharacterAdded event timed out"))local et=fw:WaitForChild("HumanoidRootPart",5)if et and(et:IsA("BasePart")and fu)then task.delay(0.1,function()et.CFrame=fu end)end end)ej():catch(function(du)warn("[refresh-worker] "..tostring(du))end)end,newEnv("Orca.jobs.character.refresh"))()end)newModule("freecam","LocalScript","Orca.jobs.freecam","Orca.jobs",function()return setfenv(function()local a=require(script.Parent.Parent.include.RuntimeLib)local fx=a.import(script,script.Parent,"helpers","freecam")local fy=fx.DisableFreecam;local fz=fx.EnableFreecam;local eo=a.import(script,script.Parent,"helpers","job-store").onJobChange;local ej=a.async(function()a.await(eo("freecam",function(eA)if eA.active then fz()else fy()end end))end)ej():catch(function(du)warn("[freecam-worker] "..tostring(du))end)end,newEnv("Orca.jobs.freecam"))()end)newInstance("helpers","Folder","Orca.jobs.helpers","Orca.jobs")newModule("freecam","ModuleScript","Orca.jobs.helpers.freecam","Orca.jobs.helpers",function()return setfenv(function()local fA=math.pi;local fB=math.abs;local fC=math.clamp;local fD=math.exp;local fE=math.rad;local fF=math.sign;local fG=math.sqrt;local fH=math.tan;local fI=game:GetService("ContextActionService")local dT=game:GetService("Players")local en=game:GetService("RunService")local fJ=game:GetService("StarterGui")local bx=game:GetService("UserInputService")local n=game:GetService("Workspace")local fK=dT.LocalPlayer;if not fK then dT:GetPropertyChangedSignal("LocalPlayer"):Wait()fK=dT.LocalPlayer end;local fL=n.CurrentCamera;n:GetPropertyChangedSignal("CurrentCamera"):Connect(function()local fM=n.CurrentCamera;if fM then fL=fM end end)local fN=Enum.ContextActionPriority.Low.Value;local fO=Enum.ContextActionPriority.High.Value;local fP={Enum.KeyCode.LeftShift,Enum.KeyCode.P}local fQ=game:GetService("HttpService"):GenerateGUID(false)local fR=Vector3.new(1,1,1)*64;local fS=Vector2.new(0.75,1)*8;local fT=300;local fU=fE(90)local fV=2.0;local fW=3.0;local fX=4.0;local bw={}do bw.__index=bw;function bw.new(fY,fZ)local self=setmetatable({},bw)self.f=fY;self.p=fZ;self.v=fZ*0;return self end;function bw:Update(f_,cF)local g0=self.f*2*fA;local g1=self.p;local g2=self.v;local ct=cF-g1;local g3=fD(-g0*f_)local g4=cF+(g2*f_-ct*(g0*f_+1))*g3;local g5=(g0*f_*(ct*g0-g2)+g2)*g3;self.p=g4;self.v=g5;return g4 end;function bw:Reset(fZ)self.p=fZ;self.v=fZ*0 end end;local g6=Vector3.new()local g7=Vector2.new()local g8=0;local g9=bw.new(fV,Vector3.new())local ga=bw.new(fW,Vector2.new())local gb=bw.new(fX,0)local gc={}do local gd;do local ge=2.0;local gf=0.15;local function gg(bU)return(fD(ge*bU)-1)/(fD(ge)-1)end;local function gh(bU)return gg((bU-gf)/(1-gf))end;function gd(bU)return fF(bU)*fC(gh(fB(bU)),0,1)end end;local gi={ButtonX=0,ButtonY=0,DPadDown=0,DPadUp=0,ButtonL2=0,ButtonR2=0,Thumbstick1=Vector2.new(),Thumbstick2=Vector2.new()}local gj={W=0,A=0,S=0,D=0,E=0,Q=0,U=0,H=0,J=0,K=0,I=0,Y=0,Up=0,Down=0,LeftShift=0,RightShift=0}local gk={Delta=Vector2.new(),MouseWheel=0}local gl=Vector3.new(1,1,1)local gm=Vector3.new(1,1,1)local gn=Vector2.new(1,1)*fA/64;local go=Vector2.new(1,1)*fA/8;local gp=1.0;local gq=0.25;local gr=0.75;local gs=0.25;local gt=1;function gc.Vel(f_)gt=fC(gt+f_*(gj.Up-gj.Down)*gr,0.01,4)local gu=Vector3.new(gd(gi.Thumbstick1.X),gd(gi.ButtonR2)-gd(gi.ButtonL2),gd(-gi.Thumbstick1.Y))*gl;local gv=Vector3.new(gj.D-gj.A+gj.K-gj.H,gj.E-gj.Q+gj.I-gj.Y,gj.S-gj.W+gj.J-gj.U)*gm;local gw=bx:IsKeyDown(Enum.KeyCode.LeftShift)or bx:IsKeyDown(Enum.KeyCode.RightShift)return(gu+gv)*gt*(gw and gs or 1)end;function gc.Pan(f_)local gu=Vector2.new(gd(gi.Thumbstick2.Y),gd(-gi.Thumbstick2.X))*go;local gx=gk.Delta*gn/(f_*60)gk.Delta=Vector2.new()return gu+gx end;function gc.Fov(f_)local gu=(gi.ButtonX-gi.ButtonY)*gq;local gx=gk.MouseWheel*gp;gk.MouseWheel=0;return gu+gx end;do local function gy(aR,F,bV)gj[bV.KeyCode.Name]=F==Enum.UserInputState.Begin and 1 or 0;return Enum.ContextActionResult.Sink end;local function gz(aR,F,bV)gi[bV.KeyCode.Name]=F==Enum.UserInputState.Begin and 1 or 0;return Enum.ContextActionResult.Sink end;local function gA(aR,F,bV)local gB=bV.Delta;gk.Delta=Vector2.new(-gB.y,-gB.x)return Enum.ContextActionResult.Sink end;local function gC(aR,F,bV)gi[bV.KeyCode.Name]=bV.Position;return Enum.ContextActionResult.Sink end;local function gD(aR,F,bV)gi[bV.KeyCode.Name]=bV.Position.z;return Enum.ContextActionResult.Sink end;local function gE(aR,F,bV)gk[bV.UserInputType.Name]=-bV.Position.z;return Enum.ContextActionResult.Sink end;local function gF(gG)for gH,bM in pairs(gG)do gG[gH]=bM*0 end end;function gc.StartCapture()fI:BindActionAtPriority(fQ.."FreecamKeyboard",gy,false,fO,Enum.KeyCode.W,Enum.KeyCode.A,Enum.KeyCode.S,Enum.KeyCode.D,Enum.KeyCode.E,Enum.KeyCode.Q,Enum.KeyCode.Up,Enum.KeyCode.Down)fI:BindActionAtPriority(fQ.."FreecamMousePan",gA,false,fO,Enum.UserInputType.MouseMovement)fI:BindActionAtPriority(fQ.."FreecamMouseWheel",gE,false,fO,Enum.UserInputType.MouseWheel)fI:BindActionAtPriority(fQ.."FreecamGamepadButton",gz,false,fO,Enum.KeyCode.ButtonX,Enum.KeyCode.ButtonY)fI:BindActionAtPriority(fQ.."FreecamGamepadTrigger",gD,false,fO,Enum.KeyCode.ButtonR2,Enum.KeyCode.ButtonL2)fI:BindActionAtPriority(fQ.."FreecamGamepadThumbstick",gC,false,fO,Enum.KeyCode.Thumbstick1,Enum.KeyCode.Thumbstick2)end;function gc.StopCapture()gt=1;gF(gi)gF(gj)gF(gk)fI:UnbindAction(fQ.."FreecamKeyboard")fI:UnbindAction(fQ.."FreecamMousePan")fI:UnbindAction(fQ.."FreecamMouseWheel")fI:UnbindAction(fQ.."FreecamGamepadButton")fI:UnbindAction(fQ.."FreecamGamepadTrigger")fI:UnbindAction(fQ.."FreecamGamepadThumbstick")end end end;local function gI(gJ)local gK=0.1;local gL=fL.ViewportSize;local gM=2*fH(g8/2)local gN=gL.x/gL.y*gM;local gO=gJ.rightVector;local gP=gJ.upVector;local gQ=gJ.lookVector;local gR=Vector3.new()local gS=512;for bU=0,1,0.5 do for eD=0,1,0.5 do local gT=(bU-0.5)*gN;local gU=(eD-0.5)*gM;local ct=gO*gT-gP*gU+gQ;local gV=gJ.p+ct*gK;local c_,gW=n:FindPartOnRay(Ray.new(gV,ct.unit*gS))local gX=(gW-gV).magnitude;if gS>gX then gS=gX;gR=ct.unit end end end;return gQ:Dot(gR)*gS end;local function gY(f_)local gZ=g9:Update(f_,gc.Vel(f_))local g_=ga:Update(f_,gc.Pan(f_))local h0=gb:Update(f_,gc.Fov(f_))local h1=fG(fH(fE(70/2))/fH(fE(g8/2)))g8=fC(g8+h0*fT*f_/h1,1,120)g7=g7+g_*fS*f_/h1;g7=Vector2.new(fC(g7.x,-fU,fU),g7.y%(2*fA))local fh=CFrame.new(g6)*CFrame.fromOrientation(g7.x,g7.y,0)*CFrame.new(gZ*fR*f_)g6=fh.p;fL.CFrame=fh;fL.Focus=fh*CFrame.new(0,0,-gI(fh))fL.FieldOfView=g8 end;local h2={}do local h3;local h4;local h5;local h6;local fh;local h7;local h8={}local h9={Backpack=true,Chat=true,Health=true,PlayerList=true}local ha={BadgesNotificationsActive=true,PointsNotificationsActive=true}function h2.Push()h7=fL.FieldOfView;fL.FieldOfView=70;fh=fL.CFrame;h6=fL.Focus;h3=bx.MouseBehavior;bx.MouseBehavior=Enum.MouseBehavior.Default end;function h2.Pop()fL.FieldOfView=h7;h7=nil;fL.CFrame=fh;fh=nil;fL.Focus=h6;h6=nil;bx.MouseBehavior=h3;h3=nil end end;local function hb()local fh=fL.CFrame;g7=Vector2.new(fh:toEulerAnglesYXZ())g6=fh.p;g8=fL.FieldOfView;g9:Reset(Vector3.new())ga:Reset(Vector2.new())gb:Reset(0)h2.Push()en:BindToRenderStep(fQ,Enum.RenderPriority.Camera.Value+1,gY)gc.StartCapture()end;local function hc()gc.StopCapture()en:UnbindFromRenderStep(fQ)h2.Pop()end;local er=false;local function fz()if not er then hb()er=true end end;local function fy()if er then hc()er=false end end;return{EnableFreecam=fz,DisableFreecam=fy}end,newEnv("Orca.jobs.helpers.freecam"))()end)newModule("get-selected-player","ModuleScript","Orca.jobs.helpers.get-selected-player","Orca.jobs.helpers",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.include.RuntimeLib)local dT=a.import(script,a.getModule(script,"@rbxts","services")).Players;local ec=a.import(script,script.Parent,"job-store").getStore;local hd=a.async(function(bP)local ek=a.await(ec())local he={current=nil}ek.changed:connect(function(el)local hf=el.dashboard.apps.playerSelected;local b0=he.current;if b0~=nil then b0=b0.Name end;if b0~=hf then he.current=hf~=nil and dT:FindFirstChild(hf)or nil;if bP then task.defer(bP,he.current)end end end)return he end)return{getSelectedPlayer=hd}end,newEnv("Orca.jobs.helpers.get-selected-player"))()end)newModule("job-store","ModuleScript","Orca.jobs.helpers.job-store","Orca.jobs.helpers",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.include.RuntimeLib)local de=a.import(script,script.Parent.Parent.Parent,"utils","timeout").setInterval;local ek={}local function hg(hh)if ek.current then error("Store has already been set")end;ek.current=hh end;local ec=a.async(function()if ek.current then return ek.current end;return a.Promise.new(function(hi,c_,hj)local hk;hk=de(function()if ek.current then hi(ek.current)hk:clear()end end,100)hj(function()hk:clear()end)end)end)local hl;local eo=a.async(function(hm,d8)local ek=a.await(ec())local hn=ek:getState().jobs[hm]return ek.changed:connect(function(el)local eA=el.jobs[hm]if not hl(eA,hn)then hn=eA;task.defer(d8,eA,el)end end)end)function hl(ho,dE)for ea in pairs(ho)do if ho[ea]~=dE[ea]then return false end end;return true end;return{setStore=hg,getStore=ec,onJobChange=eo}end,newEnv("Orca.jobs.helpers.job-store"))()end)newInstance("players","Folder","Orca.jobs.players","Orca.jobs")newModule("hide","LocalScript","Orca.jobs.players.hide","Orca.jobs.players",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.include.RuntimeLib)local dT=a.import(script,a.getModule(script,"@rbxts","services")).Players;local hd=a.import(script,script.Parent.Parent,"helpers","get-selected-player").getSelectedPlayer;local eW=a.import(script,script.Parent.Parent,"helpers","job-store")local ec=eW.getStore;local eo=eW.onJobChange;local aP=a.import(script,script.Parent.Parent.Parent,"store","actions","jobs.action").setJobActive;local hp={}local function hq(ep)if hp[ep]~=nil then return nil end;local eI=ep.Character;local hr;hr={character=eI,parent=eI.Parent,handle=ep.CharacterAdded:Connect(function(fw)fw.Parent=nil;hr.character=eI end)}hp[ep]=hr;eI.Parent=nil end;local function hs(ep,ht)if not(hp[ep]~=nil)then return nil end;local hr=hp[ep]if ht then hr.character.Parent=hr.parent end;hr.handle:Disconnect()hp[ep]=nil end;local ej=a.async(function()local ek=a.await(ec())local he=a.await(hd(function(ep)local hu=ek;local b0;if ep then b0=hp[ep]~=nil else b0=false end;hu:dispatch(aP("hide",b0))end))dT.PlayerRemoving:Connect(function(ep)if ep==he.current then ek:dispatch(aP("hide",false))else hs(ep,false)end end)a.await(eo("hide",function(eA)local ep=he.current;if not ep then ek:dispatch(aP("hide",false))return nil end;if eA.active and ep.Character then hq(ep)elseif not eA.active then hs(ep,true)end end))end)ej():catch(function(du)warn("[hide-worker] "..tostring(du))end)end,newEnv("Orca.jobs.players.hide"))()end)newModule("kill","LocalScript","Orca.jobs.players.kill","Orca.jobs.players",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.include.RuntimeLib)local em=a.import(script,a.getModule(script,"@rbxts","services"))local dT=em.Players;local n=em.Workspace;local hd=a.import(script,script.Parent.Parent,"helpers","get-selected-player").getSelectedPlayer;local eW=a.import(script,script.Parent.Parent,"helpers","job-store")local ec=eW.getStore;local eo=eW.onJobChange;local aP=a.import(script,script.Parent.Parent.Parent,"store","actions","jobs.action").setJobActive;local ep=dT.LocalPlayer;local hv=a.async(function(hw)local hx=ep:FindFirstChildWhichIsA("Backpack")if not hx then error("No inventory found")end;local hy=ep.Character;local hz=hw.Character;if not hy or not hz then error("Victim or local player has no character")end;local hA=hy:FindFirstChildWhichIsA("Humanoid")local hB=hy:FindFirstChild("HumanoidRootPart")local hC=hz:FindFirstChild("HumanoidRootPart")if not hA or(not hB or not hC)then error("Victim or local player has no Humanoid or root part")end;local hD={}local bf=#hD;local hE=hy:GetChildren()local hF=#hE;table.move(hE,1,hF,bf+1,hD)bf=bf+hF;local hG=hx:GetChildren()table.move(hG,1,#hG,bf+1,hD)local y=function(hH)return hH:IsA("Tool")and hH:FindFirstChild("Handle")~=nil end;local b0=nil;for e3,aw in ipairs(hD)do if y(aw,e3-1,hD)==true then b0=aw;break end end;local hI=b0;if not hI then error("A tool with a handle is required to kill this victim")end;hA.Name=""local fi=hA:Clone()fi.DisplayName=utf8.char(128298)fi.Parent=hy;fi.Name="Humanoid"task.wait()hA:Destroy()n.CurrentCamera.CameraSubject=fi;hI.Parent=hy;do local hJ=0;local hK=false;while true do if hK then hJ=hJ+1 else hK=true end;if not(hJ<250)then break end;if hC.Parent~=hz or hB.Parent~=hy then error("Victim or local player has no root part; did a player respawn?")end;if hI.Parent~=hy then return hB end;hB.CFrame=hC.CFrame;task.wait(0.1)end end;error("Failed to attach to victim")end)local hL=a.async(function(hw)local ek=a.await(ec())local hM=ep.Character;if hM~=nil then hM=hM:FindFirstChild("HumanoidRootPart")end;local hN=hM;local b0=hN;if b0~=nil then b0=b0:IsA("BasePart")end;local u=b0 and hN.CFrame or nil;ek:dispatch(aP("refresh",true))a.await(a.Promise.fromEvent(ep.CharacterAdded,function(eI)return eI:WaitForChild("HumanoidRootPart",5)~=nil end))task.wait(0.3)local f5=a.await(hv(hw))local U={hw.Character,ep.Character}local hz=U[1]local hy=U[2]repeat do task.wait(0.1)f5.CFrame=CFrame.new(1000000,n.FallenPartsDestroyHeight+5,1000000)end;local b1=hz;if b1~=nil then b1=b1:FindFirstChild("HumanoidRootPart")end;local b2=b1~=nil;if b2 then local fc=hy;if fc~=nil then fc=fc:FindFirstChild("HumanoidRootPart")end;b2=fc~=nil end until not b2;local fw=a.await(a.Promise.fromEvent(ep.CharacterAdded,function(eI)return eI:WaitForChild("HumanoidRootPart",5)~=nil end))if u then fw.HumanoidRootPart.CFrame=u end end)local ej=a.async(function()local ek=a.await(ec())local he=a.await(hd())a.await(eo("kill",function(eA)if eA.active then if not he.current then ek:dispatch(aP("kill",false))return nil end;hL(he.current):catch(function(du)return warn("[kill-worker] "..tostring(du))end):finally(function()return ek:dispatch(aP("kill",false))end)end end))end)ej():catch(function(du)warn("[kill-worker] "..tostring(du))end)end,newEnv("Orca.jobs.players.kill"))()end)newModule("spectate","LocalScript","Orca.jobs.players.spectate","Orca.jobs.players",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.include.RuntimeLib)local n=a.import(script,a.getModule(script,"@rbxts","services")).Workspace;local hd=a.import(script,script.Parent.Parent,"helpers","get-selected-player").getSelectedPlayer;local eW=a.import(script,script.Parent.Parent,"helpers","job-store")local ec=eW.getStore;local eo=eW.onJobChange;local aP=a.import(script,script.Parent.Parent.Parent,"store","actions","jobs.action").setJobActive;local ej=a.async(function()local ek=a.await(ec())local he=a.await(hd(function()ek:dispatch(aP("spectate",false))end))local hO=false;local hP;local hQ;local function hR(dP)dP:GetPropertyChangedSignal("CameraSubject"):Connect(function()if hP~=dP.CameraSubject and ek:getState().jobs.spectate.active then hO=false;ek:dispatch(aP("spectate",false))end end)end;n:GetPropertyChangedSignal("CurrentCamera"):Connect(function()hR(n.CurrentCamera)end)hR(n.CurrentCamera)a.await(eo("spectate",function(eA)local dP=n.CurrentCamera;if eA.active then local hS=he.current;if hS~=nil then hS=hS.Character;if hS~=nil then hS=hS:FindFirstChildWhichIsA("Humanoid")end end;local hT=hS;if not hT then ek:dispatch(aP("spectate",false))else hO=true;hQ=dP.CameraSubject;hP=hT;dP.CameraSubject=hT end elseif hO then hO=false;dP.CameraSubject=hQ;hQ=nil;hP=nil end end))end)ej():catch(function(du)warn("[spectate-worker] "..tostring(du))end)end,newEnv("Orca.jobs.players.spectate"))()end)newModule("teleport","LocalScript","Orca.jobs.players.teleport","Orca.jobs.players",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.include.RuntimeLib)local dT=a.import(script,a.getModule(script,"@rbxts","services")).Players;local hd=a.import(script,script.Parent.Parent,"helpers","get-selected-player").getSelectedPlayer;local eW=a.import(script,script.Parent.Parent,"helpers","job-store")local ec=eW.getStore;local eo=eW.onJobChange;local aP=a.import(script,script.Parent.Parent.Parent,"store","actions","jobs.action").setJobActive;local cX=a.import(script,script.Parent.Parent.Parent,"utils","timeout").setTimeout;local ej=a.async(function()local ek=a.await(ec())local he=a.await(hd(function()ek:dispatch(aP("teleport",false))end))local d0;a.await(eo("teleport",function(eA)local b0=d0;if b0~=nil then b0:clear()end;d0=nil;if eA.active then local hU=dT.LocalPlayer.Character;if hU~=nil then hU=hU:FindFirstChild("HumanoidRootPart")end;local f5=hU;local hV=he.current;if hV~=nil then hV=hV.Character;if hV~=nil then hV=hV:FindFirstChild("HumanoidRootPart")end end;local hW=hV;if not hW or(not f5 or(not f5:IsA("BasePart")or not hW:IsA("BasePart")))then ek:dispatch(aP("teleport",false))warn("[teleport-worker] Failed to find root parts ("..tostring(f5).." -> "..tostring(hW)..")")return nil end;d0=cX(function()ek:dispatch(aP("teleport",false))local a6=hW.CFrame;local a7=CFrame.new(0,0,1)f5.CFrame=a6*a7 end,1000)end end))end)ej():catch(function(du)warn("[teleport-worker] "..tostring(du))end)end,newEnv("Orca.jobs.players.teleport"))()end)newModule("server","LocalScript","Orca.jobs.server","Orca.jobs",function()return setfenv(function()local a=require(script.Parent.Parent.include.RuntimeLib)local em=a.import(script,a.getModule(script,"@rbxts","services"))local hX=em.HttpService;local dT=em.Players;local hY=em.TeleportService;local eW=a.import(script,script.Parent,"helpers","job-store")local ec=eW.getStore;local eo=eW.onJobChange;local aP=a.import(script,script.Parent.Parent,"store","actions","jobs.action").setJobActive;local hZ=a.import(script,script.Parent.Parent,"utils","http")local cX=a.import(script,script.Parent.Parent,"utils","timeout").setTimeout;local h_;local i0=a.async(function()h_()local i1=hX:JSONDecode(a.await(hZ.get("https://games.roblox.com/v1/games/"..tostring(game.PlaceId).."/servers/Public?sortOrder=Asc&limit=100")))local i2=i1.data;local y=function(i3)return i3.playing<i3.maxPlayers and i3.id~=game.JobId end;local d_={}local bf=0;for av,aw in ipairs(i2)do if y(aw,av-1,i2)==true then bf=bf+1;d_[bf]=aw end end;local i4=d_;if#i4==0 then error("[server-worker-switch] No servers available.")else local i3=i4[math.random(#i4-1)+1]hY:TeleportToPlaceInstance(game.PlaceId,i3.id)end end)local i5=a.async(function()h_()if#dT:GetPlayers()==1 then hY:Teleport(game.PlaceId,dT.LocalPlayer)else hY:TeleportToPlaceInstance(game.PlaceId,game.JobId)end end)function h_()local i6={string.match(VERSION,"^.+%..+%..+$")}~=nil;local eU=i6 and'loadstring(game:HttpGetAsync("https://raw.githubusercontent.com/richie0866/orca/master/public/latest.lua"))()'or'loadstring(game:HttpGetAsync("https://raw.githubusercontent.com/richie0866/orca/master/public/snapshot.lua"))()'local b0=syn;if b0~=nil then b0=b0.queue_on_teleport end;local b2=b0;if b2==nil then b2=queue_on_teleport end;local b1=b2;if b1~=nil then b1(eU)end end;local ej=a.async(function()local ek=a.await(ec())local d0;local function cW()local b0=d0;if b0~=nil then b0:clear()end;d0=nil end;a.await(eo("rejoinServer",function(eA,F)cW()if F.jobs.switchServer.active then aP("switchServer",false)end;if eA.active then d0=cX(function()i5():catch(function(du)warn("[server-worker-rejoin] "..tostring(du))ek:dispatch(aP("rejoinServer",false))end)end,1000)end end))a.await(eo("switchServer",function(eA,F)cW()if F.jobs.rejoinServer.active then aP("rejoinServer",false)end;if eA.active then d0=cX(function()i0():catch(function(du)warn("[server-worker-switch] "..tostring(du))ek:dispatch(aP("switchServer",false))end)end,1000)end end))end)ej():catch(function(du)warn("[server-worker] "..tostring(du))end)end,newEnv("Orca.jobs.server"))()end)newModule("main","LocalScript","Orca.main","Orca",function()return setfenv(function()local a=require(script.Parent.include.RuntimeLib)local ap=a.import(script,a.getModule(script,"@rbxts","make"))local b=a.import(script,a.getModule(script,"@rbxts","roact").src)local ah=a.import(script,a.getModule(script,"@rbxts","roact-rodux-hooked").out).Provider;local dT=a.import(script,a.getModule(script,"@rbxts","services")).Players;local cv=a.import(script,script.Parent,"constants").IS_DEV;local hg=a.import(script,script.Parent,"jobs").setStore;local i7=a.import(script,script.Parent,"store","actions","dashboard.action").toggleDashboard;local aj=a.import(script,script.Parent,"store","store").configureStore;local e=a.import(script,script.Parent,"App").default;if getgenv()._ORCA_IS_LOADED~=nil then error("Orca is already loaded!")end;local ek=aj()hg(ek)local i8=ap("Folder",{})b.mount(b.createElement(ah,{store=ek},{b.createElement(e)}),i8)local i9=i8:WaitForChild("1")local ia=syn and syn.protect_gui or protect_gui;if ia then ia(i9)end;if cv then i9.Parent=dT.LocalPlayer:WaitForChild("PlayerGui")elseif gethui then i9.Parent=gethui()else i9.Parent=game:GetService("CoreGui")end;getgenv()._ORCA_IS_LOADED=true;if time()>3 then task.defer(function()return ek:dispatch(i7())end)end end,newEnv("Orca.main"))()end)newInstance("store","Folder","Orca.store","Orca")newInstance("actions","Folder","Orca.store.actions","Orca.store")newModule("dashboard.action","ModuleScript","Orca.store.actions.dashboard.action","Orca.store.actions",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.include.RuntimeLib)local ib=a.import(script,a.getModule(script,"@rbxts","rodux").src)local ic=ib.makeActionCreator("dashboard/setDashboardPage",function(c3)return{page=c3}end)local i7=ib.makeActionCreator("dashboard/toggleDashboard",function()return{}end)local aO=ib.makeActionCreator("dashboard/setHint",function(aS)return{hint=aS}end)local aN=ib.makeActionCreator("dashboard/clearHint",function()return{}end)local he=ib.makeActionCreator("dashboard/playerSelected",function(ep)return{name=ep.Name}end)local id=ib.makeActionCreator("dashboard/playerDeselected",function()return{}end)return{setDashboardPage=ic,toggleDashboard=i7,setHint=aO,clearHint=aN,playerSelected=he,playerDeselected=id}end,newEnv("Orca.store.actions.dashboard.action"))()end)newModule("jobs.action","ModuleScript","Orca.store.actions.jobs.action","Orca.store.actions",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.include.RuntimeLib)local ib=a.import(script,a.getModule(script,"@rbxts","rodux").src)local aP=ib.makeActionCreator("jobs/setJobActive",function(hm,aX)return{jobName=hm,active=aX}end)local ie=ib.makeActionCreator("jobs/setJobValue",function(hm,d1)return{jobName=hm,value=d1}end)return{setJobActive=aP,setJobValue=ie}end,newEnv("Orca.store.actions.jobs.action"))()end)newModule("options.action","ModuleScript","Orca.store.actions.options.action","Orca.store.actions",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.include.RuntimeLib)local ib=a.import(script,a.getModule(script,"@rbxts","rodux").src)local ig=ib.makeActionCreator("options/setAcrylicBlurEnabled",function(aX)return{active=aX}end)return{setAcrylicBlurEnabled=ig}end,newEnv("Orca.store.actions.options.action"))()end)newModule("theme.action","ModuleScript","Orca.store.actions.theme.action","Orca.store.actions",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.include.RuntimeLib)local ib=a.import(script,a.getModule(script,"@rbxts","rodux").src)local ih=ib.makeActionCreator("theme/setTheme",function(aT)return{theme=aT}end)return{setTheme=ih}end,newEnv("Orca.store.actions.theme.action"))()end)newInstance("models","Folder","Orca.store.models","Orca.store")newModule("dashboard.model","ModuleScript","Orca.store.models.dashboard.model","Orca.store.models",function()return setfenv(function()local ai;do local cf={}ai=setmetatable({},{__index=cf})ai.Home="home"cf.home="Home"ai.Apps="apps"cf.apps="Apps"ai.Scripts="scripts"cf.scripts="Scripts"ai.Options="options"cf.options="Options"end;local ii={[ai.Home]=0,[ai.Apps]=1,[ai.Scripts]=2,[ai.Options]=3}local ij={[ai.Home]="rbxassetid://8992031167",[ai.Apps]="rbxassetid://8992031246",[ai.Scripts]="rbxassetid://8992030918",[ai.Options]="rbxassetid://8992031056"}return{DashboardPage=ai,PAGE_TO_INDEX=ii,PAGE_TO_ICON=ij}end,newEnv("Orca.store.models.dashboard.model"))()end)newModule("jobs.model","ModuleScript","Orca.store.models.jobs.model","Orca.store.models",function()return setfenv(function()end,newEnv("Orca.store.models.jobs.model"))()end)newModule("options.model","ModuleScript","Orca.store.models.options.model","Orca.store.models",function()return setfenv(function()end,newEnv("Orca.store.models.options.model"))()end)newModule("theme.model","ModuleScript","Orca.store.models.theme.model","Orca.store.models",function()return setfenv(function()end,newEnv("Orca.store.models.theme.model"))()end)newInstance("reducers","Folder","Orca.store.reducers","Orca.store")newModule("dashboard.reducer","ModuleScript","Orca.store.reducers.dashboard.reducer","Orca.store.reducers",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.include.RuntimeLib)local ib=a.import(script,a.getModule(script,"@rbxts","rodux").src)local ai=a.import(script,script.Parent.Parent,"models","dashboard.model").DashboardPage;local dz={page=ai.Home,isOpen=false,hint=nil,apps={playerSelected=nil}}local ik=ib.createReducer(dz,{["dashboard/setDashboardPage"]=function(F,aR)local as={}for av,aw in pairs(F)do as[av]=aw end;as.page=aR.page;return as end,["dashboard/toggleDashboard"]=function(F)local as={}for av,aw in pairs(F)do as[av]=aw end;as.isOpen=not F.isOpen;return as end,["dashboard/setHint"]=function(F,aR)local as={}for av,aw in pairs(F)do as[av]=aw end;as.hint=aR.hint;return as end,["dashboard/clearHint"]=function(F)local as={}for av,aw in pairs(F)do as[av]=aw end;as.hint=nil;return as end,["dashboard/playerSelected"]=function(F,aR)local as={}for av,aw in pairs(F)do as[av]=aw end;local at="apps"local au={}for av,aw in pairs(F.apps)do au[av]=aw end;au.playerSelected=aR.name;as[at]=au;return as end,["dashboard/playerDeselected"]=function(F)local as={}for av,aw in pairs(F)do as[av]=aw end;local at="apps"local au={}for av,aw in pairs(F.apps)do au[av]=aw end;au.playerSelected=nil;as[at]=au;return as end})return{dashboardReducer=ik}end,newEnv("Orca.store.reducers.dashboard.reducer"))()end)newModule("jobs.reducer","ModuleScript","Orca.store.reducers.jobs.reducer","Orca.store.reducers",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.include.RuntimeLib)local ib=a.import(script,a.getModule(script,"@rbxts","rodux").src)local dz={flight={value=60,active=false},walkSpeed={value=80,active=false},jumpHeight={value=200,active=false},refresh={active=false},ghost={active=false},godmode={active=false},freecam={active=false},teleport={active=false},hide={active=false},kill={active=false},spectate={active=false},rejoinServer={active=false},switchServer={active=false}}local il=ib.createReducer(dz,{["jobs/setJobActive"]=function(F,aR)local as={}for av,aw in pairs(F)do as[av]=aw end;local at=aR.jobName;local au={}for av,aw in pairs(F[aR.jobName])do au[av]=aw end;au.active=aR.active;as[at]=au;return as end,["jobs/setJobValue"]=function(F,aR)local as={}for av,aw in pairs(F)do as[av]=aw end;local at=aR.jobName;local au={}for av,aw in pairs(F[aR.jobName])do au[av]=aw end;au.value=aR.value;as[at]=au;return as end})return{jobsReducer=il}end,newEnv("Orca.store.reducers.jobs.reducer"))()end)newModule("options.reducer","ModuleScript","Orca.store.reducers.options.reducer","Orca.store.reducers",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.include.RuntimeLib)local ib=a.import(script,a.getModule(script,"@rbxts","rodux").src)local dz={acrylicBlurEnabled=true}local im=ib.createReducer(dz,{["options/setAcrylicBlurEnabled"]=function(F,aR)local as={}for av,aw in pairs(F)do as[av]=aw end;as.acrylicBlurEnabled=aR.active;return as end})return{optionsReducer=im}end,newEnv("Orca.store.reducers.options.reducer"))()end)newModule("theme.reducer","ModuleScript","Orca.store.reducers.theme.reducer","Orca.store.reducers",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.include.RuntimeLib)local ib=a.import(script,a.getModule(script,"@rbxts","rodux").src)local io=a.import(script,script.Parent.Parent.Parent,"themes","sorbet").sorbet;local dz={current=io}local ip=ib.createReducer(dz,{["theme/setTheme"]=function(F,aR)local as={}for av,aw in pairs(F)do as[av]=aw end;as.current=aR.theme;return as end})return{themeReducer=ip}end,newEnv("Orca.store.reducers.theme.reducer"))()end)newModule("store","ModuleScript","Orca.store.store","Orca.store",function()return setfenv(function()local a=require(script.Parent.Parent.include.RuntimeLib)local ib=a.import(script,a.getModule(script,"@rbxts","rodux").src)local ik=a.import(script,script.Parent,"reducers","dashboard.reducer").dashboardReducer;local il=a.import(script,script.Parent,"reducers","jobs.reducer").jobsReducer;local im=a.import(script,script.Parent,"reducers","options.reducer").optionsReducer;local ip=a.import(script,script.Parent,"reducers","theme.reducer").themeReducer;local iq=ib.combineReducers({dashboard=ik,jobs=il,theme=ip,options=im})local function aj(dz)return ib.Store.new(iq,dz)end;return{configureStore=aj}end,newEnv("Orca.store.store"))()end)newModule("themes","ModuleScript","Orca.themes","Orca",function()return setfenv(function()local a=require(script.Parent.include.RuntimeLib)local ir=a.import(script,script,"dark-theme").darkTheme;local is=a.import(script,script,"frosted-glass").frostedGlass;local it=a.import(script,script,"high-contrast").highContrast;local iu=a.import(script,script,"light-theme").lightTheme;local iv=a.import(script,script,"obsidian").obsidian;local io=a.import(script,script,"sorbet").sorbet;local iw={io,ir,iu,is,iv,it}local function ix()return iw end;return{getThemes=ix}end,newEnv("Orca.themes"))()end)newModule("dark-theme","ModuleScript","Orca.themes.dark-theme","Orca.themes",function()return setfenv(function()local a=require(script.Parent.Parent.include.RuntimeLib)local ak=a.import(script,script.Parent.Parent,"utils","color3").hex;local ir={name="Dark theme",preview={foreground={color=ColorSequence.new(ak("#ffffff"))},background={color=ColorSequence.new(ak("#232428"))},accent={color=ColorSequence.new({ColorSequenceKeypoint.new(0,ak("#F6BD29")),ColorSequenceKeypoint.new(0.5,ak("#F64229")),ColorSequenceKeypoint.new(1,ak("#9029F6"))}),rotation=25}},navbar={outlined=true,acrylic=false,foreground=ak("#ffffff"),background=ak("#232428"),transparency=0,accentGradient={color=ColorSequence.new({ColorSequenceKeypoint.new(0,ak("#f629c6")),ColorSequenceKeypoint.new(0.25,ak("#F64229")),ColorSequenceKeypoint.new(0.5,ak("#ffd42a")),ColorSequenceKeypoint.new(0.75,ak("#37CC95")),ColorSequenceKeypoint.new(1,ak("#3789cc"))})},dropshadow=ak("#232428"),dropshadowTransparency=0.3,glowTransparency=0},clock={outlined=true,acrylic=false,foreground=ak("#ffffff"),background=ak("#232428"),transparency=0,dropshadow=ak("#232428"),dropshadowTransparency=0.3},home={title={outlined=true,acrylic=false,foreground=ak("#ffffff"),background=ak("#ffffff"),backgroundGradient={color=ColorSequence.new({ColorSequenceKeypoint.new(0,ak("#F6BD29")),ColorSequenceKeypoint.new(0.5,ak("#F64229")),ColorSequenceKeypoint.new(1,ak("#9029F6"))}),rotation=25},transparency=0,dropshadow=ak("#ffffff"),dropshadowGradient={color=ColorSequence.new({ColorSequenceKeypoint.new(0,ak("#F6BD29")),ColorSequenceKeypoint.new(0.5,ak("#F64229")),ColorSequenceKeypoint.new(1,ak("#9029F6"))}),rotation=25},dropshadowTransparency=0.3},profile={outlined=true,acrylic=false,foreground=ak("#ffffff"),background=ak("#232428"),transparency=0,dropshadow=ak("#232428"),dropshadowTransparency=0.3,avatar={background=ak("#1B1C20"),gradient={color=ColorSequence.new({ColorSequenceKeypoint.new(0,ak("#F6BD29")),ColorSequenceKeypoint.new(0.5,ak("#F64229")),ColorSequenceKeypoint.new(1,ak("#9029F6"))}),rotation=25},transparency=0},button={outlined=true,foreground=ak("#ffffff"),foregroundTransparency=0.5,background=ak("#1B1C20"),backgroundTransparency=0},slider={outlined=true,foreground=ak("#ffffff"),foregroundTransparency=0,background=ak("#1B1C20"),backgroundTransparency=0},highlight={flight=ak("#a22df0"),walkSpeed=ak("#EC423D"),jumpHeight=ak("#37CC95"),refresh=ak("#a22df0"),ghost=ak("#FF4040"),godmode=ak("#f09c2d"),freecam=ak("#37CC95")}},server={outlined=true,acrylic=false,foreground=ak("#ffffff"),background=ak("#37CC95"),transparency=0,dropshadow=ak("#37CC95"),dropshadowTransparency=0.3,rejoinButton={outlined=true,foreground=ak("#ffffff"),background=ak("#37CC95"),accent=ak("#232428"),foregroundTransparency=0,backgroundTransparency=0},switchButton={outlined=true,foreground=ak("#ffffff"),background=ak("#37CC95"),accent=ak("#232428"),foregroundTransparency=0,backgroundTransparency=0}},friendActivity={outlined=true,acrylic=false,foreground=ak("#ffffff"),background=ak("#232428"),transparency=0,dropshadow=ak("#232428"),dropshadowTransparency=0.3,friendButton={outlined=true,accent=ak("#37CC95"),foreground=ak("#ffffff"),foregroundTransparency=0,background=ak("#1B1C20"),backgroundTransparency=0,dropshadow=ak("#000000"),dropshadowTransparency=0.4,glowTransparency=0.6}}},apps={players={outlined=true,acrylic=false,foreground=ak("#ffffff"),background=ak("#232428"),transparency=0,dropshadow=ak("#232428"),dropshadowTransparency=0.3,avatar={background=ak("#1B1C20"),gradient={color=ColorSequence.new({ColorSequenceKeypoint.new(0,ak("#37CC95")),ColorSequenceKeypoint.new(1,ak("#37CC95"))}),rotation=25},transparency=0},button={outlined=true,foreground=ak("#ffffff"),foregroundTransparency=0.5,background=ak("#1B1C20"),backgroundTransparency=0},highlight={teleport=ak("#37CC95"),hide=ak("#f09c2d"),kill=ak("#EC423D"),spectate=ak("#a22df0")},playerButton={outlined=true,accent=ak("#37CC95"),foreground=ak("#ffffff"),foregroundTransparency=0.5,background=ak("#1B1C20"),backgroundTransparency=0,dropshadow=ak("#000000"),dropshadowTransparency=0.5,glowTransparency=0.2}}},options={themes={outlined=true,acrylic=false,foreground=ak("#ffffff"),background=ak("#232428"),transparency=0,dropshadow=ak("#232428"),dropshadowTransparency=0.3,themeButton={outlined=true,accent=ak("#37a4cc"),foreground=ak("#ffffff"),foregroundTransparency=0.5,background=ak("#1B1C20"),backgroundTransparency=0,dropshadow=ak("#000000"),dropshadowTransparency=0.5,glowTransparency=0.2}}}}return{darkTheme=ir}end,newEnv("Orca.themes.dark-theme"))()end)newModule("frosted-glass","ModuleScript","Orca.themes.frosted-glass","Orca.themes",function()return setfenv(function()local a=require(script.Parent.Parent.include.RuntimeLib)local ir=a.import(script,script.Parent,"dark-theme").darkTheme;local ak=a.import(script,script.Parent.Parent,"utils","color3").hex;local a_=ak("#000000")local iy=ColorSequence.new(ak("#000000"))local iz={acrylic=true,outlined=true,foreground=ak("#ffffff"),background=ak("#ffffff"),backgroundGradient=nil,transparency=0.9,dropshadow=ak("#ffffff"),dropshadowTransparency=0,dropshadowGradient={color=ColorSequence.new(ak("#000000")),transparency=NumberSequence.new(1,0.8),rotation=90}}local as={}for av,aw in pairs(ir)do as[av]=aw end;as.name="Frosted glass"as.preview={foreground={color=ColorSequence.new(ak("#ffffff"))},background={color=ColorSequence.new(ak("#ffffff"))},accent={color=iy}}local at="navbar"local au={}for av,aw in pairs(ir.navbar)do au[av]=aw end;au.outlined=true;au.acrylic=true;au.foreground=ak("#ffffff")au.background=ak("#ffffff")au.backgroundGradient=nil;au.transparency=0.9;au.dropshadow=ak("#000000")au.dropshadowTransparency=0.2;au.accentGradient={color=ColorSequence.new(ak("#ffffff")),transparency=NumberSequence.new(0.8),rotation=90}au.glowTransparency=0.5;as[at]=au;as.clock={outlined=true,acrylic=true,foreground=ak("#ffffff"),background=ak("#ffffff"),backgroundGradient=nil,transparency=0.9,dropshadow=ak("#000000"),dropshadowTransparency=0.2}local iA="home"local ay={}local iB="title"local aA={}for av,aw in pairs(iz)do aA[av]=aw end;ay[iB]=aA;local iC="profile"local aC={}for av,aw in pairs(iz)do aC[av]=aw end;local iD="avatar"local aE={}for av,aw in pairs(ir.home.profile.avatar)do aE[av]=aw end;aE.background=ak("#ffffff")aE.transparency=0.7;aE.gradient={color=ColorSequence.new(ak("#ffffff"),ak("#ffffff")),transparency=NumberSequence.new(0.5,1),rotation=45}aC[iD]=aE;aC.highlight={flight=a_,walkSpeed=a_,jumpHeight=a_,refresh=a_,ghost=a_,godmode=a_,freecam=a_}local iE="slider"local aG={}for av,aw in pairs(ir.home.profile.slider)do aG[av]=aw end;aG.outlined=false;aG.foreground=ak("#ffffff")aG.background=ak("#ffffff")aG.backgroundTransparency=0.8;aG.indicatorTransparency=0.3;aC[iE]=aG;local iF="button"local iG={}for av,aw in pairs(ir.home.profile.button)do iG[av]=aw end;iG.outlined=false;iG.foreground=ak("#ffffff")iG.background=ak("#ffffff")iG.backgroundTransparency=0.8;aC[iF]=iG;ay[iC]=aC;local iH="server"local iI={}for av,aw in pairs(iz)do iI[av]=aw end;local iJ="rejoinButton"local iK={}for av,aw in pairs(ir.home.server.rejoinButton)do iK[av]=aw end;iK.outlined=false;iK.foreground=ak("#ffffff")iK.background=ak("#ffffff")iK.foregroundTransparency=0.5;iK.backgroundTransparency=0.8;iK.accent=a_;iI[iJ]=iK;local iL="switchButton"local iM={}for av,aw in pairs(ir.home.server.switchButton)do iM[av]=aw end;iM.outlined=false;iM.foreground=ak("#ffffff")iM.background=ak("#ffffff")iM.foregroundTransparency=0.5;iM.backgroundTransparency=0.8;iM.accent=a_;iI[iL]=iM;ay[iH]=iI;local iN="friendActivity"local iO={}for av,aw in pairs(iz)do iO[av]=aw end;local iP="friendButton"local iQ={}for av,aw in pairs(ir.home.friendActivity.friendButton)do iQ[av]=aw end;iQ.outlined=false;iQ.foreground=ak("#ffffff")iQ.background=ak("#ffffff")iQ.dropshadow=ak("#ffffff")iQ.backgroundTransparency=0.7;iO[iP]=iQ;ay[iN]=iO;as[iA]=ay;local iR="apps"local iS={}local iT="players"local iU={}for av,aw in pairs(iz)do iU[av]=aw end;iU.highlight={teleport=a_,hide=a_,kill=a_,spectate=a_}local iV="avatar"local iW={}for av,aw in pairs(ir.apps.players.avatar)do iW[av]=aw end;iW.background=ak("#ffffff")iW.transparency=0.7;iW.gradient={color=ColorSequence.new(ak("#ffffff"),ak("#ffffff")),transparency=NumberSequence.new(0.5,1),rotation=45}iU[iV]=iW;local iX="button"local iY={}for av,aw in pairs(ir.apps.players.button)do iY[av]=aw end;iY.outlined=false;iY.foreground=ak("#ffffff")iY.background=ak("#ffffff")iY.backgroundTransparency=0.8;iU[iX]=iY;local iZ="playerButton"local i_={}for av,aw in pairs(ir.apps.players.playerButton)do i_[av]=aw end;i_.outlined=false;i_.foreground=ak("#ffffff")i_.background=ak("#ffffff")i_.dropshadow=ak("#ffffff")i_.accent=a_;i_.backgroundTransparency=0.8;i_.dropshadowTransparency=0.7;iU[iZ]=i_;iS[iT]=iU;as[iR]=iS;local j0="options"local j1={}local j2="themes"local j3={}for av,aw in pairs(iz)do j3[av]=aw end;local j4="themeButton"local j5={}for av,aw in pairs(ir.options.themes.themeButton)do j5[av]=aw end;j5.outlined=false;j5.foreground=ak("#ffffff")j5.background=ak("#ffffff")j5.dropshadow=ak("#ffffff")j5.accent=a_;j5.backgroundTransparency=0.8;j5.dropshadowTransparency=0.7;j3[j4]=j5;j1[j2]=j3;as[j0]=j1;local is=as;return{frostedGlass=is}end,newEnv("Orca.themes.frosted-glass"))()end)newModule("high-contrast","ModuleScript","Orca.themes.high-contrast","Orca.themes",function()return setfenv(function()local a=require(script.Parent.Parent.include.RuntimeLib)local ir=a.import(script,script.Parent,"dark-theme").darkTheme;local ak=a.import(script,script.Parent.Parent,"utils","color3").hex;local as={}for av,aw in pairs(ir)do as[av]=aw end;as.name="High contrast"as.preview={foreground={color=ColorSequence.new(ak("#ffffff"))},background={color=ColorSequence.new(ak("#000000"))},accent={color=ColorSequence.new({ColorSequenceKeypoint.new(0,ak("#F6BD29")),ColorSequenceKeypoint.new(0.5,ak("#F64229")),ColorSequenceKeypoint.new(1,ak("#9029F6"))}),rotation=25}}local at="navbar"local au={}for av,aw in pairs(ir.navbar)do au[av]=aw end;au.foreground=ak("#ffffff")au.background=ak("#000000")au.dropshadow=ak("#000000")as[at]=au;local iA="clock"local ay={}for av,aw in pairs(ir.clock)do ay[av]=aw end;ay.foreground=ak("#ffffff")ay.background=ak("#000000")ay.dropshadow=ak("#000000")as[iA]=ay;local iB="home"local aA={}local iC="title"local aC={}for av,aw in pairs(ir.home.title)do aC[av]=aw end;aC.foreground=ak("#ffffff")aC.background=ak("#000000")aC.dropshadow=ak("#000000")aA[iC]=aC;local iD="profile"local aE={}for av,aw in pairs(ir.home.profile)do aE[av]=aw end;aE.foreground=ak("#ffffff")aE.background=ak("#000000")aE.dropshadow=ak("#000000")local iE="avatar"local aG={}for av,aw in pairs(ir.home.profile.avatar)do aG[av]=aw end;aG.background=ak("#ffffff")aG.transparency=0.9;aG.gradient={color=ColorSequence.new({ColorSequenceKeypoint.new(0,ak("#F6BD29")),ColorSequenceKeypoint.new(0.5,ak("#F64229")),ColorSequenceKeypoint.new(1,ak("#9029F6"))})}aE[iE]=aG;local iF="slider"local iG={}for av,aw in pairs(ir.home.profile.slider)do iG[av]=aw end;iG.foreground=ak("#ffffff")iG.background=ak("#000000")aE[iF]=iG;local iH="button"local iI={}for av,aw in pairs(ir.home.profile.button)do iI[av]=aw end;iI.foreground=ak("#ffffff")iI.background=ak("#000000")aE[iH]=iI;aA[iD]=aE;local iJ="server"local iK={}for av,aw in pairs(ir.home.server)do iK[av]=aw end;iK.foreground=ak("#ffffff")iK.background=ak("#000000")iK.dropshadow=ak("#000000")local iL="rejoinButton"local iM={}for av,aw in pairs(ir.home.server.rejoinButton)do iM[av]=aw end;iM.foreground=ak("#ffffff")iM.background=ak("#000000")iM.foregroundTransparency=0.5;iM.accent=ak("#ff3f6c")iK[iL]=iM;local iN="switchButton"local iO={}for av,aw in pairs(ir.home.server.switchButton)do iO[av]=aw end;iO.foreground=ak("#ffffff")iO.background=ak("#000000")iO.foregroundTransparency=0.5;iO.accent=ak("#ff3f6c")iK[iN]=iO;aA[iJ]=iK;local iP="friendActivity"local iQ={}for av,aw in pairs(ir.home.friendActivity)do iQ[av]=aw end;iQ.foreground=ak("#ffffff")iQ.background=ak("#000000")iQ.dropshadow=ak("#000000")local iR="friendButton"local iS={}for av,aw in pairs(ir.home.friendActivity.friendButton)do iS[av]=aw end;iS.foreground=ak("#ffffff")iS.background=ak("#000000")iQ[iR]=iS;aA[iP]=iQ;as[iB]=aA;local iT="apps"local iU={}local iV="players"local iW={}for av,aw in pairs(ir.apps.players)do iW[av]=aw end;iW.foreground=ak("#ffffff")iW.background=ak("#000000")iW.dropshadow=ak("#000000")local iX="avatar"local iY={}for av,aw in pairs(ir.apps.players.avatar)do iY[av]=aw end;iY.background=ak("#ffffff")iY.transparency=0.9;iY.gradient={color=ColorSequence.new({ColorSequenceKeypoint.new(0,ak("#F6BD29")),ColorSequenceKeypoint.new(0.5,ak("#F64229")),ColorSequenceKeypoint.new(1,ak("#9029F6"))})}iW[iX]=iY;local iZ="button"local i_={}for av,aw in pairs(ir.apps.players.button)do i_[av]=aw end;i_.foreground=ak("#ffffff")i_.background=ak("#000000")iW[iZ]=i_;local j0="playerButton"local j1={}for av,aw in pairs(ir.apps.players.playerButton)do j1[av]=aw end;j1.foreground=ak("#ffffff")j1.background=ak("#000000")j1.accent=ak("#ff3f6c")j1.dropshadowTransparency=0.7;iW[j0]=j1;iU[iV]=iW;as[iT]=iU;local j2="options"local j3={}local j4="themes"local j5={}for av,aw in pairs(ir.options.themes)do j5[av]=aw end;j5.foreground=ak("#ffffff")j5.background=ak("#000000")j5.dropshadow=ak("#000000")local j6="themeButton"local j7={}for av,aw in pairs(ir.options.themes.themeButton)do j7[av]=aw end;j7.foreground=ak("#ffffff")j7.background=ak("#000000")j7.accent=ak("#ff3f6c")j7.dropshadowTransparency=0.7;j5[j6]=j7;j3[j4]=j5;as[j2]=j3;local it=as;return{highContrast=it}end,newEnv("Orca.themes.high-contrast"))()end)newModule("light-theme","ModuleScript","Orca.themes.light-theme","Orca.themes",function()return setfenv(function()local a=require(script.Parent.Parent.include.RuntimeLib)local ir=a.import(script,script.Parent,"dark-theme").darkTheme;local ak=a.import(script,script.Parent.Parent,"utils","color3").hex;local as={}for av,aw in pairs(ir)do as[av]=aw end;as.name="Light theme"as.preview={foreground={color=ColorSequence.new(ak("#000000"))},background={color=ColorSequence.new(ak("#ffffff"))},accent={color=ColorSequence.new({ColorSequenceKeypoint.new(0,ak("#F6BD29")),ColorSequenceKeypoint.new(0.5,ak("#F64229")),ColorSequenceKeypoint.new(1,ak("#9029F6"))}),rotation=25}}local at="navbar"local au={}for av,aw in pairs(ir.navbar)do au[av]=aw end;au.foreground=ak("#000000")au.background=ak("#ffffff")as[at]=au;local iA="clock"local ay={}for av,aw in pairs(ir.clock)do ay[av]=aw end;ay.foreground=ak("#000000")ay.background=ak("#ffffff")as[iA]=ay;local iB="home"local aA={}local iC="title"local aC={}for av,aw in pairs(ir.home.title)do aC[av]=aw end;aC.foreground=ak("#000000")aC.background=ak("#ffffff")aA[iC]=aC;local iD="profile"local aE={}for av,aw in pairs(ir.home.profile)do aE[av]=aw end;aE.foreground=ak("#000000")aE.background=ak("#ffffff")local iE="avatar"local aG={}for av,aw in pairs(ir.home.profile.avatar)do aG[av]=aw end;aG.background=ak("#000000")aG.transparency=0.9;aG.gradient={color=ColorSequence.new(ak("#3ce09b"))}aE[iE]=aG;local iF="slider"local iG={}for av,aw in pairs(ir.home.profile.slider)do iG[av]=aw end;iG.foreground=ak("#000000")iG.background=ak("#ffffff")aE[iF]=iG;local iH="button"local iI={}for av,aw in pairs(ir.home.profile.button)do iI[av]=aw end;iI.foreground=ak("#000000")iI.background=ak("#ffffff")aE[iH]=iI;aA[iD]=aE;local iJ="server"local iK={}for av,aw in pairs(ir.home.server)do iK[av]=aw end;iK.foreground=ak("#000000")iK.background=ak("#ff3f6c")iK.dropshadow=ak("#ff3f6c")local iL="rejoinButton"local iM={}for av,aw in pairs(ir.home.server.rejoinButton)do iM[av]=aw end;iM.foreground=ak("#000000")iM.background=ak("#ff3f6c")iM.accent=ak("#ffffff")iK[iL]=iM;local iN="switchButton"local iO={}for av,aw in pairs(ir.home.server.switchButton)do iO[av]=aw end;iO.foreground=ak("#000000")iO.background=ak("#ff3f6c")iO.accent=ak("#ffffff")iK[iN]=iO;aA[iJ]=iK;local iP="friendActivity"local iQ={}for av,aw in pairs(ir.home.friendActivity)do iQ[av]=aw end;iQ.foreground=ak("#000000")iQ.background=ak("#ffffff")local iR="friendButton"local iS={}for av,aw in pairs(ir.home.friendActivity.friendButton)do iS[av]=aw end;iS.foreground=ak("#ffffff")iS.background=ak("#ffffff")iQ[iR]=iS;aA[iP]=iQ;as[iB]=aA;local iT="apps"local iU={}local iV="players"local iW={}for av,aw in pairs(ir.apps.players)do iW[av]=aw end;iW.foreground=ak("#000000")iW.background=ak("#ffffff")local iX="avatar"local iY={}for av,aw in pairs(ir.apps.players.avatar)do iY[av]=aw end;iY.background=ak("#000000")iY.transparency=0.9;iY.gradient={color=ColorSequence.new(ak("#3ce09b"))}iW[iX]=iY;local iZ="button"local i_={}for av,aw in pairs(ir.apps.players.button)do i_[av]=aw end;i_.foreground=ak("#000000")i_.background=ak("#ffffff")iW[iZ]=i_;local j0="playerButton"local j1={}for av,aw in pairs(ir.apps.players.playerButton)do j1[av]=aw end;j1.foreground=ak("#000000")j1.background=ak("#ffffff")j1.backgroundHovered=ak("#eeeeee")j1.accent=ak("#3ce09b")j1.dropshadowTransparency=0.7;iW[j0]=j1;iU[iV]=iW;as[iT]=iU;local j2="options"local j3={}local j4="themes"local j5={}for av,aw in pairs(ir.options.themes)do j5[av]=aw end;j5.foreground=ak("#000000")j5.background=ak("#ffffff")local j6="themeButton"local j7={}for av,aw in pairs(ir.options.themes.themeButton)do j7[av]=aw end;j7.foreground=ak("#000000")j7.background=ak("#ffffff")j7.backgroundHovered=ak("#eeeeee")j7.accent=ak("#3ce09b")j7.dropshadowTransparency=0.7;j5[j6]=j7;j3[j4]=j5;as[j2]=j3;local iu=as;return{lightTheme=iu}end,newEnv("Orca.themes.light-theme"))()end)newModule("obsidian","ModuleScript","Orca.themes.obsidian","Orca.themes",function()return setfenv(function()local a=require(script.Parent.Parent.include.RuntimeLib)local ir=a.import(script,script.Parent,"dark-theme").darkTheme;local ak=a.import(script,script.Parent.Parent,"utils","color3").hex;local a_=ak("#9029F6")local iy=ColorSequence.new(ak("#9029F6"))local as={}for av,aw in pairs(ir)do as[av]=aw end;as.name="Obsidian"as.preview={foreground={color=ColorSequence.new(ak("#ffffff"))},background={color=ColorSequence.new(ak("#000000"))},accent={color=iy}}local at="navbar"local au={}for av,aw in pairs(ir.navbar)do au[av]=aw end;au.acrylic=true;au.outlined=false;au.foreground=ak("#ffffff")au.background=ak("#000000")au.dropshadow=ak("#000000")au.transparency=0.7;au.accentGradient={color=iy,transparency=NumberSequence.new(0.5)}as[at]=au;local iA="clock"local ay={}for av,aw in pairs(ir.clock)do ay[av]=aw end;ay.acrylic=true;ay.outlined=false;ay.foreground=ak("#ffffff")ay.background=ak("#000000")ay.dropshadow=ak("#000000")ay.transparency=0.7;as[iA]=ay;local iB="home"local aA={}local iC="title"local aC={}for av,aw in pairs(ir.home.title)do aC[av]=aw end;aC.acrylic=true;aC.outlined=false;aC.foreground=ak("#ffffff")aC.background=ak("#000000")aC.dropshadow=ak("#000000")aC.transparency=0.7;aC.dropshadowTransparency=0.65;aA[iC]=aC;local iD="profile"local aE={}for av,aw in pairs(ir.home.profile)do aE[av]=aw end;aE.acrylic=true;aE.outlined=false;aE.foreground=ak("#ffffff")aE.background=ak("#000000")aE.dropshadow=ak("#000000")aE.transparency=0.7;aE.dropshadowTransparency=0.65;local iE="avatar"local aG={}for av,aw in pairs(ir.home.profile.avatar)do aG[av]=aw end;aG.background=ak("#000000")aG.transparency=0.7;aG.gradient={color=iy}aE[iE]=aG;aE.highlight={flight=a_,walkSpeed=a_,jumpHeight=a_,refresh=a_,ghost=a_,godmode=a_,freecam=a_}local iF="slider"local iG={}for av,aw in pairs(ir.home.profile.slider)do iG[av]=aw end;iG.outlined=false;iG.foreground=ak("#ffffff")iG.background=ak("#000000")iG.backgroundTransparency=0.5;iG.indicatorTransparency=0.5;aE[iF]=iG;local iH="button"local iI={}for av,aw in pairs(ir.home.profile.button)do iI[av]=aw end;iI.outlined=false;iI.foreground=ak("#ffffff")iI.background=ak("#000000")iI.backgroundTransparency=0.5;aE[iH]=iI;aA[iD]=aE;local iJ="server"local iK={}for av,aw in pairs(ir.home.server)do iK[av]=aw end;iK.acrylic=true;iK.outlined=false;iK.foreground=ak("#ffffff")iK.background=ak("#000000")iK.dropshadow=ak("#000000")iK.transparency=0.7;iK.dropshadowTransparency=0.65;local iL="rejoinButton"local iM={}for av,aw in pairs(ir.home.server.rejoinButton)do iM[av]=aw end;iM.outlined=false;iM.foreground=ak("#ffffff")iM.background=ak("#000000")iM.backgroundTransparency=0.5;iM.foregroundTransparency=0.5;iM.accent=a_;iK[iL]=iM;local iN="switchButton"local iO={}for av,aw in pairs(ir.home.server.switchButton)do iO[av]=aw end;iO.outlined=false;iO.foreground=ak("#ffffff")iO.background=ak("#000000")iO.backgroundTransparency=0.5;iO.foregroundTransparency=0.5;iO.accent=a_;iK[iN]=iO;aA[iJ]=iK;local iP="friendActivity"local iQ={}for av,aw in pairs(ir.home.friendActivity)do iQ[av]=aw end;iQ.acrylic=true;iQ.outlined=false;iQ.foreground=ak("#ffffff")iQ.background=ak("#000000")iQ.dropshadow=ak("#000000")iQ.transparency=0.7;iQ.dropshadowTransparency=0.65;local iR="friendButton"local iS={}for av,aw in pairs(ir.home.friendActivity.friendButton)do iS[av]=aw end;iS.outlined=false;iS.foreground=ak("#ffffff")iS.background=ak("#000000")iS.dropshadow=ak("#000000")iS.backgroundTransparency=0.7;iQ[iR]=iS;aA[iP]=iQ;as[iB]=aA;local iT="apps"local iU={}local iV="players"local iW={}for av,aw in pairs(ir.apps.players)do iW[av]=aw end;iW.acrylic=true;iW.outlined=false;iW.foreground=ak("#ffffff")iW.background=ak("#000000")iW.dropshadow=ak("#000000")iW.transparency=0.7;iW.dropshadowTransparency=0.65;iW.highlight={teleport=a_,hide=a_,kill=a_,spectate=a_}local iX="avatar"local iY={}for av,aw in pairs(ir.apps.players.avatar)do iY[av]=aw end;iY.background=ak("#000000")iY.transparency=0.7;iY.gradient={color=iy}iW[iX]=iY;local iZ="button"local i_={}for av,aw in pairs(ir.apps.players.button)do i_[av]=aw end;i_.outlined=false;i_.foreground=ak("#ffffff")i_.background=ak("#000000")i_.backgroundTransparency=0.5;iW[iZ]=i_;local j0="playerButton"local j1={}for av,aw in pairs(ir.apps.players.playerButton)do j1[av]=aw end;j1.outlined=false;j1.foreground=ak("#ffffff")j1.background=ak("#000000")j1.accent=a_;j1.backgroundTransparency=0.5;j1.dropshadowTransparency=0.7;iW[j0]=j1;iU[iV]=iW;as[iT]=iU;local j2="options"local j3={}local j4="themes"local j5={}for av,aw in pairs(ir.options.themes)do j5[av]=aw end;j5.acrylic=true;j5.outlined=false;j5.foreground=ak("#ffffff")j5.background=ak("#000000")j5.dropshadow=ak("#000000")j5.transparency=0.7;j5.dropshadowTransparency=0.65;local j6="themeButton"local j7={}for av,aw in pairs(ir.options.themes.themeButton)do j7[av]=aw end;j7.outlined=false;j7.foreground=ak("#ffffff")j7.background=ak("#000000")j7.accent=a_;j7.backgroundTransparency=0.5;j7.dropshadowTransparency=0.7;j5[j6]=j7;j3[j4]=j5;as[j2]=j3;local iv=as;return{obsidian=iv}end,newEnv("Orca.themes.obsidian"))()end)newModule("sorbet","ModuleScript","Orca.themes.sorbet","Orca.themes",function()return setfenv(function()local a=require(script.Parent.Parent.include.RuntimeLib)local ir=a.import(script,script.Parent,"dark-theme").darkTheme;local ak=a.import(script,script.Parent.Parent,"utils","color3").hex;local j8=ak("#C6428E")local j9=ak("#484fd7")local ja=ak("#9a3fe5")local iy=ColorSequence.new({ColorSequenceKeypoint.new(0,j8),ColorSequenceKeypoint.new(0.5,ja),ColorSequenceKeypoint.new(1,j9)})local b3=ak("#181818")local jb=ak("#242424")local iz={acrylic=false,outlined=false,foreground=ak("#ffffff"),background=b3,backgroundGradient=nil,transparency=0,dropshadow=b3,dropshadowTransparency=0.3}local as={}for av,aw in pairs(ir)do as[av]=aw end;as.name="Sorbet"as.preview={foreground={color=ColorSequence.new(ak("#ffffff"))},background={color=ColorSequence.new(b3)},accent={color=iy}}local at="navbar"local au={}for av,aw in pairs(ir.navbar)do au[av]=aw end;au.outlined=false;au.background=b3;au.dropshadow=b3;au.accentGradient={color=iy}as[at]=au;local iA="clock"local ay={}for av,aw in pairs(ir.clock)do ay[av]=aw end;ay.outlined=false;ay.background=b3;ay.dropshadow=b3;as[iA]=ay;local iB="home"local aA={}local iC="title"local aC={}for av,aw in pairs(iz)do aC[av]=aw end;aC.background=ak("#ffffff")aC.backgroundGradient={color=iy,rotation=30}aC.dropshadow=ak("#ffffff")aC.dropshadowGradient={color=iy,rotation=30}aA[iC]=aC;local iD="profile"local aE={}for av,aw in pairs(iz)do aE[av]=aw end;local iE="avatar"local aG={}for av,aw in pairs(ir.home.profile.avatar)do aG[av]=aw end;aG.background=jb;aG.transparency=0;aG.gradient={color=iy,rotation=45}aE[iE]=aG;aE.highlight={flight=j8,walkSpeed=ja,jumpHeight=j9,refresh=j8,ghost=j9,godmode=j8,freecam=j9}local iF="slider"local iG={}for av,aw in pairs(ir.home.profile.slider)do iG[av]=aw end;iG.outlined=false;iG.foreground=ak("#ffffff")iG.background=jb;aE[iF]=iG;local iH="button"local iI={}for av,aw in pairs(ir.home.profile.button)do iI[av]=aw end;iI.outlined=false;iI.foreground=ak("#ffffff")iI.background=jb;aE[iH]=iI;aA[iD]=aE;local iJ="server"local iK={}for av,aw in pairs(iz)do iK[av]=aw end;local iL="rejoinButton"local iM={}for av,aw in pairs(ir.home.server.rejoinButton)do iM[av]=aw end;iM.outlined=false;iM.foreground=ak("#ffffff")iM.background=jb;iM.foregroundTransparency=0.5;iM.accent=j8;iK[iL]=iM;local iN="switchButton"local iO={}for av,aw in pairs(ir.home.server.switchButton)do iO[av]=aw end;iO.outlined=false;iO.foreground=ak("#ffffff")iO.background=jb;iO.foregroundTransparency=0.5;iO.accent=j9;iK[iN]=iO;aA[iJ]=iK;local iP="friendActivity"local iQ={}for av,aw in pairs(iz)do iQ[av]=aw end;local iR="friendButton"local iS={}for av,aw in pairs(ir.home.friendActivity.friendButton)do iS[av]=aw end;iS.outlined=false;iS.foreground=ak("#ffffff")iS.background=jb;iQ[iR]=iS;aA[iP]=iQ;as[iB]=aA;local iT="apps"local iU={}local iV="players"local iW={}for av,aw in pairs(iz)do iW[av]=aw end;iW.highlight={teleport=j8,hide=j9,kill=j8,spectate=j9}local iX="avatar"local iY={}for av,aw in pairs(ir.apps.players.avatar)do iY[av]=aw end;iY.background=jb;iY.transparency=0;iY.gradient={color=iy,rotation=45}iW[iX]=iY;local iZ="button"local i_={}for av,aw in pairs(ir.apps.players.button)do i_[av]=aw end;i_.outlined=false;i_.foreground=ak("#ffffff")i_.background=jb;iW[iZ]=i_;local j0="playerButton"local j1={}for av,aw in pairs(ir.apps.players.playerButton)do j1[av]=aw end;j1.outlined=false;j1.foreground=ak("#ffffff")j1.background=jb;j1.dropshadow=jb;j1.accent=j9;iW[j0]=j1;iU[iV]=iW;as[iT]=iU;local j2="options"local j3={}local j4="themes"local j5={}for av,aw in pairs(iz)do j5[av]=aw end;local j6="themeButton"local j7={}for av,aw in pairs(ir.options.themes.themeButton)do j7[av]=aw end;j7.outlined=false;j7.foreground=ak("#ffffff")j7.background=jb;j7.dropshadow=jb;j7.accent=j9;j5[j6]=j7;j3[j4]=j5;as[j2]=j3;local io=as;return{sorbet=io}end,newEnv("Orca.themes.sorbet"))()end)newModule("theme.interface","ModuleScript","Orca.themes.theme.interface","Orca.themes",function()return setfenv(function()end,newEnv("Orca.themes.theme.interface"))()end)newInstance("utils","Folder","Orca.utils","Orca")newModule("array-util","ModuleScript","Orca.utils.array-util","Orca.utils",function()return setfenv(function()local function jc(jd,je)local d_=table.create(#jd)for av,aw in ipairs(jd)do d_[av]=je(aw,av-1,jd)end;local jf={}for c_,aw in ipairs(d_)do jf[aw[1]]=aw[2]end;return jf end;return{arrayToMap=jc}end,newEnv("Orca.utils.array-util"))()end)newModule("binding-util","ModuleScript","Orca.utils.binding-util","Orca.utils",function()return setfenv(function()local a=require(script.Parent.Parent.include.RuntimeLib)local b=a.import(script,a.getModule(script,"@rbxts","roact").src)local function jg(cC)return type(cC)=="table"and cC.getValue~=nil end;local function b7(d1,jh)return jg(d1)and d1:map(jh)or b.createBinding(jh(d1))end;local function b6(d1)return jg(d1)and d1 or b.createBinding(d1)end;return{isBinding=jg,mapBinding=b7,asBinding=b6}end,newEnv("Orca.utils.binding-util"))()end)newModule("color3","ModuleScript","Orca.utils.color3","Orca.utils",function()return setfenv(function()local function ji(b9)if typeof(b9)=="ColorSequence"then b9=b9.Keypoints[1].Value end;return b9.R*0.2126+b9.G*0.7152+b9.B*0.0722 end;local function jj(jk,bN)local c2=math.floor(bN*(#jk.Keypoints-1))local jl=math.min(c2+1,#jk.Keypoints-1)local b2=jk.Keypoints[c2+1]if b2==nil then b2=jk.Keypoints[1]end;local jm=b2;local jn=jk.Keypoints[jl+1]if jn==nil then jn=jm end;local jo=jn;return jm.Value:Lerp(jo.Value,bN*(#jk.Keypoints-1)-c2)end;local jp=function(ak)local jq=string.gsub(ak,"#","0x",1)local b2=tonumber(jq)if b2==nil then b2=0 end;return b2 end;local jr=function(js)return Color3.fromRGB(math.floor(js/65536)%256,math.floor(js/256)%256,js%256)end;local ak=function(ak)return jr(jp(ak))end;local jt=function(cb,dD,dE)return Color3.fromRGB(cb,dD,dE)end;local ju=function(jv,bd,bM)return Color3.fromHSV(jv/360,bd/100,bM/100)end;local jw=function(jv,bd,jx)local jy=bd*(jx<50 and jx or 100-jx)/100;local jz=jy==0 and 0 or 2*jy/(jx+jy)*100;local jA=jx+jy;return Color3.fromHSV(jv/255,jz/100,jA/100)end;return{getLuminance=ji,getColorInSequence=jj,hex=ak,rgb=jt,hsv=ju,hsl=jw}end,newEnv("Orca.utils.color3"))()end)newModule("debug","ModuleScript","Orca.utils.debug","Orca.utils",function()return setfenv(function()local jB=os.clock()local jC="clock"local jD={}local function jE(hf)local b2=jD[hf]if b2==nil then b2=0 end;jD[hf]=b2+1;jC=hf;jB=os.clock()end;local function jF()local jG=os.clock()-jB;local b2=jD[jC]if b2==nil then b2=0 end;local hJ=b2;print("\n["..jC.." "..tostring(hJ).."]\n"..tostring(jG*1000).." ms\n\n")end;return{startTimer=jE,endTimer=jF}end,newEnv("Orca.utils.debug"))()end)newModule("http","ModuleScript","Orca.utils.http","Orca.utils",function()return setfenv(function()local a=require(script.Parent.Parent.include.RuntimeLib)local hX=a.import(script,a.getModule(script,"@rbxts","services")).HttpService;local cv=a.import(script,script.Parent.Parent,"constants").IS_DEV;local jH;jH=a.async(function(jI)if cv then return hX:RequestAsync(jI)else local jJ=syn and syn.request or jH;if not jJ then error("request/syn.request is not available")end;return jJ(jI)end end)local jK=a.async(function(jL,jM)return game:HttpGetAsync(jL,jM)end)local jN=a.async(function(jL,hr,jO,jM)return game:HttpPostAsync(jL,hr,jO,jM)end)return{request=jH,get=jK,post=jN}end,newEnv("Orca.utils.http"))()end)newModule("number-util","ModuleScript","Orca.utils.number-util","Orca.utils",function()return setfenv(function()local function q(jP,jQ,jR,jS,jT)return jS+(jP-jQ)*(jT-jS)/(jR-jQ)end;local function jU(ho,dE,gG)return ho+(dE-ho)*gG end;return{map=q,lerp=jU}end,newEnv("Orca.utils.number-util"))()end)newModule("timeout","ModuleScript","Orca.utils.timeout","Orca.utils",function()return setfenv(function()local a=require(script.Parent.Parent.include.RuntimeLib)local en=a.import(script,a.getModule(script,"@rbxts","services")).RunService;local jV;do jV=setmetatable({},{__tostring=function()return"Timeout"end})jV.__index=jV;function jV.new(...)local self=setmetatable({},jV)return self:constructor(...)or self end;function jV:constructor(d8,jW,...)local jX={...}self.running=true;task.delay(jW/1000,function()if self.running then d8(unpack(jX))end end)end;function jV:clear()self.running=false end end;local function cX(d8,jW,...)local jX={...}return jV.new(d8,jW,unpack(jX))end;local function cW(d0)d0:clear()end;local jY;do jY=setmetatable({},{__tostring=function()return"Interval"end})jY.__index=jY;function jY.new(...)local self=setmetatable({},jY)return self:constructor(...)or self end;function jY:constructor(d8,jW,...)local jX={...}self.running=true;task.defer(function()local jB=0;local jZ;jZ=en.Heartbeat:Connect(function(j_)jB=jB+j_;if not self.running then jZ:Disconnect()elseif jB>=jW/1000 then jB=jB-jW/1000;d8(unpack(jX))end end)end)end;function jY:clear()self.running=false end end;local function de(d8,jW,...)local jX={...}return jY.new(d8,jW,unpack(jX))end;local function dd(hk)hk:clear()end;return{setTimeout=cX,clearTimeout=cW,setInterval=de,clearInterval=dd,Timeout=jV,Interval=jY}end,newEnv("Orca.utils.timeout"))()end)newModule("udim2","ModuleScript","Orca.utils.udim2","Orca.utils",function()return setfenv(function()local function am(bU,eD)return UDim2.new(0,bU,0,eD)end;local function r(bU,eD)return UDim2.new(bU,0,eD,0)end;local function ce(L,dG,ck)if ck==nil then ck=1 end;return Vector2.new(dG.X.Offset+dG.X.Scale/ck*L.X,dG.Y.Offset+dG.Y.Scale/ck*L.Y)end;return{px=am,scale=r,applyUDim2=ce}end,newEnv("Orca.utils.udim2"))()end)newInstance("views","Folder","Orca.views","Orca")newModule("Clock","ModuleScript","Orca.views.Clock","Orca.views",function()return setfenv(function()local a=require(script.Parent.Parent.include.RuntimeLib)local g={}g.default=a.import(script,script,"Clock").default;return g end,newEnv("Orca.views.Clock"))()end)newModule("Clock","ModuleScript","Orca.views.Clock.Clock","Orca.views.Clock",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.include.RuntimeLib)local b=a.import(script,a.getModule(script,"@rbxts","roact").src)local h=a.import(script,a.getModule(script,"@rbxts","roact-hooked").out)local i=h.hooked;local k=h.useEffect;local l=h.useMemo;local aH=h.useState;local k0=a.import(script,a.getModule(script,"@rbxts","services")).TextService;local B=a.import(script,script.Parent.Parent.Parent,"components","Acrylic").default;local b8=a.import(script,script.Parent.Parent.Parent,"components","Border").default;local bl=a.import(script,script.Parent.Parent.Parent,"components","Fill").default;local bm=a.import(script,script.Parent.Parent.Parent,"components","Glow")local bn=bm.default;local bo=bm.GlowRadius;local p=a.import(script,script.Parent.Parent.Parent,"hooks","common","rodux-hooks").useAppSelector;local aL=a.import(script,script.Parent.Parent.Parent,"hooks","common","use-spring").useSpring;local e9=a.import(script,script.Parent.Parent.Parent,"hooks","use-theme").useTheme;local de=a.import(script,script.Parent.Parent.Parent,"utils","timeout").setInterval;local am=a.import(script,script.Parent.Parent.Parent,"utils","udim2").px;local k1=am(56,56)local k2=14;local function k3()return string.gsub(os.date("%I:%M %p"),"^0([0-9])","%1")end;local function k4()local c4=p(function(F)return F.dashboard.isOpen end)local aT=e9("clock")local U=aH(k3())local k5=U[1]local k6=U[2]local k7=l(function()return k0:GetTextSize(k5,20,"GothamBold",Vector2.new(200,56))end,{k5})k(function()local hk=de(function()return k6(k3())end,1000)return function()return hk:clear()end end,{})local bc={}local y=am(k7.X+k2,0)bc.Size=k1+y;bc.Position=aL(c4 and UDim2.new(0,0,1,0)or UDim2.new(0,0,1,48+56+20),{})bc.AnchorPoint=Vector2.new(0,1)bc.BackgroundTransparency=1;local be={b.createElement(bn,{radius=bo.Size146,size=UDim2.new(1,80,0,146),position=am(-40,-20),color=aT.dropshadow,gradient=aT.dropshadowGradient,transparency=aT.transparency}),b.createElement(bl,{color=aT.background,gradient=aT.backgroundGradient,transparency=aT.transparency,radius=8})}local bf=#be;local bv=aT.outlined and b.createFragment({border=b.createElement(b8,{color=aT.foreground,radius=8,transparency=0.8})})if bv then if bv.elements~=nil or bv.props~=nil and bv.component~=nil then be[bf+1]=bv else for av,aw in ipairs(bv)do be[bf+av]=aw end end end;bf=#be;be[bf+1]=b.createElement("ImageLabel",{Image="rbxassetid://8992234911",ImageColor3=aT.foreground,Size=am(36,36),Position=am(10,10),BackgroundTransparency=1})be[bf+2]=b.createElement("TextLabel",{Text=k5,Font="GothamBold",TextColor3=aT.foreground,TextSize=20,TextXAlignment="Left",TextYAlignment="Center",Size=am(0,0),Position=am(51,27),BackgroundTransparency=1})local c9=aT.acrylic and b.createElement(B)or nil;if c9 then if c9.elements~=nil or c9.props~=nil and c9.component~=nil then be[bf+3]=c9 else for av,aw in ipairs(c9)do be[bf+2+av]=aw end end end;return b.createElement("Frame",bc,be)end;local f=i(k4)return{default=f}end,newEnv("Orca.views.Clock.Clock"))()end)newModule("Dashboard","ModuleScript","Orca.views.Dashboard","Orca.views",function()return setfenv(function()local a=require(script.Parent.Parent.include.RuntimeLib)local g={}g.default=a.import(script,script,"Dashboard").default;return g end,newEnv("Orca.views.Dashboard"))()end)newModule("Dashboard","ModuleScript","Orca.views.Dashboard.Dashboard","Orca.views.Dashboard",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.include.RuntimeLib)local b=a.import(script,a.getModule(script,"@rbxts","roact").src)local h=a.import(script,a.getModule(script,"@rbxts","roact-hooked").out)local i=h.hooked;local k=h.useEffect;local l=h.useMemo;local bx=a.import(script,a.getModule(script,"@rbxts","services")).UserInputService;local bk=a.import(script,script.Parent.Parent.Parent,"components","Canvas").default;local cx=a.import(script,script.Parent.Parent.Parent,"context","scale-context").ScaleContext;local aJ=a.import(script,script.Parent.Parent.Parent,"hooks","common","rodux-hooks")local aK=aJ.useAppDispatch;local p=aJ.useAppSelector;local aL=a.import(script,script.Parent.Parent.Parent,"hooks","common","use-spring").useSpring;local dO=a.import(script,script.Parent.Parent.Parent,"hooks","common","use-viewport-size").useViewportSize;local i7=a.import(script,script.Parent.Parent.Parent,"store","actions","dashboard.action").toggleDashboard;local ak=a.import(script,script.Parent.Parent.Parent,"utils","color3").hex;local q=a.import(script,script.Parent.Parent.Parent,"utils","number-util").map;local r=a.import(script,script.Parent.Parent.Parent,"utils","udim2").scale;local k8=a.import(script,script.Parent.Parent,"Hint").default;local k4=a.import(script,script.Parent.Parent,"Clock").default;local k9=a.import(script,script.Parent.Parent,"Navbar").default;local ka=a.import(script,script.Parent.Parent,"Pages").default;local kb=980;local kc=1080;local kd=14;local ke=48;local function kf(a4)if a4<kc and a4>=kb then return q(a4,kb,kc,kd,ke)elseif a4<kb then return kd else return ke end end;local function kg(a4)if a4<kb then return q(a4,kb,130,1,0)else return 1 end end;local function c()local aW=aK()local c4=p(function(F)return F.dashboard.isOpen end)local kh=dO()local U=l(function()return{kh:map(function(bd)return kg(bd.Y)end),kh:map(function(bd)return kf(bd.Y)end)}end,{kh})local ck=U[1]local bX=U[2]k(function()local ki=bx.InputBegan:Connect(function(bV,eB)if eB then return nil end;if bV.KeyCode==Enum.KeyCode.K then aW(i7())end end)return function()return ki:Disconnect()end end,{})return b.createElement(cx.Provider,{value=ck},{b.createElement("Frame",{Size=r(1,1),BackgroundColor3=ak("#000000"),BackgroundTransparency=aL(c4 and 0 or 1,{}),BorderSizePixel=0},{b.createElement("UIGradient",{Transparency=NumberSequence.new(1,0.25),Rotation=90})}),b.createElement(bk,{padding={top=48,bottom=bX,left=48,right=48}},{b.createElement(bk,{padding={bottom=bX:map(function(kj)return 56+kj end)}},{b.createElement(ka),b.createElement(k8)}),b.createElement(k9),b.createElement(k4)})})end;local f=i(c)return{default=f}end,newEnv("Orca.views.Dashboard.Dashboard"))()end)newModule("Dashboard.story","ModuleScript","Orca.views.Dashboard.Dashboard.story","Orca.views.Dashboard",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.include.RuntimeLib)local b=a.import(script,a.getModule(script,"@rbxts","roact").src)local ah=a.import(script,a.getModule(script,"@rbxts","roact-rodux-hooked").out).Provider;local ai=a.import(script,script.Parent.Parent.Parent,"store","models","dashboard.model").DashboardPage;local aj=a.import(script,script.Parent.Parent.Parent,"store","store").configureStore;local c=a.import(script,script.Parent,"Dashboard").default;return function(an)local ao=b.mount(b.createElement(ah,{store=aj({dashboard={isOpen=true,page=ai.Home,hint=nil,apps={}}})},{b.createElement(c)}),an,"Dashboard")return function()return b.unmount(ao)end end end,newEnv("Orca.views.Dashboard.Dashboard.story"))()end)newModule("Hint","ModuleScript","Orca.views.Hint","Orca.views",function()return setfenv(function()local a=require(script.Parent.Parent.include.RuntimeLib)local g={}g.default=a.import(script,script,"Hint").default;return g end,newEnv("Orca.views.Hint"))()end)newModule("Hint","ModuleScript","Orca.views.Hint.Hint","Orca.views.Hint",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.include.RuntimeLib)local b=a.import(script,a.getModule(script,"@rbxts","roact").src)local h=a.import(script,a.getModule(script,"@rbxts","roact-hooked").out)local i=h.hooked;local k=h.useEffect;local aH=h.useState;local p=a.import(script,script.Parent.Parent.Parent,"hooks","common","rodux-hooks").useAppSelector;local b_=a.import(script,script.Parent.Parent.Parent,"hooks","common","use-delayed-state").useDelayedState;local aL=a.import(script,script.Parent.Parent.Parent,"hooks","common","use-spring").useSpring;local cd=a.import(script,script.Parent.Parent.Parent,"hooks","use-scale").useScale;local ak=a.import(script,script.Parent.Parent.Parent,"utils","color3").hex;local r=a.import(script,script.Parent.Parent.Parent,"utils","udim2").scale;local function k8()local ck=cd()local aS=p(function(F)return F.dashboard.hint end)local kk=p(function(F)return F.dashboard.isOpen end)local b2=aS;if b2==nil then b2=""end;local U=aH(b2)local kl=U[1]local km=U[2]local kn=b_(aS~=nil and kk,500,function(ko)return not ko end)k(function()if kn and aS~=nil then km(aS)end end,{aS,kn})return b.createElement("TextLabel",{RichText=true,Text=kl,TextXAlignment="Right",TextYAlignment="Bottom",TextColor3=ak("#FFFFFF"),TextTransparency=aL(kn and 0.4 or 1,{}),Font="GothamSemibold",TextSize=18,BackgroundTransparency=1,Position=aL(kn and r(1,1)or UDim2.new(1,0,1,48),{})},{b.createElement("UIScale",{Scale=ck})})end;local f=i(k8)return{default=f}end,newEnv("Orca.views.Hint.Hint"))()end)newModule("Navbar","ModuleScript","Orca.views.Navbar","Orca.views",function()return setfenv(function()local a=require(script.Parent.Parent.include.RuntimeLib)local g={}g.default=a.import(script,script,"Navbar").default;return g end,newEnv("Orca.views.Navbar"))()end)newModule("Navbar","ModuleScript","Orca.views.Navbar.Navbar","Orca.views.Navbar",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.include.RuntimeLib)local b=a.import(script,a.getModule(script,"@rbxts","roact").src)local i=a.import(script,a.getModule(script,"@rbxts","roact-hooked").out).hooked;local B=a.import(script,script.Parent.Parent.Parent,"components","Acrylic").default;local b8=a.import(script,script.Parent.Parent.Parent,"components","Border").default;local bk=a.import(script,script.Parent.Parent.Parent,"components","Canvas").default;local bl=a.import(script,script.Parent.Parent.Parent,"components","Fill").default;local bm=a.import(script,script.Parent.Parent.Parent,"components","Glow")local bn=bm.default;local bo=bm.GlowRadius;local p=a.import(script,script.Parent.Parent.Parent,"hooks","common","rodux-hooks").useAppSelector;local aL=a.import(script,script.Parent.Parent.Parent,"hooks","common","use-spring").useSpring;local dS=a.import(script,script.Parent.Parent.Parent,"hooks","use-current-page").useCurrentPage;local e9=a.import(script,script.Parent.Parent.Parent,"hooks","use-theme").useTheme;local kp=a.import(script,script.Parent.Parent.Parent,"store","models","dashboard.model")local ai=kp.DashboardPage;local ii=kp.PAGE_TO_INDEX;local kq=a.import(script,script.Parent.Parent.Parent,"utils","color3")local jj=kq.getColorInSequence;local ak=kq.hex;local al=a.import(script,script.Parent.Parent.Parent,"utils","udim2")local am=al.px;local r=al.scale;local kr=a.import(script,script.Parent,"NavbarTab").default;local ks=am(400,56)local kt;local function k9()local aT=e9("navbar")local c3=dS()local c4=p(function(F)return F.dashboard.isOpen end)local bN=aL(ii[c3]/4,{frequency=3.9,dampingRatio=0.76})local bc={Size=ks,Position=aL(c4 and UDim2.new(0.5,0,1,0)or UDim2.new(0.5,0,1,48+56+20),{}),AnchorPoint=Vector2.new(0.5,1),BackgroundTransparency=1}local be={b.createElement(bn,{radius=bo.Size146,size=UDim2.new(1,80,0,146),position=am(-40,-20),color=aT.dropshadow,gradient=aT.dropshadowGradient,transparency=aT.transparency}),b.createElement(kt,{transparency=aT.glowTransparency,position=bN:map(function(ho)return ho+0.125 end),sequenceColor=bN:map(function(ho)return jj(aT.accentGradient.color,ho+0.125)end)}),b.createElement(bl,{color=aT.background,gradient=aT.backgroundGradient,radius=8,transparency=aT.transparency}),b.createElement(bk,{size=am(100,56),position=bN:map(function(ho)return r(math.round(ho*800)/800,0)end),clipsDescendants=true},{b.createElement("Frame",{Size=ks,Position=bN:map(function(ho)return r(-4*math.round(ho*800)/800,0)end),BackgroundColor3=ak("#FFFFFF"),BorderSizePixel=0},{b.createElement("UIGradient",{Color=aT.accentGradient.color,Transparency=aT.accentGradient.transparency,Rotation=aT.accentGradient.rotation}),b.createElement("UICorner",{CornerRadius=UDim.new(0,8)})})})}local bf=#be;local bv=aT.outlined and b.createFragment({border=b.createElement(b8,{color=aT.foreground,radius=8,transparency=0.8})})if bv then if bv.elements~=nil or bv.props~=nil and bv.component~=nil then be[bf+1]=bv else for av,aw in ipairs(bv)do be[bf+av]=aw end end end;bf=#be;be[bf+1]=b.createElement(kr,{page=ai.Home})be[bf+2]=b.createElement(kr,{page=ai.Apps})be[bf+3]=b.createElement(kr,{page=ai.Scripts})be[bf+4]=b.createElement(kr,{page=ai.Options})local c9=aT.acrylic and b.createElement(B)or nil;if c9 then if c9.elements~=nil or c9.props~=nil and c9.component~=nil then be[bf+5]=c9 else for av,aw in ipairs(c9)do be[bf+4+av]=aw end end end;return b.createElement("Frame",bc,be)end;local f=i(k9)function kt(ku)return b.createElement("ImageLabel",{Image="rbxassetid://8992238178",ImageColor3=ku.sequenceColor,ImageTransparency=ku.transparency,Size=am(148,104),Position=ku.position:map(function(ho)return UDim2.new(ho,0,0,-18)end),AnchorPoint=Vector2.new(0.5,0),BackgroundTransparency=1})end;return{default=f}end,newEnv("Orca.views.Navbar.Navbar"))()end)newModule("Navbar.story","ModuleScript","Orca.views.Navbar.Navbar.story","Orca.views.Navbar",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.include.RuntimeLib)local b=a.import(script,a.getModule(script,"@rbxts","roact").src)local ah=a.import(script,a.getModule(script,"@rbxts","roact-rodux-hooked").out).Provider;local ai=a.import(script,script.Parent.Parent.Parent,"store","models","dashboard.model").DashboardPage;local aj=a.import(script,script.Parent.Parent.Parent,"store","store").configureStore;local k9=a.import(script,script.Parent,"Navbar").default;return function(an)local ao=b.mount(b.createElement(ah,{store=aj({dashboard={isOpen=true,page=ai.Home,hint=nil,apps={}}})},{b.createElement(k9)}),an,"Navbar")return function()return b.unmount(ao)end end end,newEnv("Orca.views.Navbar.Navbar.story"))()end)newModule("NavbarTab","ModuleScript","Orca.views.Navbar.NavbarTab","Orca.views.Navbar",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.include.RuntimeLib)local b=a.import(script,a.getModule(script,"@rbxts","roact").src)local h=a.import(script,a.getModule(script,"@rbxts","roact-hooked").out)local i=h.hooked;local aH=h.useState;local aK=a.import(script,script.Parent.Parent.Parent,"hooks","common","rodux-hooks").useAppDispatch;local aL=a.import(script,script.Parent.Parent.Parent,"hooks","common","use-spring").useSpring;local c0=a.import(script,script.Parent.Parent.Parent,"hooks","use-current-page").useIsPageOpen;local e9=a.import(script,script.Parent.Parent.Parent,"hooks","use-theme").useTheme;local ic=a.import(script,script.Parent.Parent.Parent,"store","actions","dashboard.action").setDashboardPage;local kp=a.import(script,script.Parent.Parent.Parent,"store","models","dashboard.model")local ij=kp.PAGE_TO_ICON;local ii=kp.PAGE_TO_INDEX;local al=a.import(script,script.Parent.Parent.Parent,"utils","udim2")local am=al.px;local r=al.scale;local kv=am(100,56)local function kr(C)local c3=C.page;local aT=e9("navbar")local c5=c0(c3)local aW=aK()local U=aH(false)local kw=U[1]local aZ=U[2]return b.createElement("TextButton",{Text="",AutoButtonColor=false,Active=not c5,Size=kv,Position=r(ii[c3]/4,0),BackgroundTransparency=1,[b.Event.Activated]=function()return aW(ic(c3))end,[b.Event.MouseEnter]=function()return aZ(true)end,[b.Event.MouseLeave]=function()return aZ(false)end},{b.createElement("ImageLabel",{Image=ij[c3],ImageColor3=aT.foreground,ImageTransparency=aL(c5 and 0 or(kw and 0.5 or 0.75),{}),Size=am(36,36),Position=r(0.5,0.5),AnchorPoint=Vector2.new(0.5,0.5),BackgroundTransparency=1})})end;local f=i(kr)return{default=f}end,newEnv("Orca.views.Navbar.NavbarTab"))()end)newModule("Pages","ModuleScript","Orca.views.Pages","Orca.views",function()return setfenv(function()local a=require(script.Parent.Parent.include.RuntimeLib)local g={}g.default=a.import(script,script,"Pages").default;return g end,newEnv("Orca.views.Pages"))()end)newModule("Apps","ModuleScript","Orca.views.Pages.Apps","Orca.views.Pages",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.include.RuntimeLib)local g={}g.default=a.import(script,script,"Apps").default;return g end,newEnv("Orca.views.Pages.Apps"))()end)newModule("Apps","ModuleScript","Orca.views.Pages.Apps.Apps","Orca.views.Pages.Apps",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.Parent.include.RuntimeLib)local b=a.import(script,a.getModule(script,"@rbxts","roact").src)local kx=a.import(script,a.getModule(script,"@rbxts","roact-hooked").out).pure;local bk=a.import(script,script.Parent.Parent.Parent.Parent,"components","Canvas").default;local cd=a.import(script,script.Parent.Parent.Parent.Parent,"hooks","use-scale").useScale;local r=a.import(script,script.Parent.Parent.Parent.Parent,"utils","udim2").scale;local ky=a.import(script,script.Parent,"PlayersCard").default;local function kz()local ck=cd()return b.createElement(bk,{position=r(0,1),anchor=Vector2.new(0,1)},{b.createElement("UIScale",{Scale=ck}),b.createElement(ky)})end;local f=kx(kz)return{default=f}end,newEnv("Orca.views.Pages.Apps.Apps"))()end)newModule("PlayersCard","ModuleScript","Orca.views.Pages.Apps.PlayersCard","Orca.views.Pages.Apps",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.Parent.include.RuntimeLib)local g={}g.default=a.import(script,script,"PlayersCard").default;return g end,newEnv("Orca.views.Pages.Apps.PlayersCard"))()end)newModule("Actions","ModuleScript","Orca.views.Pages.Apps.PlayersCard.Actions","Orca.views.Pages.Apps.PlayersCard",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.Parent.Parent.include.RuntimeLib)local b=a.import(script,a.getModule(script,"@rbxts","roact").src)local i=a.import(script,a.getModule(script,"@rbxts","roact-hooked").out).hooked;local aQ=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"components","ActionButton").default;local bk=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"components","Canvas").default;local e9=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"hooks","use-theme").useTheme;local am=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"utils","udim2").px;local function kA()local aT=e9("apps").players;return b.createElement(bk,{anchor=Vector2.new(0.5,0),size=am(278,49),position=UDim2.new(0.5,0,0,304)},{b.createElement(aQ,{action="teleport",hint="<font face='GothamBlack'>Teleport to</font> this player, tap again to cancel",theme=aT,image="rbxassetid://8992042585",position=am(0,0),canDeactivate=true}),b.createElement(aQ,{action="hide",hint="<font face='GothamBlack'>Hide</font> this player's character; persists between players",theme=aT,image="rbxassetid://8992042653",position=am(72,0),canDeactivate=true}),b.createElement(aQ,{action="kill",hint="<font face='GothamBlack'>Kill</font> this player with a tool handle",theme=aT,image="rbxassetid://8992042471",position=am(145,0)}),b.createElement(aQ,{action="spectate",hint="<font face='GothamBlack'>Spectate</font> this player",theme=aT,image="rbxassetid://8992042721",position=am(217,0),canDeactivate=true})})end;local f=i(kA)return{default=f}end,newEnv("Orca.views.Pages.Apps.PlayersCard.Actions"))()end)newModule("Avatar","ModuleScript","Orca.views.Pages.Apps.PlayersCard.Avatar","Orca.views.Pages.Apps.PlayersCard",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.Parent.Parent.include.RuntimeLib)local b=a.import(script,a.getModule(script,"@rbxts","roact").src)local i=a.import(script,a.getModule(script,"@rbxts","roact-hooked").out).hooked;local dT=a.import(script,a.getModule(script,"@rbxts","services")).Players;local b8=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"components","Border").default;local bk=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"components","Canvas").default;local p=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"hooks","common","rodux-hooks").useAppSelector;local e9=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"hooks","use-theme").useTheme;local am=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"utils","udim2").px;local function kB()local aT=e9("apps").players;local he=p(function(F)local b0;if F.dashboard.apps.playerSelected~=nil then b0=dT:FindFirstChild(F.dashboard.apps.playerSelected)else b0=nil end;return b0 end)return b.createElement(bk,{anchor=Vector2.new(0.5,0),size=am(186,186),position=UDim2.new(0.5,0,0,24)},{b.createElement("ImageLabel",{Image="https://www.roblox.com/headshot-thumbnail/image?userId="..tostring(he and he.UserId or dT.LocalPlayer.UserId).."&width=150&height=150&format=png",Size=am(150,150),Position=am(18,18),BackgroundColor3=aT.avatar.background,BackgroundTransparency=aT.avatar.transparency},{b.createElement("UICorner",{CornerRadius=UDim.new(1,0)})}),b.createElement(b8,{size=4,radius="circular"},{b.createElement("UIGradient",{Color=aT.avatar.gradient.color,Transparency=aT.avatar.gradient.transparency,Rotation=aT.avatar.gradient.rotation})})})end;local f=i(kB)return{default=f}end,newEnv("Orca.views.Pages.Apps.PlayersCard.Avatar"))()end)newModule("PlayersCard","ModuleScript","Orca.views.Pages.Apps.PlayersCard.PlayersCard","Orca.views.Pages.Apps.PlayersCard",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.Parent.Parent.include.RuntimeLib)local b=a.import(script,a.getModule(script,"@rbxts","roact").src)local i=a.import(script,a.getModule(script,"@rbxts","roact-hooked").out).hooked;local c1=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"components","Card").default;local e9=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"hooks","use-theme").useTheme;local ai=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"store","models","dashboard.model").DashboardPage;local am=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"utils","udim2").px;local kA=a.import(script,script.Parent,"Actions").default;local kB=a.import(script,script.Parent,"Avatar").default;local kC=a.import(script,script.Parent,"Selection").default;local kD=a.import(script,script.Parent,"Username").default;local function ky()local aT=e9("apps").players;return b.createElement(c1,{index=1,page=ai.Apps,theme=aT,size=am(326,648),position=UDim2.new(0,0,1,0)},{b.createElement(kB),b.createElement(kD),b.createElement(kA),b.createElement(kC)})end;local f=i(ky)return{default=f}end,newEnv("Orca.views.Pages.Apps.PlayersCard.PlayersCard"))()end)newModule("Selection","ModuleScript","Orca.views.Pages.Apps.PlayersCard.Selection","Orca.views.Pages.Apps.PlayersCard",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.Parent.Parent.include.RuntimeLib)local b=a.import(script,a.getModule(script,"@rbxts","roact").src)local h=a.import(script,a.getModule(script,"@rbxts","roact-hooked").out)local i=h.hooked;local k=h.useEffect;local l=h.useMemo;local aH=h.useState;local em=a.import(script,a.getModule(script,"@rbxts","services"))local dT=em.Players;local k0=em.TextService;local b8=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"components","Border").default;local bk=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"components","Canvas").default;local bl=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"components","Fill").default;local bm=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"components","Glow")local bn=bm.default;local bo=bm.GlowRadius;local cv=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"constants").IS_DEV;local cK=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"hooks","common","flipper-hooks").useLinear;local aJ=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"hooks","common","rodux-hooks")local aK=aJ.useAppDispatch;local p=aJ.useAppSelector;local aL=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"hooks","common","use-spring").useSpring;local e9=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"hooks","use-theme").useTheme;local aM=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"store","actions","dashboard.action")local id=aM.playerDeselected;local he=aM.playerSelected;local jc=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"utils","array-util").arrayToMap;local jU=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"utils","number-util").lerp;local al=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"utils","udim2")local am=al.px;local r=al.scale;local kE=20;local kF=60;local kG=326-24*2;local kH=60;local kI=NumberSequence.new({NumberSequenceKeypoint.new(0,1),NumberSequenceKeypoint.new(0.05,0),NumberSequenceKeypoint.new(0.9,0),NumberSequenceKeypoint.new(0.95,1),NumberSequenceKeypoint.new(1,1)})local function kJ()local U=aH(dT:GetPlayers())local kK=U[1]local kL=U[2]k(function()local kM=dT.PlayerAdded:Connect(function()kL(dT:GetPlayers())end)local kN=dT.PlayerRemoving:Connect(function()kL(dT:GetPlayers())end)return function()kM:Disconnect()kN:Disconnect()end end,{})return kK end;local kO;local function kC()local aW=aK()local kK=kJ()local he=p(function(F)return F.dashboard.apps.playerSelected end)local kP=l(function()local y=function(kj)return kj.Name==he end;local b0=nil;for e3,aw in ipairs(kK)do if y(aw,e3-1,kK)==true then b0=aw;break end end;local kQ=b0;local c7=function(kj)return kj.Name~=he and(kj~=dT.LocalPlayer or cv)end;local d_={}local bf=0;for av,aw in ipairs(kK)do if c7(aw,av-1,kK)==true then bf=bf+1;d_[bf]=aw end end;local kR=function(ho,dE)return string.lower(ho.Name)<string.lower(dE.Name)end;table.sort(d_,kR)local kS=d_;local b1;if kQ then local hD={kQ}local bi=#hD;table.move(kS,1,#kS,bi+1,hD)b1=hD else b1=kS end;return b1 end,{kK,he})k(function()local b2=he~=nil;if b2 then local y=function(ep)return ep.Name==he end;local b0=nil;for e3,aw in ipairs(kP)do if y(aw,e3-1,kP)==true then b0=aw;break end end;b2=not b0 end;if b2 then aW(id())end end,{kK,he})local bc={size=am(326,280),position=am(0,368),padding={left=24,right=24,top=8},clipsDescendants=true}local be={}local bf=#be;local bg={Size=r(1,1),CanvasSize=am(0,#kP*(kF+kE)+kE),BackgroundTransparency=1,BorderSizePixel=0,ScrollBarImageTransparency=1,ScrollBarThickness=0,ClipsDescendants=false}local bh={}local bi=#bh;for av,aw in pairs(jc(kP,function(ep,c2)return{ep.Name,b.createElement(kO,{name=ep.Name,displayName=ep.DisplayName,userId=ep.UserId,index=c2})}end))do bh[av]=aw end;be[bf+1]=b.createElement("ScrollingFrame",bg,bh)return b.createElement(bk,bc,be)end;local f=i(kC)local function kT(C)local hf=C.name;local kU=C.userId;local kV=C.displayName;local c2=C.index;local aW=aK()local aT=e9("apps").players.playerButton;local kW=p(function(F)return F.dashboard.apps.playerSelected==hf end)local U=aH(false)local aY=U[1]local aZ=U[2]local kX="  "..kV.." (@"..hf..")"local kY=l(function()return k0:GetTextSize(kX,14,Enum.Font.GothamBold,Vector2.new(1000,kF))end,{kX})local kZ=cK(aY and kG-kH-20-kY.X or 0,{velocity=aY and 40 or 150}):map(function(bU)return UDim.new(0,math.min(bU,0))end)local b0;if kW then b0=aT.accent else local b1;if aY then local b2=aT.backgroundHovered;if b2==nil then b2=aT.background:Lerp(aT.accent,0.1)end;b1=b2 else b1=aT.background end;b0=b1 end;local b3=aL(b0,{})local b1;if kW then b1=aT.accent else local fc;if aY then local b2=aT.backgroundHovered;if b2==nil then b2=aT.dropshadow:Lerp(aT.accent,0.5)end;fc=b2 else fc=aT.dropshadow end;b1=fc end;local k_=aL(b1,{})local b4=aL(kW and aT.foregroundAccent and aT.foregroundAccent or aT.foreground,{})local bc={size=am(kG,kF),position=aL(am(0,(kE+kF)*c2),{}),zIndex=c2}local be={b.createElement(bn,{radius=bo.Size70,color=k_,size=UDim2.new(1,36,1,36),position=am(-18,5-18),transparency=aL(kW and aT.glowTransparency or(aY and jU(aT.dropshadowTransparency,aT.glowTransparency,0.5)or aT.dropshadowTransparency),{})}),b.createElement(bl,{color=b3,transparency=aL(aT.backgroundTransparency,{}),radius=8}),b.createElement("TextLabel",{Text=kX,Font="GothamBold",TextSize=14,TextColor3=b4,TextXAlignment=Enum.TextXAlignment.Left,TextYAlignment=Enum.TextYAlignment.Center,TextTransparency=aL(kW and 0 or(aY and aT.foregroundTransparency/2 or aT.foregroundTransparency),{}),BackgroundTransparency=1,Position=am(kH,1),Size=UDim2.new(1,-kH,1,-1),ClipsDescendants=true},{b.createElement("UIPadding",{PaddingLeft=kZ}),b.createElement("UIGradient",{Transparency=kI})}),b.createElement("ImageLabel",{Image="https://www.roblox.com/headshot-thumbnail/image?userId="..tostring(kU).."&width=60&height=60&format=png",Size=UDim2.new(0,kF,0,kF),BackgroundTransparency=1},{b.createElement("UICorner",{CornerRadius=UDim.new(0,8)})})}local bf=#be;local bv=aT.outlined and b.createElement(b8,{color=b4,transparency=0.8,radius=8})if bv then if bv.elements~=nil or bv.props~=nil and bv.component~=nil then be[bf+1]=bv else for av,aw in ipairs(bv)do be[bf+av]=aw end end end;bf=#be;be[bf+1]=b.createElement("TextButton",{[b.Event.Activated]=function()local ep=dT:FindFirstChild(hf)local b2=not kW;if b2 then local fc=ep;if fc~=nil then fc=fc:IsA("Player")end;b2=fc end;if b2 then aW(he(ep))else aW(id())end end,[b.Event.MouseEnter]=function()return aZ(true)end,[b.Event.MouseLeave]=function()return aZ(false)end,Text="",Transparency=1,Size=r(1,1)})return b.createElement(bk,bc,be)end;kO=i(kT)return{default=f}end,newEnv("Orca.views.Pages.Apps.PlayersCard.Selection"))()end)newModule("Username","ModuleScript","Orca.views.Pages.Apps.PlayersCard.Username","Orca.views.Pages.Apps.PlayersCard",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.Parent.Parent.include.RuntimeLib)local b=a.import(script,a.getModule(script,"@rbxts","roact").src)local i=a.import(script,a.getModule(script,"@rbxts","roact-hooked").out).hooked;local dT=a.import(script,a.getModule(script,"@rbxts","services")).Players;local bk=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"components","Canvas").default;local p=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"hooks","common","rodux-hooks").useAppSelector;local e9=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"hooks","use-theme").useTheme;local al=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"utils","udim2")local am=al.px;local r=al.scale;local function kD()local aT=e9("apps").players;local he=p(function(F)local b0;if F.dashboard.apps.playerSelected~=nil then b0=dT:FindFirstChild(F.dashboard.apps.playerSelected)else b0=nil end;return b0 end)return b.createElement(bk,{anchor=Vector2.new(0.5,0),size=am(278,49),position=UDim2.new(0.5,0,0,231)},{b.createElement("TextLabel",{Font="GothamBlack",Text=he and he.DisplayName or"N/A",TextSize=20,TextColor3=aT.foreground,TextXAlignment="Center",TextYAlignment="Top",Size=r(1,1),BackgroundTransparency=1}),b.createElement("TextLabel",{Font="GothamBold",Text=he and he.Name or"Select a player",TextSize=16,TextColor3=aT.foreground,TextXAlignment="Center",TextYAlignment="Bottom",TextTransparency=0.7,Size=r(1,1),BackgroundTransparency=1})})end;local f=i(kD)return{default=f}end,newEnv("Orca.views.Pages.Apps.PlayersCard.Username"))()end)newModule("Home","ModuleScript","Orca.views.Pages.Home","Orca.views.Pages",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.include.RuntimeLib)local g={}g.default=a.import(script,script,"Home").default;return g end,newEnv("Orca.views.Pages.Home"))()end)newModule("FriendActivityCard","ModuleScript","Orca.views.Pages.Home.FriendActivityCard","Orca.views.Pages.Home",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.Parent.include.RuntimeLib)local b=a.import(script,a.getModule(script,"@rbxts","roact").src)local h=a.import(script,a.getModule(script,"@rbxts","roact-hooked").out)local i=h.hooked;local kx=h.pure;local k=h.useEffect;local l=h.useMemo;local dk=h.useReducer;local aH=h.useState;local em=a.import(script,a.getModule(script,"@rbxts","services"))local dT=em.Players;local hY=em.TeleportService;local b8=a.import(script,script.Parent.Parent.Parent.Parent,"components","Border").default;local bk=a.import(script,script.Parent.Parent.Parent.Parent,"components","Canvas").default;local c1=a.import(script,script.Parent.Parent.Parent.Parent,"components","Card").default;local bl=a.import(script,script.Parent.Parent.Parent.Parent,"components","Fill").default;local df=a.import(script,script.Parent.Parent.Parent.Parent,"hooks","common","use-interval").useInterval;local aL=a.import(script,script.Parent.Parent.Parent.Parent,"hooks","common","use-spring").useSpring;local e1=a.import(script,script.Parent.Parent.Parent.Parent,"hooks","use-friends").useFriendActivity;local e9=a.import(script,script.Parent.Parent.Parent.Parent,"hooks","use-theme").useTheme;local ai=a.import(script,script.Parent.Parent.Parent.Parent,"store","models","dashboard.model").DashboardPage;local jc=a.import(script,script.Parent.Parent.Parent.Parent,"utils","array-util").arrayToMap;local al=a.import(script,script.Parent.Parent.Parent.Parent,"utils","udim2")local am=al.px;local r=al.scale;local l0={frequency=6}local l1=48;local l2;local function l3()local aT=e9("home").friendActivity;local U=dk(function(F)return F+1 end,0)local l4=U[1]local l5=U[2]local dt=e1({l4})local l6=dt[1]local dX=dt[3]local l7=aH(l6)local e2=l7[1]local l8=l7[2]k(function()if#l6>0 then local y=function(ho,dE)return#ho.friends>#dE.friends end;table.sort(l6,y)l8(l6)end end,{l6})df(function()return l5()end,#e2==0 and dX~="pending"and 3000 or 30000)local bc={index=3,page=ai.Home,theme=aT,size=am(326,416),position=UDim2.new(0,374,1,0)}local be={b.createElement("TextLabel",{Text="Friend Activity",Font="GothamBlack",TextSize=20,TextColor3=aT.foreground,TextXAlignment="Left",TextYAlignment="Top",Position=am(24,24),BackgroundTransparency=1})}local bf=#be;local bg={anchor=Vector2.new(0,1),size=aL(#e2>0 and UDim2.new(1,0,0,344)or UDim2.new(1,0,0,0),{}),position=r(0,1)}local bh={}local bi=#bh;local l9={Size=r(1,1),ScrollBarThickness=0,ScrollBarImageTransparency=1,ScrollingDirection="Y",CanvasSize=am(0,#e2*(l1+156)+l1),BackgroundTransparency=1,BorderSizePixel=0}local la={}local lb=#la;for av,aw in pairs(jc(e2,function(e4,c2)return{tostring(e4.placeId),b.createElement(l2,{game=e4,index=c2})}end))do la[av]=aw end;bh[bi+1]=b.createElement("ScrollingFrame",l9,la)be[bf+1]=b.createElement(bk,bg,bh)return b.createElement(c1,bc,be)end;local f=i(l3)local lc;local function ld(ku)local aT=e9("home").friendActivity;local le=l(function()return#ku.game.friends*(48+10)+96 end,{#ku.game.friends})local bc={Image=ku.game.thumbnail,ScaleType="Crop",Size=am(278,156),Position=aL(am(24,ku.index*(l1+156)),{}),BackgroundTransparency=1}local be={b.createElement(b8,{color=aT.foreground,radius=8,transparency=0.8}),b.createElement("UICorner",{CornerRadius=UDim.new(0,8)})}local bf=#be;local e6=ku.game.friends;local y=function(dZ,c2)return{tostring(dZ.VisitorId),b.createElement(lc,{friend=dZ,index=c2})}end;local d_=table.create(#e6)for av,aw in ipairs(e6)do d_[av]=y(aw,av-1,e6)end;local jf={}for c_,aw in ipairs(d_)do jf[aw[1]]=aw[2]end;local bg={Size=UDim2.new(1,0,0,64),Position=UDim2.new(0,0,1,-24),CanvasSize=am(le,0),ScrollingDirection="X",ScrollBarThickness=0,ScrollBarImageTransparency=1,BackgroundTransparency=1,BorderSizePixel=0,ClipsDescendants=false}local bh={b.createElement("UIListLayout",{SortOrder="LayoutOrder",FillDirection="Horizontal",HorizontalAlignment="Left",VerticalAlignment="Top",Padding=UDim.new(0,10)}),b.createElement("UIPadding",{PaddingLeft=UDim.new(0,10)})}local bi=#bh;for av,aw in pairs(jf)do bh[av]=aw end;be[bf+1]=b.createElement("ScrollingFrame",bg,bh)return b.createElement("ImageLabel",bc,be)end;l2=kx(ld)local function lf(ku)local aT=e9("home").friendActivity.friendButton;local U=aH(false)local kw=U[1]local aZ=U[2]local lg="https://www.roblox.com/headshot-thumbnail/image?userId="..tostring(ku.friend.VisitorId).."&width=48&height=48&format=png"local bc={size=aL(kw and am(96,48)or am(48,48),l0)}local be={b.createElement("ImageLabel",{Image="rbxassetid://8992244272",ImageColor3=aL(kw and aT.accent or aT.dropshadow,l0),ImageTransparency=aL(kw and aT.glowTransparency or aT.dropshadowTransparency,l0),Size=aL(kw and am(88+36,74)or am(76,74),l0),Position=am(-14,-10),ScaleType="Slice",SliceCenter=Rect.new(Vector2.new(42,42),Vector2.new(42,42)),BackgroundTransparency=1}),b.createElement(bl,{radius=24,color=aL(kw and aT.accent or aT.background,l0),transparency=aT.backgroundTransparency})}local bf=#be;local bv=aT.outlined and b.createFragment({border=b.createElement(b8,{radius=23,color=kw and aT.foregroundAccent and aT.foregroundAccent or aT.foreground,transparency=0.7})})if bv then if bv.elements~=nil or bv.props~=nil and bv.component~=nil then be[bf+1]=bv else for av,aw in ipairs(bv)do be[bf+av]=aw end end end;bf=#be;be[bf+1]=b.createElement("ImageLabel",{Image=lg,ScaleType="Crop",Size=am(48,48),LayoutOrder=ku.index,BackgroundTransparency=1},{b.createElement("UICorner",{CornerRadius=UDim.new(1,0)})})be[bf+2]=b.createElement(bk,{clipsDescendants=true},{b.createElement("ImageLabel",{Image="rbxassetid://8992244380",ImageColor3=kw and aT.foregroundAccent and aT.foregroundAccent or aT.foreground,ImageTransparency=aT.foregroundTransparency,Size=am(36,36),Position=am(48,6),BackgroundTransparency=1})})be[bf+3]=b.createElement("TextButton",{Text="",AutoButtonColor=false,Size=r(1,1),BackgroundTransparency=1,[b.Event.Activated]=function()pcall(function()hY:TeleportToPlaceInstance(ku.friend.PlaceId,ku.friend.GameId,dT.LocalPlayer)end)end,[b.Event.MouseEnter]=function()return aZ(true)end,[b.Event.MouseLeave]=function()return aZ(false)end})return b.createElement(bk,bc,be)end;lc=i(lf)return{default=f}end,newEnv("Orca.views.Pages.Home.FriendActivityCard"))()end)newModule("Home","ModuleScript","Orca.views.Pages.Home.Home","Orca.views.Pages.Home",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.Parent.include.RuntimeLib)local b=a.import(script,a.getModule(script,"@rbxts","roact").src)local kx=a.import(script,a.getModule(script,"@rbxts","roact-hooked").out).pure;local bk=a.import(script,script.Parent.Parent.Parent.Parent,"components","Canvas").default;local cd=a.import(script,script.Parent.Parent.Parent.Parent,"hooks","use-scale").useScale;local r=a.import(script,script.Parent.Parent.Parent.Parent,"utils","udim2").scale;local lh=a.import(script,script.Parent,"ServerCard","ServerCard").default;local l3=a.import(script,script.Parent,"FriendActivityCard").default;local li=a.import(script,script.Parent,"ProfileCard").default;local lj=a.import(script,script.Parent,"TitleCard").default;local function lk()local ck=cd()return b.createElement(bk,{position=r(0,1),anchor=Vector2.new(0,1)},{b.createElement("UIScale",{Scale=ck}),b.createElement(lj),b.createElement(lh),b.createElement(l3),b.createElement(li)})end;local f=kx(lk)return{default=f}end,newEnv("Orca.views.Pages.Home.Home"))()end)newModule("Home.story","ModuleScript","Orca.views.Pages.Home.Home.story","Orca.views.Pages.Home",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.Parent.include.RuntimeLib)local b=a.import(script,a.getModule(script,"@rbxts","roact").src)local ah=a.import(script,a.getModule(script,"@rbxts","roact-rodux-hooked").out).Provider;local ai=a.import(script,script.Parent.Parent.Parent.Parent,"store","models","dashboard.model").DashboardPage;local aj=a.import(script,script.Parent.Parent.Parent.Parent,"store","store").configureStore;local lk=a.import(script,script.Parent,"Home").default;return function(an)local ao=b.mount(b.createElement(ah,{store=aj({dashboard={isOpen=true,page=ai.Home,hint=nil,apps={}}})},{b.createElement(lk)}),an,"Home")return function()return b.unmount(ao)end end end,newEnv("Orca.views.Pages.Home.Home.story"))()end)newModule("ProfileCard","ModuleScript","Orca.views.Pages.Home.ProfileCard","Orca.views.Pages.Home",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.Parent.include.RuntimeLib)local g={}g.default=a.import(script,script,"ProfileCard").default;return g end,newEnv("Orca.views.Pages.Home.ProfileCard"))()end)newModule("Actions","ModuleScript","Orca.views.Pages.Home.ProfileCard.Actions","Orca.views.Pages.Home.ProfileCard",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.Parent.Parent.include.RuntimeLib)local b=a.import(script,a.getModule(script,"@rbxts","roact").src)local i=a.import(script,a.getModule(script,"@rbxts","roact-hooked").out).hooked;local aQ=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"components","ActionButton").default;local bk=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"components","Canvas").default;local e9=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"hooks","use-theme").useTheme;local am=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"utils","udim2").px;local function kA()local aT=e9("home").profile;return b.createElement(bk,{anchor=Vector2.new(0.5,0),size=am(278,49),position=UDim2.new(0.5,0,0,575)},{b.createElement(aQ,{action="refresh",hint="<font face='GothamBlack'>Refresh</font> your character at this location",theme=aT,image="rbxassetid://8992253511",position=am(0,0)}),b.createElement(aQ,{action="ghost",hint="<font face='GothamBlack'>Spawn a ghost</font> and go to it when disabled",theme=aT,image="rbxassetid://8992253792",position=am(72,0),canDeactivate=true}),b.createElement(aQ,{action="godmode",hint="<font face='GothamBlack'>Set godmode</font>, may break respawn",theme=aT,image="rbxassetid://8992253678",position=am(145,0)}),b.createElement(aQ,{action="freecam",hint="<font face='GothamBlack'>Set freecam</font>, use Q & E to move vertically",theme=aT,image="rbxassetid://8992253933",position=am(217,0),canDeactivate=true})})end;local f=i(kA)return{default=f}end,newEnv("Orca.views.Pages.Home.ProfileCard.Actions"))()end)newModule("Avatar","ModuleScript","Orca.views.Pages.Home.ProfileCard.Avatar","Orca.views.Pages.Home.ProfileCard",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.Parent.Parent.include.RuntimeLib)local b=a.import(script,a.getModule(script,"@rbxts","roact").src)local i=a.import(script,a.getModule(script,"@rbxts","roact-hooked").out).hooked;local dT=a.import(script,a.getModule(script,"@rbxts","services")).Players;local b8=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"components","Border").default;local bk=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"components","Canvas").default;local e9=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"hooks","use-theme").useTheme;local am=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"utils","udim2").px;local ll="https://www.roblox.com/headshot-thumbnail/image?userId="..tostring(dT.LocalPlayer.UserId).."&width=150&height=150&format=png"local function kB()local aT=e9("home").profile;return b.createElement(bk,{anchor=Vector2.new(0.5,0),size=am(186,186),position=UDim2.new(0.5,0,0,24)},{b.createElement("ImageLabel",{Image=ll,Size=am(150,150),Position=am(18,18),BackgroundColor3=aT.avatar.background,BackgroundTransparency=aT.avatar.transparency},{b.createElement("UICorner",{CornerRadius=UDim.new(1,0)})}),b.createElement(b8,{size=4,radius="circular"},{b.createElement("UIGradient",{Color=aT.avatar.gradient.color,Transparency=aT.avatar.gradient.transparency,Rotation=aT.avatar.gradient.rotation})})})end;local f=i(kB)return{default=f}end,newEnv("Orca.views.Pages.Home.ProfileCard.Avatar"))()end)newModule("Info","ModuleScript","Orca.views.Pages.Home.ProfileCard.Info","Orca.views.Pages.Home.ProfileCard",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.Parent.Parent.include.RuntimeLib)local b=a.import(script,a.getModule(script,"@rbxts","roact").src)local i=a.import(script,a.getModule(script,"@rbxts","roact-hooked").out).hooked;local dT=a.import(script,a.getModule(script,"@rbxts","services")).Players;local bk=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"components","Canvas").default;local b_=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"hooks","common","use-delayed-state").useDelayedState;local aL=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"hooks","common","use-spring").useSpring;local c0=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"hooks","use-current-page").useIsPageOpen;local dU=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"hooks","use-friends").useFriends;local e9=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"hooks","use-theme").useTheme;local ai=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"store","models","dashboard.model").DashboardPage;local am=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"utils","udim2").px;local function lm()local aT=e9("home").profile;local c4=c0(ai.Home)local U=dU()local dW=U[1]if dW==nil then dW={}end;local dX=U[3]local ln=#dW;local y=function(dZ)return dZ.PlaceId~=nil and dZ.PlaceId==game.PlaceId end;local d_={}local bf=0;for av,aw in ipairs(dW)do if y(aw,av-1,dW)==true then bf=bf+1;d_[bf]=aw end end;local lo=#d_;local lp=b_(c4,400,function(lq)return not lq end)local lr=b_(c4 and dX~="pending",500,function(lq)return not lq end)local ls=b_(c4 and dX~="pending",600,function(lq)return not lq end)return b.createElement(bk,{anchor=Vector2.new(0.5,0),size=am(278,48),position=UDim2.new(0.5,0,0,300)},{b.createElement("Frame",{Size=am(0,26),Position=am(90,11),BackgroundTransparency=1},{b.createElement("UIStroke",{Thickness=0.5,Color=aT.foreground,Transparency=0.7})}),b.createElement("Frame",{Size=am(0,26),Position=am(187,11),BackgroundTransparency=1},{b.createElement("UIStroke",{Thickness=0.5,Color=aT.foreground,Transparency=0.7})}),b.createElement("TextLabel",{Font="GothamBold",Text="Joined\n"..tostring(os.date("%m/%d/%Y",os.time()-dT.LocalPlayer.AccountAge*24*60*60)),TextSize=13,TextColor3=aT.foreground,TextXAlignment="Center",TextYAlignment="Center",TextTransparency=aL(lp and 0.2 or 1,{}),Size=am(85,48),Position=aL(lp and am(0,0)or am(-20,0),{}),BackgroundTransparency=1}),b.createElement("TextLabel",{Font="GothamBold",Text=lo==1 and"1 friend\njoined"or tostring(lo).." friends\njoined",TextSize=13,TextColor3=aT.foreground,TextXAlignment="Center",TextYAlignment="Center",TextTransparency=aL(lr and 0.2 or 1,{}),Size=am(85,48),Position=aL(lr and am(97,0)or am(97-20,0),{}),BackgroundTransparency=1}),b.createElement("TextLabel",{Font="GothamBold",Text=ln==1 and"1 friend\nonline"or tostring(ln).." friends\nonline",TextSize=13,TextColor3=aT.foreground,TextXAlignment="Center",TextYAlignment="Center",TextTransparency=aL(ls and 0.2 or 1,{}),Size=am(85,48),Position=aL(ls and am(193,0)or am(193-20,0),{}),BackgroundTransparency=1})})end;local f=i(lm)return{default=f}end,newEnv("Orca.views.Pages.Home.ProfileCard.Info"))()end)newModule("ProfileCard","ModuleScript","Orca.views.Pages.Home.ProfileCard.ProfileCard","Orca.views.Pages.Home.ProfileCard",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.Parent.Parent.include.RuntimeLib)local b=a.import(script,a.getModule(script,"@rbxts","roact").src)local i=a.import(script,a.getModule(script,"@rbxts","roact-hooked").out).hooked;local bk=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"components","Canvas").default;local c1=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"components","Card").default;local e9=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"hooks","use-theme").useTheme;local ai=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"store","models","dashboard.model").DashboardPage;local am=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"utils","udim2").px;local kA=a.import(script,script.Parent,"Actions").default;local kB=a.import(script,script.Parent,"Avatar").default;local lm=a.import(script,script.Parent,"Info").default;local lt=a.import(script,script.Parent,"Sliders").default;local kD=a.import(script,script.Parent,"Username").default;local function li()local aT=e9("home").profile;return b.createElement(c1,{index=1,page=ai.Home,theme=aT,size=am(326,648),position=UDim2.new(0,0,1,0)},{b.createElement(bk,{padding={left=24,right=24}},{b.createElement(kB),b.createElement(kD),b.createElement(lm),b.createElement(lt),b.createElement(kA)})})end;local f=i(li)return{default=f}end,newEnv("Orca.views.Pages.Home.ProfileCard.ProfileCard"))()end)newModule("Sliders","ModuleScript","Orca.views.Pages.Home.ProfileCard.Sliders","Orca.views.Pages.Home.ProfileCard",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.Parent.Parent.include.RuntimeLib)local b=a.import(script,a.getModule(script,"@rbxts","roact").src)local h=a.import(script,a.getModule(script,"@rbxts","roact-hooked").out)local i=h.hooked;local cc=h.useBinding;local aH=h.useState;local aI=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"components","BrightButton").default;local bD=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"components","BrightSlider").default;local bk=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"components","Canvas").default;local aJ=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"hooks","common","rodux-hooks")local aK=aJ.useAppDispatch;local p=aJ.useAppSelector;local aL=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"hooks","common","use-spring").useSpring;local e9=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"hooks","use-theme").useTheme;local aM=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"store","actions","dashboard.action")local aN=aM.clearHint;local aO=aM.setHint;local lu=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"store","actions","jobs.action")local aP=lu.setJobActive;local ie=lu.setJobValue;local al=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"utils","udim2")local am=al.px;local r=al.scale;local bB={frequency=5}local lv;local function lt()return b.createElement(bk,{size=am(278,187),position=am(0,368)},{b.createElement(lv,{display="Flight",hint="<font face='GothamBlack'>Configure flight</font> in studs per second",jobName="flight",units="studs/s",min=10,max=100,position=0}),b.createElement(lv,{display="Speed",hint="<font face='GothamBlack'>Configure speed</font> in studs per second",jobName="walkSpeed",units="studs/s",min=0,max=100,position=69}),b.createElement(lv,{display="Jump",hint="<font face='GothamBlack'>Configure height</font> in studs",jobName="jumpHeight",units="studs",min=0,max=500,position=138})})end;local f=lt;local function lw(ku)local aT=e9("home").profile;local aW=aK()local eA=p(function(F)return F.jobs[ku.jobName]end)local U=cc(eA.value)local d1=U[1]local lx=U[2]local dt=aH(false)local aY=dt[1]local aZ=dt[2]local a_=aT.highlight[ku.jobName]local b0;if eA.active then b0=a_ else local b1;if aY then local b2=aT.button.backgroundHovered;if b2==nil then b2=aT.button.background:Lerp(a_,0.1)end;b1=b2 else b1=aT.button.background end;b0=b1 end;local ly=aL(b0,{})local lz=aL(eA.active and aT.button.foregroundAccent and aT.button.foregroundAccent or aT.foreground,{})return b.createElement(bk,{size=am(278,49),position=am(0,ku.position)},{b.createElement(bD,{onValueChanged=lx,onRelease=function()return aW(ie(ku.jobName,math.round(d1:getValue())))end,min=ku.min,max=ku.max,initialValue=eA.value,size=am(181,49),position=am(0,0),radius=8,color=aT.slider.background,accentColor=a_,borderEnabled=aT.slider.outlined,borderColor=aT.slider.foreground,transparency=aT.slider.backgroundTransparency,indicatorTransparency=aT.slider.indicatorTransparency},{b.createElement("TextLabel",{Font="GothamBold",Text=d1:map(function(d1)return tostring(math.round(d1)).." "..ku.units end),TextSize=15,TextColor3=aT.slider.foreground,TextXAlignment="Center",TextYAlignment="Center",TextTransparency=aT.slider.foregroundTransparency,Size=r(1,1),BackgroundTransparency=1})}),b.createElement(aI,{onActivate=function()return aW(aP(ku.jobName,not eA.active))end,onHover=function(aY)if aY then aZ(true)aW(aO(ku.hint))else aZ(false)aW(aN())end end,size=am(85,49),position=am(193,0),radius=8,color=ly,borderEnabled=aT.button.outlined,borderColor=lz,transparency=aT.button.backgroundTransparency},{b.createElement("TextLabel",{Font="GothamBold",Text=ku.display,TextSize=15,TextColor3=lz,TextXAlignment="Center",TextYAlignment="Center",TextTransparency=aL(eA.active and 0 or(aY and aT.button.foregroundTransparency-0.25 or aT.button.foregroundTransparency),{}),Size=r(1,1),BackgroundTransparency=1})})})end;lv=i(lw)return{default=f}end,newEnv("Orca.views.Pages.Home.ProfileCard.Sliders"))()end)newModule("Username","ModuleScript","Orca.views.Pages.Home.ProfileCard.Username","Orca.views.Pages.Home.ProfileCard",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.Parent.Parent.include.RuntimeLib)local b=a.import(script,a.getModule(script,"@rbxts","roact").src)local i=a.import(script,a.getModule(script,"@rbxts","roact-hooked").out).hooked;local dT=a.import(script,a.getModule(script,"@rbxts","services")).Players;local bk=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"components","Canvas").default;local e9=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"hooks","use-theme").useTheme;local al=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"utils","udim2")local am=al.px;local r=al.scale;local function kD()local aT=e9("home").profile;return b.createElement(bk,{anchor=Vector2.new(0.5,0),size=am(278,49),position=UDim2.new(0.5,0,0,231)},{b.createElement("TextLabel",{Font="GothamBlack",Text=dT.LocalPlayer.DisplayName,TextSize=20,TextColor3=aT.foreground,TextXAlignment="Center",TextYAlignment="Top",Size=r(1,1),BackgroundTransparency=1}),b.createElement("TextLabel",{Font="GothamBold",Text=dT.LocalPlayer.Name,TextSize=16,TextColor3=aT.foreground,TextXAlignment="Center",TextYAlignment="Bottom",TextTransparency=0.7,Size=r(1,1),BackgroundTransparency=1})})end;local f=i(kD)return{default=f}end,newEnv("Orca.views.Pages.Home.ProfileCard.Username"))()end)newModule("ServerCard","ModuleScript","Orca.views.Pages.Home.ServerCard","Orca.views.Pages.Home",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.Parent.include.RuntimeLib)local g={}g.default=a.import(script,script,"ServerCard").default;return g end,newEnv("Orca.views.Pages.Home.ServerCard"))()end)newModule("ServerAction","ModuleScript","Orca.views.Pages.Home.ServerCard.ServerAction","Orca.views.Pages.Home.ServerCard",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.Parent.Parent.include.RuntimeLib)local b=a.import(script,a.getModule(script,"@rbxts","roact").src)local h=a.import(script,a.getModule(script,"@rbxts","roact-hooked").out)local i=h.hooked;local aH=h.useState;local aI=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"components","BrightButton").default;local aJ=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"hooks","common","rodux-hooks")local aK=aJ.useAppDispatch;local p=aJ.useAppSelector;local aL=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"hooks","common","use-spring").useSpring;local e9=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"hooks","use-theme").useTheme;local aM=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"store","actions","dashboard.action")local aN=aM.clearHint;local aO=aM.setHint;local aP=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"store","actions","jobs.action").setJobActive;local al=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"utils","udim2")local am=al.px;local r=al.scale;local function lA(C)local aR=C.action;local aS=C.hint;local lB=C.icon;local L=C.size;local M=C.position;local aW=aK()local aT=e9("home").server[aR=="switchServer"and"switchButton"or"rejoinButton"]local aX=p(function(F)return F.jobs[aR].active end)local U=aH(false)local aY=U[1]local aZ=U[2]local b0;if aX then b0=aT.accent else local b1;if aY then local b2=aT.backgroundHovered;if b2==nil then b2=aT.background:Lerp(aT.accent,0.1)end;b1=b2 else b1=aT.background end;b0=b1 end;local b3=aL(b0,{})local b4=aL(aX and aT.foregroundAccent and aT.foregroundAccent or aT.foreground,{})return b.createElement(aI,{onActivate=function()return aW(aP(aR,not aX))end,onHover=function(aY)if aY then aZ(true)aW(aO(aS))else aZ(false)aW(aN())end end,size=L,position=M,radius=8,color=b3,borderEnabled=aT.outlined,borderColor=b4,transparency=aT.backgroundTransparency},{b.createElement("ImageLabel",{Image=lB,ImageColor3=b4,ImageTransparency=aL(aX and 0 or(aY and aT.foregroundTransparency-0.25 or aT.foregroundTransparency),{}),AnchorPoint=Vector2.new(0.5,0.5),Size=am(36,36),Position=r(0.5,0.5),BackgroundTransparency=1})})end;local f=i(lA)return{default=f}end,newEnv("Orca.views.Pages.Home.ServerCard.ServerAction"))()end)newModule("ServerCard","ModuleScript","Orca.views.Pages.Home.ServerCard.ServerCard","Orca.views.Pages.Home.ServerCard",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.Parent.Parent.include.RuntimeLib)local b=a.import(script,a.getModule(script,"@rbxts","roact").src)local i=a.import(script,a.getModule(script,"@rbxts","roact-hooked").out).hooked;local dT=a.import(script,a.getModule(script,"@rbxts","services")).Players;local c1=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"components","Card").default;local cv=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"constants").IS_DEV;local e9=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"hooks","use-theme").useTheme;local ai=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"store","models","dashboard.model").DashboardPage;local am=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"utils","udim2").px;local lA=a.import(script,script.Parent,"ServerAction").default;local lC=a.import(script,script.Parent,"StatusLabel").default;local function lh()local aT=e9("home").server;return b.createElement(c1,{index=2,page=ai.Home,theme=aT,size=am(326,184),position=UDim2.new(0,374,1,-416-48)},{b.createElement("TextLabel",{Text="Server",Font="GothamBlack",TextSize=20,TextColor3=aT.foreground,TextXAlignment="Left",TextYAlignment="Top",Position=am(24,24),BackgroundTransparency=1}),b.createElement(lC,{offset=69,units="players",getValue=function()return tostring(#dT:GetPlayers()).." / "..tostring(dT.MaxPlayers)end}),b.createElement(lC,{offset=108,units="elapsed",getValue=function()local lD=cv and os.clock()or time()local lE=math.floor(lD/86400)local lF=math.floor((lD-lE*86400)/3600)local lG=math.floor((lD-lE*86400-lF*3600)/60)local lH=math.floor(lD-lE*86400-lF*3600-lG*60)return lE>0 and tostring(lE).." days"or(lF>0 and tostring(lF).." hours"or(lG>0 and tostring(lG).." minutes"or tostring(lH).." seconds"))end}),b.createElement(lC,{offset=147,units="ping",getValue=function()return tostring(math.round(dT.LocalPlayer:GetNetworkPing()*1000)).." ms"end}),b.createElement(lA,{action="switchServer",hint="<font face='GothamBlack'>Switch</font> to a different server",icon="rbxassetid://8992259774",size=am(66,50),position=UDim2.new(1,-66-24,1,-100-16-12)}),b.createElement(lA,{action="rejoinServer",hint="<font face='GothamBlack'>Rejoin</font> this server",icon="rbxassetid://8992259894",size=am(66,50),position=UDim2.new(1,-66-24,1,-50-16)})})end;local f=i(lh)return{default=f}end,newEnv("Orca.views.Pages.Home.ServerCard.ServerCard"))()end)newModule("StatusLabel","ModuleScript","Orca.views.Pages.Home.ServerCard.StatusLabel","Orca.views.Pages.Home.ServerCard",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.Parent.Parent.include.RuntimeLib)local b=a.import(script,a.getModule(script,"@rbxts","roact").src)local h=a.import(script,a.getModule(script,"@rbxts","roact-hooked").out)local i=h.hooked;local l=h.useMemo;local aH=h.useState;local k0=a.import(script,a.getModule(script,"@rbxts","services")).TextService;local df=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"hooks","common","use-interval").useInterval;local e9=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"hooks","use-theme").useTheme;local am=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"utils","udim2").px;local function lC(C)local ct=C.offset;local lI=C.units;local lJ=C.getValue;local aT=e9("home").server;local U=aH(lJ)local d1=U[1]local lx=U[2]local lK=l(function()return k0:GetTextSize(d1 .." ",16,"GothamBold",Vector2.new()).X end,{d1})df(function()lx(lJ())end,1000)return b.createFragment({b.createElement("TextLabel",{Text=d1,RichText=true,Font="GothamBold",TextSize=16,TextColor3=aT.foreground,TextXAlignment="Left",TextYAlignment="Top",Position=am(24,ct),BackgroundTransparency=1}),b.createElement("TextLabel",{Text=lI,RichText=true,Font="GothamBold",TextSize=16,TextColor3=aT.foreground,TextTransparency=0.4,TextXAlignment="Left",TextYAlignment="Top",Position=am(24+lK,ct),BackgroundTransparency=1})})end;local f=i(lC)return{default=f}end,newEnv("Orca.views.Pages.Home.ServerCard.StatusLabel"))()end)newModule("TitleCard","ModuleScript","Orca.views.Pages.Home.TitleCard","Orca.views.Pages.Home",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.Parent.include.RuntimeLib)local b=a.import(script,a.getModule(script,"@rbxts","roact").src)local i=a.import(script,a.getModule(script,"@rbxts","roact-hooked").out).hooked;local bk=a.import(script,script.Parent.Parent.Parent.Parent,"components","Canvas").default;local c1=a.import(script,script.Parent.Parent.Parent.Parent,"components","Card").default;local lL=a.import(script,script.Parent.Parent.Parent.Parent,"constants")local cv=lL.IS_DEV;local cw=lL.VERSION_TAG;local b_=a.import(script,script.Parent.Parent.Parent.Parent,"hooks","common","use-delayed-state").useDelayedState;local aL=a.import(script,script.Parent.Parent.Parent.Parent,"hooks","common","use-spring").useSpring;local c0=a.import(script,script.Parent.Parent.Parent.Parent,"hooks","use-current-page").useIsPageOpen;local e9=a.import(script,script.Parent.Parent.Parent.Parent,"hooks","use-theme").useTheme;local ai=a.import(script,script.Parent.Parent.Parent.Parent,"store","models","dashboard.model").DashboardPage;local am=a.import(script,script.Parent.Parent.Parent.Parent,"utils","udim2").px;local lM;local function lj()local aT=e9("home").title;return b.createElement(c1,{index=0,page=ai.Home,theme=aT,size=am(326,184),position=UDim2.new(0,0,1,-648-48)},{b.createElement("ImageLabel",{Image="rbxassetid://8992263675",Size=am(387*0.85,473*0.85),Position=am(75,18),Rotation=5,BackgroundTransparency=1,ZIndex=cv and 1 or 2}),b.createElement(bk,{padding={top=24,left=24}},{b.createElement(lM,{index=0,text="Orca",font=Enum.Font.GothamBlack,size=20,position=am(0,0)}),b.createElement(lM,{index=1,text=cw,position=am(0,40)}),b.createElement(lM,{index=2,text="By 0866",position=am(0,63),transparency=0.15}),b.createElement(lM,{index=3,text="Powered by TS",position=am(0,86),transparency=0.3}),b.createElement(lM,{index=4,text="richie0866/orca",position=UDim2.new(0,0,1,-40),transparency=0.45})})})end;local f=i(lj)local function lN(ku)local U=ku;local c2=U.index;local kX=U.text;local lO=U.font;if lO==nil then lO=Enum.Font.GothamBold end;local L=U.size;if L==nil then L=16 end;local M=U.position;local ba=U.transparency;if ba==nil then ba=0 end;local aT=e9("home").title;local c4=c0(ai.Home)local c5=b_(c4,c2*100+300,function(hp)return not hp end)local bc={Text=kX,Font=lO,TextColor3=aT.foreground,TextSize=L,TextTransparency=aL(c5 and ba or 1,{frequency=2}),TextXAlignment="Left",TextYAlignment="Top",Size=am(200,24)}local b0;if c5 then b0=M else local y=am(24,0)b0=M-y end;bc.Position=aL(b0,{})bc.BackgroundTransparency=1;return b.createElement("TextLabel",bc)end;lM=i(lN)return{default=f}end,newEnv("Orca.views.Pages.Home.TitleCard"))()end)newModule("Options","ModuleScript","Orca.views.Pages.Options","Orca.views.Pages",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.include.RuntimeLib)local g={}g.default=a.import(script,script,"Options").default;return g end,newEnv("Orca.views.Pages.Options"))()end)newModule("Options","ModuleScript","Orca.views.Pages.Options.Options","Orca.views.Pages.Options",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.Parent.include.RuntimeLib)local b=a.import(script,a.getModule(script,"@rbxts","roact").src)local kx=a.import(script,a.getModule(script,"@rbxts","roact-hooked").out).pure;local bk=a.import(script,script.Parent.Parent.Parent.Parent,"components","Canvas").default;local cd=a.import(script,script.Parent.Parent.Parent.Parent,"hooks","use-scale").useScale;local r=a.import(script,script.Parent.Parent.Parent.Parent,"utils","udim2").scale;local lP=a.import(script,script.Parent,"ThemesCard","ThemesCard").default;local function lQ()local ck=cd()return b.createElement(bk,{position=r(0,1),anchor=Vector2.new(0,1)},{b.createElement("UIScale",{Scale=ck}),b.createElement(lP)})end;local f=kx(lQ)return{default=f}end,newEnv("Orca.views.Pages.Options.Options"))()end)newModule("ThemesCard","ModuleScript","Orca.views.Pages.Options.ThemesCard","Orca.views.Pages.Options",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.Parent.include.RuntimeLib)local g={}g.default=a.import(script,script,"ThemesCard").default;return g end,newEnv("Orca.views.Pages.Options.ThemesCard"))()end)newModule("ThemeItem","ModuleScript","Orca.views.Pages.Options.ThemesCard.ThemeItem","Orca.views.Pages.Options.ThemesCard",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.Parent.Parent.include.RuntimeLib)local b=a.import(script,a.getModule(script,"@rbxts","roact").src)local h=a.import(script,a.getModule(script,"@rbxts","roact-hooked").out)local i=h.hooked;local aH=h.useState;local b8=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"components","Border").default;local bk=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"components","Canvas").default;local bl=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"components","Fill").default;local bm=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"components","Glow")local bn=bm.default;local bo=bm.GlowRadius;local aJ=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"hooks","common","rodux-hooks")local aK=aJ.useAppDispatch;local p=aJ.useAppSelector;local aL=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"hooks","common","use-spring").useSpring;local e9=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"hooks","use-theme").useTheme;local ih=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"store","actions","theme.action").setTheme;local kq=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"utils","color3")local ji=kq.getLuminance;local ak=kq.hex;local jU=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"utils","number-util").lerp;local al=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"utils","udim2")local am=al.px;local r=al.scale;local kE=20;local kF=60;local kG=326-24*2;local kH=16;local lR;local function lS(C)local aT=C.theme;local c2=C.index;local aW=aK()local lT=e9("options").themes.themeButton;local kW=p(function(F)return F.theme.current.name==aT.name end)local U=aH(false)local aY=U[1]local aZ=U[2]local b0;if kW then b0=lT.accent else local b1;if aY then local b2=lT.backgroundHovered;if b2==nil then b2=lT.background:Lerp(lT.accent,0.1)end;b1=b2 else b1=lT.background end;b0=b1 end;local b3=aL(b0,{})local b1;if kW then b1=lT.accent else local fc;if aY then local b2=lT.backgroundHovered;if b2==nil then b2=lT.dropshadow:Lerp(lT.accent,0.5)end;fc=b2 else fc=lT.dropshadow end;b1=fc end;local k_=aL(b1,{})local b4=aL(kW and lT.foregroundAccent and lT.foregroundAccent or lT.foreground,{})local bc={size=am(kG,kF),position=am(0,(kE+kF)*c2),zIndex=c2}local be={b.createElement(bn,{radius=bo.Size70,color=k_,size=UDim2.new(1,36,1,36),position=am(-18,5-18),transparency=aL(kW and lT.glowTransparency or(aY and jU(lT.dropshadowTransparency,lT.glowTransparency,0.5)or lT.dropshadowTransparency),{})}),b.createElement(bl,{color=b3,transparency=lT.backgroundTransparency,radius=8}),b.createElement("TextLabel",{Text=aT.name,Font="GothamBold",TextSize=16,TextColor3=b4,TextXAlignment=Enum.TextXAlignment.Left,TextYAlignment=Enum.TextYAlignment.Center,TextTransparency=aL(kW and 0 or(aY and lT.foregroundTransparency/2 or lT.foregroundTransparency),{}),BackgroundTransparency=1,Position=am(kH,1),Size=UDim2.new(1,-kH,1,-1),ClipsDescendants=true}),b.createElement(lR,{color=b3,previewTheme=aT.preview})}local bf=#be;local bv=lT.outlined and b.createElement(b8,{color=b4,transparency=0.8,radius=8})if bv then if bv.elements~=nil or bv.props~=nil and bv.component~=nil then be[bf+1]=bv else for av,aw in ipairs(bv)do be[bf+av]=aw end end end;bf=#be;be[bf+1]=b.createElement("TextButton",{[b.Event.Activated]=function()return not kW and aW(ih(aT))end,[b.Event.MouseEnter]=function()return aZ(true)end,[b.Event.MouseLeave]=function()return aZ(false)end,Text="",Transparency=1,Size=r(1,1)})return b.createElement(bk,bc,be)end;local f=i(lS)function lR(C)local b9=C.color;local lU=C.previewTheme;return b.createElement("Frame",{AnchorPoint=Vector2.new(1,0),Size=UDim2.new(0,114,1,-4),Position=UDim2.new(1,-2,0,2),BackgroundColor3=b9,Transparency=1,BorderSizePixel=0},{b.createElement("UICorner",{CornerRadius=UDim.new(0,6)}),b.createElement("Frame",{AnchorPoint=Vector2.new(0,0.5),Size=am(25,25),Position=UDim2.new(0,12,0.5,0),BackgroundColor3=ak("#ffffff"),BorderSizePixel=0},{b.createElement("UICorner",{CornerRadius=UDim.new(1,0)}),b.createElement("UIGradient",{Color=lU.foreground.color,Transparency=lU.foreground.transparency,Rotation=lU.foreground.rotation}),b.createElement("UIStroke",{Color=ji(lU.foreground.color)>0.5 and ak("#000000")or ak("#ffffff"),Transparency=0.5,Thickness=2})}),b.createElement("Frame",{AnchorPoint=Vector2.new(0.5,0.5),Size=am(25,25),Position=UDim2.new(0.5,0,0.5,0),BackgroundColor3=ak("#ffffff"),BorderSizePixel=0},{b.createElement("UICorner",{CornerRadius=UDim.new(1,0)}),b.createElement("UIGradient",{Color=lU.background.color,Transparency=lU.background.transparency,Rotation=lU.background.rotation}),b.createElement("UIStroke",{Color=ji(lU.background.color)>0.5 and ak("#000000")or ak("#ffffff"),Transparency=0.5,Thickness=2})}),b.createElement("Frame",{AnchorPoint=Vector2.new(1,0.5),Size=am(25,25),Position=UDim2.new(1,-12,0.5,0),BackgroundColor3=ak("#ffffff"),BorderSizePixel=0},{b.createElement("UICorner",{CornerRadius=UDim.new(1,0)}),b.createElement("UIGradient",{Color=lU.accent.color,Transparency=lU.accent.transparency,Rotation=lU.accent.rotation}),b.createElement("UIStroke",{Color=ji(lU.accent.color)>0.5 and ak("#000000")or ak("#ffffff"),Transparency=0.5,Thickness=2})})})end;return{PADDING=kE,ENTRY_HEIGHT=kF,ENTRY_WIDTH=kG,ENTRY_TEXT_PADDING=kH,default=f}end,newEnv("Orca.views.Pages.Options.ThemesCard.ThemeItem"))()end)newModule("ThemesCard","ModuleScript","Orca.views.Pages.Options.ThemesCard.ThemesCard","Orca.views.Pages.Options.ThemesCard",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.Parent.Parent.include.RuntimeLib)local b=a.import(script,a.getModule(script,"@rbxts","roact").src)local h=a.import(script,a.getModule(script,"@rbxts","roact-hooked").out)local i=h.hooked;local l=h.useMemo;local bk=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"components","Canvas").default;local c1=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"components","Card").default;local e9=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"hooks","use-theme").useTheme;local ai=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"store","models","dashboard.model").DashboardPage;local ix=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"themes").getThemes;local jc=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"utils","array-util").arrayToMap;local al=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"utils","udim2")local am=al.px;local r=al.scale;local lV=a.import(script,script.Parent,"ThemeItem")local lS=lV.default;local kF=lV.ENTRY_HEIGHT;local kE=lV.PADDING;local function lP()local aT=e9("options").themes;local iw=l(ix,{})local bc={index=0,page=ai.Options,theme=aT,size=am(326,416),position=UDim2.new(0,0,1,0)}local be={b.createElement("TextLabel",{Text="Themes",Font="GothamBlack",TextSize=20,TextColor3=aT.foreground,TextXAlignment="Left",TextYAlignment="Top",Position=am(24,24),BackgroundTransparency=1})}local bf=#be;local bg={size=am(326,348),position=am(0,68),padding={left=24,right=24,top=8},clipsDescendants=true}local bh={}local bi=#bh;local l9={Size=r(1,1),CanvasSize=am(0,#iw*(kF+kE)+kE),BackgroundTransparency=1,BorderSizePixel=0,ScrollBarImageTransparency=1,ScrollBarThickness=0,ClipsDescendants=false}local la={}local lb=#la;for av,aw in pairs(jc(iw,function(aT,c2)return{aT.name,b.createElement(lS,{theme=aT,index=c2})}end))do la[av]=aw end;bh[bi+1]=b.createElement("ScrollingFrame",l9,la)be[bf+1]=b.createElement(bk,bg,bh)return b.createElement(c1,bc,be)end;local f=i(lP)return{default=f}end,newEnv("Orca.views.Pages.Options.ThemesCard.ThemesCard"))()end)newModule("Pages","ModuleScript","Orca.views.Pages.Pages","Orca.views.Pages",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.include.RuntimeLib)local b=a.import(script,a.getModule(script,"@rbxts","roact").src)local i=a.import(script,a.getModule(script,"@rbxts","roact-hooked").out).hooked;local b_=a.import(script,script.Parent.Parent.Parent,"hooks","common","use-delayed-state").useDelayedState;local dS=a.import(script,script.Parent.Parent.Parent,"hooks","use-current-page").useCurrentPage;local ai=a.import(script,script.Parent.Parent.Parent,"store","models","dashboard.model").DashboardPage;local kz=a.import(script,script.Parent,"Apps").default;local lk=a.import(script,script.Parent,"Home").default;local lQ=a.import(script,script.Parent,"Options").default;local lW=a.import(script,script.Parent,"Scripts").default;local function ka()local lX=dS()local lY=b_(lX==ai.Scripts,2000,function(lZ)return lZ end)local be={home=b.createFragment({home=b.createElement(lk)}),apps=b.createFragment({apps=b.createElement(kz)})}local bf=#be;local bv=lY and b.createFragment({scripts=b.createElement(lW)})if bv then if bv.elements~=nil or bv.props~=nil and bv.component~=nil then be[bf+1]=bv else for av,aw in ipairs(bv)do be[bf+av]=aw end end end;bf=#be;be.options=b.createFragment({options=b.createElement(lQ)})return b.createFragment(be)end;local f=i(ka)return{default=f}end,newEnv("Orca.views.Pages.Pages"))()end)newModule("Scripts","ModuleScript","Orca.views.Pages.Scripts","Orca.views.Pages",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.include.RuntimeLib)local g={}g.default=a.import(script,script,"Scripts").default;return g end,newEnv("Orca.views.Pages.Scripts"))()end)newModule("Content","ModuleScript","Orca.views.Pages.Scripts.Content","Orca.views.Pages.Scripts",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.Parent.include.RuntimeLib)local b=a.import(script,a.getModule(script,"@rbxts","roact").src)local i=a.import(script,a.getModule(script,"@rbxts","roact-hooked").out).hooked;local bk=a.import(script,script.Parent.Parent.Parent.Parent,"components","Canvas").default;local cd=a.import(script,script.Parent.Parent.Parent.Parent,"hooks","use-scale").useScale;local ak=a.import(script,script.Parent.Parent.Parent.Parent,"utils","color3").hex;local al=a.import(script,script.Parent.Parent.Parent.Parent,"utils","udim2")local am=al.px;local r=al.scale;local l_,m0;local function m1(C)local m2=C.header;local m3=C.body;local m4=C.footer;local ck=cd()local bc={padding={top=ck:map(function(bd)return bd*48 end),left=ck:map(function(bd)return bd*48 end),bottom=ck:map(function(bd)return bd*48 end),right=ck:map(function(bd)return bd*48 end)}}local be={m3~=nil and b.createElement(l_,{header=m2,scaleFactor=ck})or b.createElement(m0,{header=m2,scaleFactor=ck})}local bf=#be;local bv=m3~=nil and b.createElement("TextLabel",{Text=m3,TextColor3=ak("#FFFFFF"),Font="GothamBlack",TextSize=36,TextXAlignment="Left",TextYAlignment="Top",Size=r(1,70/416),Position=ck:map(function(bd)return am(0,110*bd)end),BackgroundTransparency=1},{b.createElement("UIScale",{Scale=ck})})if bv then if bv.elements~=nil or bv.props~=nil and bv.component~=nil then be[bf+1]=bv else for av,aw in ipairs(bv)do be[bf+av]=aw end end end;bf=#be;be[bf+1]=b.createElement("TextLabel",{Text=m4,TextColor3=ak("#FFFFFF"),Font="GothamBlack",TextSize=18,TextXAlignment="Center",TextYAlignment="Bottom",AnchorPoint=Vector2.new(0.5,1),Size=r(1,20/416),Position=r(0.5,1),BackgroundTransparency=1},{b.createElement("UIScale",{Scale=ck})})return b.createElement(bk,bc,be)end;function l_(ku)return b.createElement("TextLabel",{Text=ku.header,TextColor3=ak("#FFFFFF"),Font="GothamBlack",TextSize=64,TextXAlignment="Left",TextYAlignment="Top",Size=r(1,70/416),BackgroundTransparency=1},{b.createElement("UIScale",{Scale=ku.scaleFactor})})end;function m0(ku)return b.createElement("TextLabel",{Text=ku.header,TextColor3=ak("#FFFFFF"),Font="GothamBlack",TextSize=48,TextXAlignment="Center",TextYAlignment="Center",AnchorPoint=Vector2.new(0.5,0.5),Size=r(1,1),Position=r(0.5,0.5),BackgroundTransparency=1},{b.createElement("UIScale",{Scale=ku.scaleFactor})})end;local f=i(m1)return{default=f}end,newEnv("Orca.views.Pages.Scripts.Content"))()end)newModule("ScriptCard","ModuleScript","Orca.views.Pages.Scripts.ScriptCard","Orca.views.Pages.Scripts",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.Parent.include.RuntimeLib)local bw=a.import(script,a.getModule(script,"@rbxts","flipper").src).Spring;local b=a.import(script,a.getModule(script,"@rbxts","roact").src)local h=a.import(script,a.getModule(script,"@rbxts","roact-hooked").out)local i=h.hooked;local k=h.useEffect;local b8=a.import(script,script.Parent.Parent.Parent.Parent,"components","Border").default;local bk=a.import(script,script.Parent.Parent.Parent.Parent,"components","Canvas").default;local bl=a.import(script,script.Parent.Parent.Parent.Parent,"components","Fill").default;local cr=a.import(script,script.Parent.Parent.Parent.Parent,"components","ParallaxImage").default;local by=a.import(script,script.Parent.Parent.Parent.Parent,"hooks","common","flipper-hooks")local bz=by.getBinding;local bA=by.useMotor;local b_=a.import(script,script.Parent.Parent.Parent.Parent,"hooks","common","use-delayed-state").useDelayedState;local da=a.import(script,script.Parent.Parent.Parent.Parent,"hooks","common","use-did-mount").useIsMount;local db=a.import(script,script.Parent.Parent.Parent.Parent,"hooks","common","use-forced-update").useForcedUpdate;local di=a.import(script,script.Parent.Parent.Parent.Parent,"hooks","common","use-mouse-location").useMouseLocation;local dy=a.import(script,script.Parent.Parent.Parent.Parent,"hooks","common","use-set-state").default;local aL=a.import(script,script.Parent.Parent.Parent.Parent,"hooks","common","use-spring").useSpring;local dO=a.import(script,script.Parent.Parent.Parent.Parent,"hooks","common","use-viewport-size").useViewportSize;local c0=a.import(script,script.Parent.Parent.Parent.Parent,"hooks","use-current-page").useIsPageOpen;local ai=a.import(script,script.Parent.Parent.Parent.Parent,"store","models","dashboard.model").DashboardPage;local ak=a.import(script,script.Parent.Parent.Parent.Parent,"utils","color3").hex;local r=a.import(script,script.Parent.Parent.Parent.Parent,"utils","udim2").scale;local m5={dampingRatio=3,frequency=2}local function m6(C)local c2=C.index;local m7=C.backgroundImage;local m8=C.backgroundImageSize;local k_=C.dropshadow;local m9=C.dropshadowSize;local ma=C.dropshadowPosition;local mb=C.anchorPoint;local L=C.size;local M=C.position;local br=C.onActivate;local bb=C[b.Children]local mc=db()local md=c0(ai.Scripts)local b0;if da()then b0=false else b0=md end;local c4=b0;local me=b_(c4,c2*30)k(function()return mc()end,{})local mf=bA({0,0})local mg=bz(mf)local kh=dO()local ct=b.joinBindings({viewportSize=kh,mouseLocation=mg}):map(function(bj)local kh=bj.viewportSize;local U=bj.mouseLocation;local bU=U[1]local eD=U[2]return Vector2.new((bU-kh.X/2)/kh.X,(eD-kh.Y/2)/kh.Y)end)di(function(u)mf:setGoal({bw.new(u.X,{dampingRatio=5}),bw.new(u.Y,{dampingRatio=5})})end)local U=dy({isHovered=false,isPressed=false})local dt=U[1]local kw=dt.isHovered;local mh=dt.isPressed;local mi=U[2]local bc={anchor=mb,size=L}local b1;if me then b1=M else local c6=UDim2.new(0,0,1,48*3+56)b1=M+c6 end;bc.position=aL(b1,{frequency=2.2,dampingRatio=0.75})local be={}local bf=#be;local bg={anchor=Vector2.new(0.5,0.5),size=aL(kw and not mh and UDim2.new(1,48,1,48)or r(1,1),{frequency=2}),position=r(0.5,0.5)}local bh={b.createElement("ImageLabel",{Image=k_,AnchorPoint=Vector2.new(0.5,0.5),Size=r(m9.X,m9.Y),Position=r(ma.X,ma.Y),BackgroundTransparency=1}),b.createElement(cr,{image=m7,imageSize=m8,padding=Vector2.new(50,50),offset=ct},{b.createElement("UICorner",{CornerRadius=UDim.new(0,16)})})}local bi=#bh;local l9={clipsDescendants=true}local la={}local lb=#la;if bb then for av,aw in pairs(bb)do if type(av)=="number"then la[lb+av]=aw else la[av]=aw end end end;bh[bi+1]=b.createElement(bk,l9,la)bh[bi+2]=b.createElement(bl,{radius=16,color=ak("#ffffff"),transparency=aL(kw and 0 or 1,m5)},{b.createElement("UIGradient",{Transparency=NumberSequence.new(0.75,1),Offset=aL(kw and Vector2.new(0,0)or Vector2.new(-1,-1),m5),Rotation=45})})bh[bi+3]=b.createElement(b8,{radius=18,size=3,color=ak("#ffffff"),transparency=aL(kw and 0 or 1,m5)},{b.createElement("UIGradient",{Transparency=NumberSequence.new(0.7,0.9),Offset=aL(kw and Vector2.new(0,0)or Vector2.new(-1,-1),m5),Rotation=45})})bh[bi+4]=b.createElement(b8,{color=ak("#ffffff"),radius=16,transparency=aL(kw and 1 or 0.8,{})})be[bf+1]=b.createElement(bk,bg,bh)be[bf+2]=b.createElement("TextButton",{[b.Event.Activated]=function()return br()end,[b.Event.MouseEnter]=function()return mi({isHovered=true})end,[b.Event.MouseLeave]=function()return mi({isHovered=false,isPressed=false})end,[b.Event.MouseButton1Down]=function()return mi({isPressed=true})end,[b.Event.MouseButton1Up]=function()return mi({isPressed=false})end,Size=r(1,1),Text="",Transparency=1})return b.createElement(bk,bc,be)end;local f=i(m6)return{default=f}end,newEnv("Orca.views.Pages.Scripts.ScriptCard"))()end)newModule("Scripts","ModuleScript","Orca.views.Pages.Scripts.Scripts","Orca.views.Pages.Scripts",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.Parent.include.RuntimeLib)local b=a.import(script,a.getModule(script,"@rbxts","roact").src)local kx=a.import(script,a.getModule(script,"@rbxts","roact-hooked").out).pure;local bk=a.import(script,script.Parent.Parent.Parent.Parent,"components","Canvas").default;local hZ=a.import(script,script.Parent.Parent.Parent.Parent,"utils","http")local r=a.import(script,script.Parent.Parent.Parent.Parent,"utils","udim2").scale;local lL=a.import(script,script.Parent,"constants")local mj=lL.BASE_PADDING;local mk=lL.BASE_WINDOW_HEIGHT;local m1=a.import(script,script.Parent,"Content").default;local m6=a.import(script,script.Parent,"ScriptCard").default;local ml=a.async(function(jL,mm)local mn,mo=a.try(function()local mp=a.await(hZ.get(jL))local jJ,du=loadstring(mp,"@"..mm)local dx="Failed to call loadstring on Lua script from '"..jL.."': "..tostring(du)assert(jJ,dx)task.defer(jJ)end,function(mq)warn("Failed to run Lua script from '"..jL.."': "..tostring(mq))return a.TRY_RETURN,{""}end)if mn then return unpack(mo)end end)local function lW()return b.createElement(bk,{position=r(0,1),anchor=Vector2.new(0,1)},{b.createElement(m6,{onActivate=function()return ml("https://solarishub.dev/script.lua","Solaris")end,index=4,backgroundImage="rbxassetid://8992292705",backgroundImageSize=Vector2.new(1023,682),dropshadow="rbxassetid://8992292536",dropshadowSize=Vector2.new(1.15,1.25),dropshadowPosition=Vector2.new(0.5,0.55),anchorPoint=Vector2.new(0,0),size=UDim2.new(1/3,-mj*2/3,(416+mj/2)/mk,-mj/2),position=r(0,0)},{b.createElement(m1,{header="Solaris",body="A collection\nof your favorite\nscripts.",footer="solarishub.dev"})}),b.createElement(m6,{onActivate=function()return ml("https://raw.githubusercontent.com/1201for/V.G-Hub/main/V.Ghub","V.G Hub")end,index=1,backgroundImage="rbxassetid://8992292381",backgroundImageSize=Vector2.new(1021,1023),dropshadow="rbxassetid://8992291993",dropshadowSize=Vector2.new(1.15,1.25),dropshadowPosition=Vector2.new(0.5,0.55),anchorPoint=Vector2.new(0,1),size=UDim2.new(1/3,-mj*2/3,(416+mj/2)/mk,-mj/2),position=r(0,1)},{b.createElement(m1,{header="V.G Hub",body="Featuring over\n100 games.",footer="github.com/1201for"})}),b.createElement(m6,{onActivate=function()return ml("https://raw.githubusercontent.com/CMD-X/CMD-X/master/Source","CMD-X")end,index=5,backgroundImage="rbxassetid://8992291779",backgroundImageSize=Vector2.new(818,1023),dropshadow="rbxassetid://8992291581",dropshadowSize=Vector2.new(1.15,1.4),dropshadowPosition=Vector2.new(0.5,0.6),anchorPoint=Vector2.new(0.5,0),size=UDim2.new(1/3,-mj*2/3,(242+mj/2)/mk,-mj/2),position=r(0.5,0)},{b.createElement(m1,{header="CMD-X",footer="github.com/CMD-X"})}),b.createElement(m6,{onActivate=function()return ml("https://raw.githubusercontent.com/EdgeIY/infiniteyield/master/source","Infinite Yield")end,index=3,backgroundImage="rbxassetid://8992291444",backgroundImageSize=Vector2.new(1023,682),dropshadow="rbxassetid://8992291268",dropshadowSize=Vector2.new(1.15,1.4),dropshadowPosition=Vector2.new(0.5,0.6),anchorPoint=Vector2.new(0.5,0),size=UDim2.new(1/3,-mj*2/3,(242+mj)/mk,-mj),position=UDim2.new(0.5,0,1-(590+mj/2)/mk,mj/2)},{b.createElement(m1,{header="Infinite Yield",footer="github.com/EdgeIY"})}),b.createElement(m6,{onActivate=function()return ml("https://pastebin.com/raw/mMbsHWiQ","Dex Explorer")end,index=1,backgroundImage="rbxassetid://8992290931",backgroundImageSize=Vector2.new(818,1023),dropshadow="rbxassetid://8992291101",dropshadowSize=Vector2.new(1.15,1.35),dropshadowPosition=Vector2.new(0.5,0.55),anchorPoint=Vector2.new(0.5,1),size=UDim2.new(1/3,-mj*2/3,(300+mj/2)/mk,-mj/2),position=r(0.5,1)},{b.createElement(m1,{header="Dex Explorer",footer="github.com/LorekeeperZinnia"})}),b.createElement(m6,{onActivate=function()return ml("https://raw.githubusercontent.com/ic3w0lf22/Unnamed-ESP/master/UnnamedESP.lua","Unnamed ESP")end,index=6,backgroundImage="rbxassetid://8992290714",backgroundImageSize=Vector2.new(1023,682),dropshadow="rbxassetid://8992290570",dropshadowSize=Vector2.new(1.15,1.35),dropshadowPosition=Vector2.new(0.5,0.55),anchorPoint=Vector2.new(1,0),size=UDim2.new(1/3,-mj*2/3,(300+mj/2)/mk,-mj/2),position=r(1,0)},{b.createElement(m1,{header="Unnamed ESP",footer="github.com/ic3w0lf22"})}),b.createElement(m6,{onActivate=function()return ml("https://projectevo.xyz/script/loader.lua","EvoV2")end,index=2,backgroundImage="rbxassetid://8992290314",backgroundImageSize=Vector2.new(682,1023),dropshadow="rbxassetid://8992290105",dropshadowSize=Vector2.new(1.15,1.22),dropshadowPosition=Vector2.new(0.5,0.53),anchorPoint=Vector2.new(1,1),size=UDim2.new(1/3,-mj*2/3,(532+mj/2)/mk,-mj/2),position=r(1,1)},{b.createElement(m1,{header="EvoV2",body="Reliable cheats for\nRoblox's top shooter\ngames, reimagined.",footer="projectevo.xyz"})})})end;local f=kx(lW)return{default=f}end,newEnv("Orca.views.Pages.Scripts.Scripts"))()end)newModule("constants","ModuleScript","Orca.views.Pages.Scripts.constants","Orca.views.Pages.Scripts",function()return setfenv(function()local mk=880;local mr=1824;local mj=48;return{BASE_WINDOW_HEIGHT=mk,BASE_WINDOW_WIDTH=mr,BASE_PADDING=mj}end,newEnv("Orca.views.Pages.Scripts.constants"))()end)newInstance("include","Folder","Orca.include","Orca")newModule("Promise","ModuleScript","Orca.include.Promise","Orca.include",function()return setfenv(function()local ms="Non-promise value passed into %s at index %s"local mt="Please pass a list of promises to %s"local mu="Please pass a handler function to %s!"local mv={__mode="k"}local function mw(mx,my)local mz={}for c_,mA in ipairs(my)do mz[mA]=mA end;return setmetatable(mz,{__index=function(c_,gH)error(string.format("%s is not in %s!",gH,mx),2)end,__newindex=function()error(string.format("Creating new members in %s is not allowed!",mx),2)end})end;local mB;do mB={Kind=mw("Promise.Error.Kind",{"ExecutionError","AlreadyCancelled","NotResolvedInTime","TimedOut"})}mB.__index=mB;function mB.new(cL,mC)cL=cL or{}return setmetatable({error=tostring(cL.error)or"[This error has no error text.]",trace=cL.trace,context=cL.context,kind=cL.kind,parent=mC,createdTick=os.clock(),createdTrace=debug.traceback()},mB)end;function mB.is(mD)if type(mD)=="table"then local mE=getmetatable(mD)if type(mE)=="table"then return rawget(mD,"error")~=nil and type(rawget(mE,"extend"))=="function"end end;return false end;function mB.isKind(mD,mF)assert(mF~=nil,"Argument #2 to Promise.Error.isKind must not be nil")return mB.is(mD)and mD.kind==mF end;function mB:extend(cL)cL=cL or{}cL.kind=cL.kind or self.kind;return mB.new(cL,self)end;function mB:getErrorChain()local mG={self}while mG[#mG].parent do table.insert(mG,mG[#mG].parent)end;return mG end;function mB:__tostring()local mH={string.format("-- Promise.Error(%s) --",self.kind or"?")}for c_,mI in ipairs(self:getErrorChain())do table.insert(mH,table.concat({mI.trace or mI.error,mI.context},"\n"))end;return table.concat(mH,"\n")end end;local function mJ(...)return select("#",...),{...}end;local function mK(mL,...)return mL,select("#",...),{...}end;local function mM(mN)assert(mN~=nil)return function(du)if type(du)=="table"then return du end;return mB.new({error=du,kind=mB.Kind.ExecutionError,trace=debug.traceback(tostring(du),2),context="Promise created at:\n\n"..mN})end end;local function mO(mN,d8,...)return mK(xpcall(d8,mM(mN),...))end;local function mP(mN,d8,hi,mQ)return function(...)local mR,mS,dv=mO(mN,d8,...)if mR then hi(unpack(dv,1,mS))else mQ(dv[1])end end end;local function mT(gG)return next(gG)==nil end;local mU={Error=mB,Status=mw("Promise.Status",{"Started","Resolved","Rejected","Cancelled"}),_getTime=os.clock,_timeEvent=game:GetService("RunService").Heartbeat}mU.prototype={}mU.__index=mU.prototype;function mU._new(mN,d8,mC)if mC~=nil and not mU.is(mC)then error("Argument #2 to Promise.new must be a promise or nil",2)end;local self={_source=mN,_status=mU.Status.Started,_values=nil,_valuesLength=-1,_unhandledRejection=true,_queuedResolve={},_queuedReject={},_queuedFinally={},_cancellationHook=nil,_parent=mC,_consumers=setmetatable({},mv)}if mC and mC._status==mU.Status.Started then mC._consumers[self]=true end;setmetatable(self,mU)local function hi(...)self:_resolve(...)end;local function mQ(...)self:_reject(...)end;local function hj(mV)if mV then if self._status==mU.Status.Cancelled then mV()else self._cancellationHook=mV end end;return self._status==mU.Status.Cancelled end;coroutine.wrap(function()local mR,c_,dv=mO(self._source,d8,hi,mQ,hj)if not mR then mQ(dv[1])end end)()return self end;function mU.new(mW)return mU._new(debug.traceback(nil,2),mW)end;function mU:__tostring()return string.format("Promise(%s)",self:getStatus())end;function mU.defer(d8)local mN=debug.traceback(nil,2)local dm;dm=mU._new(mN,function(hi,mQ,hj)local ki;ki=mU._timeEvent:Connect(function()ki:Disconnect()local mR,c_,dv=mO(mN,d8,hi,mQ,hj)if not mR then mQ(dv[1])end end)end)return dm end;mU.async=mU.defer;function mU.resolve(...)local mX,mY=mJ(...)return mU._new(debug.traceback(nil,2),function(hi)hi(unpack(mY,1,mX))end)end;function mU.reject(...)local mX,mY=mJ(...)return mU._new(debug.traceback(nil,2),function(c_,mQ)mQ(unpack(mY,1,mX))end)end;function mU._try(mN,d8,...)local mZ,mY=mJ(...)return mU._new(mN,function(hi)hi(d8(unpack(mY,1,mZ)))end)end;function mU.try(...)return mU._try(debug.traceback(nil,2),...)end;function mU._all(mN,m_,n0)if type(m_)~="table"then error(string.format(mt,"Promise.all"),3)end;for js,dm in pairs(m_)do if not mU.is(dm)then error(string.format(ms,"Promise.all",tostring(js)),3)end end;if#m_==0 or n0==0 then return mU.resolve({})end;return mU._new(mN,function(hi,mQ,hj)local n1={}local n2={}local n3=0;local n4=0;local n5=false;local function n6()for c_,dm in ipairs(n2)do dm:cancel()end end;local function n7(js,...)if n5 then return end;n3=n3+1;if n0==nil then n1[js]=...else n1[n3]=...end;if n3>=(n0 or#m_)then n5=true;hi(n1)n6()end end;hj(n6)for js,dm in ipairs(m_)do n2[js]=dm:andThen(function(...)n7(js,...)end,function(...)n4=n4+1;if n0==nil or#m_-n4<n0 then n6()n5=true;mQ(...)end end)end;if n5 then n6()end end)end;function mU.all(m_)return mU._all(debug.traceback(nil,2),m_)end;function mU.fold(n8,d8,bG)assert(type(n8)=="table","Bad argument #1 to Promise.fold: must be a table")assert(type(d8)=="function","Bad argument #2 to Promise.fold: must be a function")local n9=mU.resolve(bG)return mU.each(n8,function(na,js)n9=n9:andThen(function(nb)return d8(nb,na,js)end)end):andThenReturn(n9)end;function mU.some(m_,n0)assert(type(n0)=="number","Bad argument #2 to Promise.some: must be a number")return mU._all(debug.traceback(nil,2),m_,n0)end;function mU.any(m_)return mU._all(debug.traceback(nil,2),m_,1):andThen(function(mY)return mY[1]end)end;function mU.allSettled(m_)if type(m_)~="table"then error(string.format(mt,"Promise.allSettled"),2)end;for js,dm in pairs(m_)do if not mU.is(dm)then error(string.format(ms,"Promise.allSettled",tostring(js)),2)end end;if#m_==0 then return mU.resolve({})end;return mU._new(debug.traceback(nil,2),function(hi,c_,hj)local nc={}local n2={}local nd=0;local function n7(js,...)nd=nd+1;nc[js]=...if nd>=#m_ then hi(nc)end end;hj(function()for c_,dm in ipairs(n2)do dm:cancel()end end)for js,dm in ipairs(m_)do n2[js]=dm:finally(function(...)n7(js,...)end)end end)end;function mU.race(m_)assert(type(m_)=="table",string.format(mt,"Promise.race"))for js,dm in pairs(m_)do assert(mU.is(dm),string.format(ms,"Promise.race",tostring(js)))end;return mU._new(debug.traceback(nil,2),function(hi,mQ,hj)local n2={}local ne=false;local function n6()for c_,dm in ipairs(n2)do dm:cancel()end end;local function nf(d8)return function(...)n6()ne=true;return d8(...)end end;if hj(nf(mQ))then return end;for js,dm in ipairs(m_)do n2[js]=dm:andThen(nf(hi),nf(mQ))end;if ne then n6()end end)end;function mU.each(n8,ng)assert(type(n8)=="table",string.format(mt,"Promise.each"))assert(type(ng)=="function",string.format(mu,"Promise.each"))return mU._new(debug.traceback(nil,2),function(hi,mQ,hj)local nh={}local ni={}local nj=false;local function n6()for c_,nk in ipairs(ni)do nk:cancel()end end;hj(function()nj=true;n6()end)local nl={}for c2,d1 in ipairs(n8)do if mU.is(d1)then if d1:getStatus()==mU.Status.Cancelled then n6()return mQ(mB.new({error="Promise is cancelled",kind=mB.Kind.AlreadyCancelled,context=string.format("The Promise that was part of the array at index %d passed into Promise.each was already cancelled when Promise.each began.\n\nThat Promise was created at:\n\n%s",c2,d1._source)}))elseif d1:getStatus()==mU.Status.Rejected then n6()return mQ(select(2,d1:await()))end;local nm=d1:andThen(function(...)return...end)table.insert(ni,nm)nl[c2]=nm else nl[c2]=d1 end end;for c2,d1 in ipairs(nl)do if mU.is(d1)then local mL;mL,d1=d1:await()if not mL then n6()return mQ(d1)end end;if nj then return end;local nn=mU.resolve(ng(d1,c2))table.insert(ni,nn)local mL,dv=nn:await()if not mL then n6()return mQ(dv)end;nh[c2]=dv end;hi(nh)end)end;function mU.is(no)if type(no)~="table"then return false end;local np=getmetatable(no)if np==mU then return true elseif np==nil then return type(no.andThen)=="function"elseif type(np)=="table"and type(rawget(np,"__index"))=="table"and type(rawget(rawget(np,"__index"),"andThen"))=="function"then return true end;return false end;function mU.promisify(d8)return function(...)return mU._try(debug.traceback(nil,2),d8,...)end end;do local nq;local ki;function mU.delay(lH)assert(type(lH)=="number","Bad argument #1 to Promise.delay, must be a number.")if not(lH>=1/60)or lH==math.huge then lH=1/60 end;return mU._new(debug.traceback(nil,2),function(hi,c_,hj)local nr=mU._getTime()local ns=nr+lH;local nt={resolve=hi,startTime=nr,endTime=ns}if ki==nil then nq=nt;ki=mU._timeEvent:Connect(function()local nu=mU._getTime()while nq~=nil and nq.endTime<nu do local hp=nq;nq=hp.next;if nq==nil then ki:Disconnect()ki=nil else nq.previous=nil end;hp.resolve(mU._getTime()-hp.startTime)end end)else if nq.endTime<ns then local hp=nq;local next=hp.next;while next~=nil and next.endTime<ns do hp=next;next=hp.next end;hp.next=nt;nt.previous=hp;if next~=nil then nt.next=next;next.previous=nt end else nt.next=nq;nq.previous=nt;nq=nt end end;hj(function()local next=nt.next;if nq==nt then if next==nil then ki:Disconnect()ki=nil else next.previous=nil end;nq=next else local nv=nt.previous;nv.next=next;if next~=nil then next.previous=nv end end end)end)end end;function mU.prototype:timeout(lH,nw)local mN=debug.traceback(nil,2)return mU.race({mU.delay(lH):andThen(function()return mU.reject(nw==nil and mB.new({kind=mB.Kind.TimedOut,error="Timed out",context=string.format("Timeout of %d seconds exceeded.\n:timeout() called at:\n\n%s",lH,mN)})or nw)end),self})end;function mU.prototype:getStatus()return self._status end;function mU.prototype:_andThen(mN,nx,ny)self._unhandledRejection=false;return mU._new(mN,function(hi,mQ)local nz=hi;if nx then nz=mP(mN,nx,hi,mQ)end;local nA=mQ;if ny then nA=mP(mN,ny,hi,mQ)end;if self._status==mU.Status.Started then table.insert(self._queuedResolve,nz)table.insert(self._queuedReject,nA)elseif self._status==mU.Status.Resolved then nz(unpack(self._values,1,self._valuesLength))elseif self._status==mU.Status.Rejected then nA(unpack(self._values,1,self._valuesLength))elseif self._status==mU.Status.Cancelled then mQ(mB.new({error="Promise is cancelled",kind=mB.Kind.AlreadyCancelled,context="Promise created at\n\n"..mN}))end end,self)end;function mU.prototype:andThen(nx,ny)assert(nx==nil or type(nx)=="function",string.format(mu,"Promise:andThen"))assert(ny==nil or type(ny)=="function",string.format(mu,"Promise:andThen"))return self:_andThen(debug.traceback(nil,2),nx,ny)end;function mU.prototype:catch(nA)assert(nA==nil or type(nA)=="function",string.format(mu,"Promise:catch"))return self:_andThen(debug.traceback(nil,2),nil,nA)end;function mU.prototype:tap(nB)assert(type(nB)=="function",string.format(mu,"Promise:tap"))return self:_andThen(debug.traceback(nil,2),function(...)local nC=nB(...)if mU.is(nC)then local mX,mY=mJ(...)return nC:andThen(function()return unpack(mY,1,mX)end)end;return...end)end;function mU.prototype:andThenCall(d8,...)assert(type(d8)=="function",string.format(mu,"Promise:andThenCall"))local mX,mY=mJ(...)return self:_andThen(debug.traceback(nil,2),function()return d8(unpack(mY,1,mX))end)end;function mU.prototype:andThenReturn(...)local mX,mY=mJ(...)return self:_andThen(debug.traceback(nil,2),function()return unpack(mY,1,mX)end)end;function mU.prototype:cancel()if self._status~=mU.Status.Started then return end;self._status=mU.Status.Cancelled;if self._cancellationHook then self._cancellationHook()end;if self._parent then self._parent:_consumerCancelled(self)end;for f7 in pairs(self._consumers)do f7:cancel()end;self:_finalize()end;function mU.prototype:_consumerCancelled(nD)if self._status~=mU.Status.Started then return end;self._consumers[nD]=nil;if next(self._consumers)==nil then self:cancel()end end;function mU.prototype:_finally(mN,nE,nF)if not nF then self._unhandledRejection=false end;return mU._new(mN,function(hi,mQ)local nG=hi;if nE then nG=mP(mN,nE,hi,mQ)end;if nF then local d8=nG;nG=function(...)if self._status==mU.Status.Rejected then return hi(self)end;return d8(...)end end;if self._status==mU.Status.Started then table.insert(self._queuedFinally,nG)else nG(self._status)end end,self)end;function mU.prototype:finally(nE)assert(nE==nil or type(nE)=="function",string.format(mu,"Promise:finally"))return self:_finally(debug.traceback(nil,2),nE)end;function mU.prototype:finallyCall(d8,...)assert(type(d8)=="function",string.format(mu,"Promise:finallyCall"))local mX,mY=mJ(...)return self:_finally(debug.traceback(nil,2),function()return d8(unpack(mY,1,mX))end)end;function mU.prototype:finallyReturn(...)local mX,mY=mJ(...)return self:_finally(debug.traceback(nil,2),function()return unpack(mY,1,mX)end)end;function mU.prototype:done(nE)assert(nE==nil or type(nE)=="function",string.format(mu,"Promise:done"))return self:_finally(debug.traceback(nil,2),nE,true)end;function mU.prototype:doneCall(d8,...)assert(type(d8)=="function",string.format(mu,"Promise:doneCall"))local mX,mY=mJ(...)return self:_finally(debug.traceback(nil,2),function()return d8(unpack(mY,1,mX))end,true)end;function mU.prototype:doneReturn(...)local mX,mY=mJ(...)return self:_finally(debug.traceback(nil,2),function()return unpack(mY,1,mX)end,true)end;function mU.prototype:awaitStatus()self._unhandledRejection=false;if self._status==mU.Status.Started then local nH=Instance.new("BindableEvent")self:finally(function()nH:Fire()end)nH.Event:Wait()nH:Destroy()end;if self._status==mU.Status.Resolved then return self._status,unpack(self._values,1,self._valuesLength)elseif self._status==mU.Status.Rejected then return self._status,unpack(self._values,1,self._valuesLength)end;return self._status end;local function nI(dX,...)return dX==mU.Status.Resolved,...end;function mU.prototype:await()return nI(self:awaitStatus())end;local function nJ(dX,...)if dX~=mU.Status.Resolved then error(...==nil and"Expected Promise rejected with no value."or...,3)end;return...end;function mU.prototype:expect()return nJ(self:awaitStatus())end;mU.prototype.awaitValue=mU.prototype.expect;function mU.prototype:_unwrap()if self._status==mU.Status.Started then error("Promise has not resolved or rejected.",2)end;local mL=self._status==mU.Status.Resolved;return mL,unpack(self._values,1,self._valuesLength)end;function mU.prototype:_resolve(...)if self._status~=mU.Status.Started then if mU.is(...)then(...):_consumerCancelled(self)end;return end;if mU.is(...)then if select("#",...)>1 then local nK=string.format("When returning a Promise from andThen, extra arguments are ".."discarded! See:\n\n%s",self._source)warn(nK)end;local nL=...local dm=nL:andThen(function(...)self:_resolve(...)end,function(...)local nM=nL._values[1]if nL._error then nM=mB.new({error=nL._error,kind=mB.Kind.ExecutionError,context="[No stack trace available as this Promise originated from an older version of the Promise library (< v2)]"})end;if mB.isKind(nM,mB.Kind.ExecutionError)then return self:_reject(nM:extend({error="This Promise was chained to a Promise that errored.",trace="",context=string.format("The Promise at:\n\n%s\n...Rejected because it was chained to the following Promise, which encountered an error:\n",self._source)}))end;self:_reject(...)end)if dm._status==mU.Status.Cancelled then self:cancel()elseif dm._status==mU.Status.Started then self._parent=dm;dm._consumers[self]=true end;return end;self._status=mU.Status.Resolved;self._valuesLength,self._values=mJ(...)for c_,d8 in ipairs(self._queuedResolve)do coroutine.wrap(d8)(...)end;self:_finalize()end;function mU.prototype:_reject(...)if self._status~=mU.Status.Started then return end;self._status=mU.Status.Rejected;self._valuesLength,self._values=mJ(...)if not mT(self._queuedReject)then for c_,d8 in ipairs(self._queuedReject)do coroutine.wrap(d8)(...)end else local du=tostring(...)coroutine.wrap(function()mU._timeEvent:Wait()if not self._unhandledRejection then return end;local nK=string.format("Unhandled Promise rejection:\n\n%s\n\n%s",du,self._source)if mU.TEST then return end;warn(nK)end)()end;self:_finalize()end;function mU.prototype:_finalize()for c_,d8 in ipairs(self._queuedFinally)do coroutine.wrap(d8)(self._status)end;self._queuedFinally=nil;self._queuedReject=nil;self._queuedResolve=nil;if not mU.TEST then self._parent=nil;self._consumers=nil end end;function mU.prototype:now(nw)local mN=debug.traceback(nil,2)if self:getStatus()==mU.Status.Resolved then return self:_andThen(mN,function(...)return...end)else return mU.reject(nw==nil and mB.new({kind=mB.Kind.NotResolvedInTime,error="This Promise was not resolved in time for :now()",context=":now() was called at:\n\n"..mN})or nw)end end;function mU.retry(d8,nN,...)assert(type(d8)=="function","Parameter #1 to Promise.retry must be a function")assert(type(nN)=="number","Parameter #2 to Promise.retry must be a number")local jX,mX={...},select("#",...)return mU.resolve(d8(...)):catch(function(...)if nN>0 then return mU.retry(d8,nN-1,unpack(jX,1,mX))else return mU.reject(...)end end)end;function mU.fromEvent(nO,ng)ng=ng or function()return true end;return mU._new(debug.traceback(nil,2),function(hi,mQ,hj)local ki;local nP=false;local function nQ()ki:Disconnect()ki=nil end;ki=nO:Connect(function(...)local nR=ng(...)if nR==true then hi(...)if ki then nQ()else nP=true end elseif type(nR)~="boolean"then error("Promise.fromEvent predicate should always return a boolean")end end)if nP and ki then return nQ()end;hj(function()nQ()end)end)end;return mU end,newEnv("Orca.include.Promise"))()end)newModule("RuntimeLib","ModuleScript","Orca.include.RuntimeLib","Orca.include",function()return setfenv(function()local mU=require(script.Parent.Promise)local en=game:GetService("RunService")local nS=game:GetService("ReplicatedFirst")local a={}a.Promise=mU;local function nT(no)return en:IsStudio()and no:FindFirstAncestorWhichIsA("Plugin")~=nil end;function a.getModule(no,nU,nV)if nV==nil then nV=nU;nU="@rbxts"end;if en:IsRunning()and no:IsDescendantOf(nS)then warn("roblox-ts packages should not be used from ReplicatedFirst!")end;if en:IsRunning()and en:IsClient()and not nT(no)and not game:IsLoaded()then game.Loaded:Wait()end;local nW=script.Parent:FindFirstChild("node_modules")if not nW then error("Could not find any modules!",2)end;repeat local nX=no:FindFirstChild("node_modules")if nX and nX~=nW then nX=nX:FindFirstChild("@rbxts")end;if nX then local nY=nX:FindFirstChild(nV)if nY then return nY end end;no=no.Parent until no==nil or no==nW;local nZ=nW:FindFirstChild(nU or"@rbxts")return(nZ or nW):FindFirstChild(nV)or error("Could not find module: "..nV,2)end;local n_={}local o0={}function a.import(o1,nY,...)for js=1,select("#",...)do nY=nY:WaitForChild(select(js,...))end;if nY.ClassName~="ModuleScript"then error("Failed to import! Expected ModuleScript, got "..nY.ClassName,2)end;n_[o1]=nY;local o2=nY;local o3=0;while o2 do o3=o3+1;o2=n_[o2]if o2==nY then local o4=o2.Name;for c_=1,o3 do o2=n_[o2]o4=o4 .."  ⇒ "..o2.Name end;error("Failed to import! Detected a circular dependency chain: "..o4,2)end end;if not o0[nY]then if _G[nY]then error("Invalid module access! Do you have two TS runtimes trying to import this? "..nY:GetFullName(),2)end;_G[nY]=a;o0[nY]=true end;local hr=require(nY)if n_[o1]==nY then n_[o1]=nil end;return hr end;function a.instanceof(hH,o5)if type(o5)=="table"and type(o5.instanceof)=="function"then return o5.instanceof(hH)end;if type(hH)=="table"then hH=getmetatable(hH)while hH~=nil do if hH==o5 then return true end;local o6=getmetatable(hH)if o6 then hH=o6.__index else hH=nil end end end;return false end;function a.async(d8)return function(...)local jP=select("#",...)local jX={...}return mU.new(function(hi,mQ)coroutine.wrap(function()local mR,dv=pcall(d8,unpack(jX,1,jP))if mR then hi(dv)else mQ(dv)end end)()end)end end;function a.await(dm)if not mU.is(dm)then return dm end;local dX,d1=dm:awaitStatus()if dX==mU.Status.Resolved then return d1 elseif dX==mU.Status.Rejected then error(d1,2)else error("The awaited Promise was cancelled",2)end end;function a.bit_lrsh(ho,dE)local o7=math.abs(ho)local dv=bit32.rshift(o7,dE)if ho==o7 then return dv else return-dv-1 end end;a.TRY_RETURN=1;a.TRY_BREAK=2;a.TRY_CONTINUE=3;function a.try(o8,o9,oa)local du,mN;local mL,ob,oc=xpcall(o8,function(od)du=od;mN=debug.traceback()end)if not mL and o9 then local oe,of=o9(du,mN)if oe then ob,oc=oe,of end end;if oa then local oe,of=oa()if oe then ob,oc=oe,of end end;return ob,oc end;function a.generator(d8)local og=coroutine.create(d8)return{next=function(...)if coroutine.status(og)=="dead"then return{done=true}else local mL,d1=coroutine.resume(og,...)if mL==false then error(d1,2)end;return{value=d1,done=coroutine.status(og)=="dead"}end end}end;return a end,newEnv("Orca.include.RuntimeLib"))()end)newInstance("node_modules","Folder","Orca.include.node_modules","Orca.include")newInstance("compiler-types","Folder","Orca.include.node_modules.compiler-types","Orca.include.node_modules")newInstance("types","Folder","Orca.include.node_modules.compiler-types.types","Orca.include.node_modules.compiler-types")newInstance("exploit-types","Folder","Orca.include.node_modules.exploit-types","Orca.include.node_modules")newInstance("types","Folder","Orca.include.node_modules.exploit-types.types","Orca.include.node_modules.exploit-types")newInstance("flipper","Folder","Orca.include.node_modules.flipper","Orca.include.node_modules")newModule("src","ModuleScript","Orca.include.node_modules.flipper.src","Orca.include.node_modules.flipper",function()return setfenv(function()local oh={SingleMotor=require(script.SingleMotor),GroupMotor=require(script.GroupMotor),Instant=require(script.Instant),Linear=require(script.Linear),Spring=require(script.Spring),isMotor=require(script.isMotor)}return oh end,newEnv("Orca.include.node_modules.flipper.src"))()end)newModule("BaseMotor","ModuleScript","Orca.include.node_modules.flipper.src.BaseMotor","Orca.include.node_modules.flipper.src",function()return setfenv(function()local en=game:GetService("RunService")local oi=require(script.Parent.Signal)local oj=function()end;local ok={}ok.__index=ok;function ok.new()return setmetatable({_onStep=oi.new(),_onStart=oi.new(),_onComplete=oi.new()},ok)end;function ok:onStep(ol)return self._onStep:connect(ol)end;function ok:onStart(ol)return self._onStart:connect(ol)end;function ok:onComplete(ol)return self._onComplete:connect(ol)end;function ok:start()if not self._connection then self._connection=en.RenderStepped:Connect(function(eC)self:step(eC)end)end end;function ok:stop()if self._connection then self._connection:Disconnect()self._connection=nil end end;ok.destroy=ok.stop;ok.step=oj;ok.getValue=oj;ok.setGoal=oj;function ok:__tostring()return"Motor"end;return ok end,newEnv("Orca.include.node_modules.flipper.src.BaseMotor"))()end)newModule("GroupMotor","ModuleScript","Orca.include.node_modules.flipper.src.GroupMotor","Orca.include.node_modules.flipper.src",function()return setfenv(function()local ok=require(script.Parent.BaseMotor)local cO=require(script.Parent.SingleMotor)local cy=require(script.Parent.isMotor)local cN=setmetatable({},ok)cN.__index=cN;local function om(d1)if cy(d1)then return d1 end;local on=typeof(d1)if on=="number"then return cO.new(d1,false)elseif on=="table"then return cN.new(d1,false)end;error(("Unable to convert %q to motor; type %s is unsupported"):format(d1,on),2)end;function cN.new(oo,op)assert(oo,"Missing argument #1: initialValues")assert(typeof(oo)=="table","initialValues must be a table!")assert(not oo.step,"initialValues contains disallowed property \"step\". Did you mean to put a table of values here?")local self=setmetatable(ok.new(),cN)if op~=nil then self._useImplicitConnections=op else self._useImplicitConnections=true end;self._complete=true;self._motors={}for ea,d1 in pairs(oo)do self._motors[ea]=om(d1)end;return self end;function cN:step(eC)if self._complete then return true end;local oq=true;for c_,cB in pairs(self._motors)do local ot=cB:step(eC)if not ot then oq=false end end;self._onStep:fire(self:getValue())if oq then if self._useImplicitConnections then self:stop()end;self._complete=true;self._onComplete:fire()end;return oq end;function cN:setGoal(ou)assert(not ou.step,"goals contains disallowed property \"step\". Did you mean to put a table of goals here?")self._complete=false;self._onStart:fire()for ea,cF in pairs(ou)do local cB=assert(self._motors[ea],("Unknown motor for key %s"):format(ea))cB:setGoal(cF)end;if self._useImplicitConnections then self:start()end end;function cN:getValue()local mY={}for ea,cB in pairs(self._motors)do mY[ea]=cB:getValue()end;return mY end;function cN:__tostring()return"Motor(Group)"end;return cN end,newEnv("Orca.include.node_modules.flipper.src.GroupMotor"))()end)newModule("Instant","ModuleScript","Orca.include.node_modules.flipper.src.Instant","Orca.include.node_modules.flipper.src",function()return setfenv(function()local cG={}cG.__index=cG;function cG.new(cI)return setmetatable({_targetValue=cI},cG)end;function cG:step()return{complete=true,value=self._targetValue}end;return cG end,newEnv("Orca.include.node_modules.flipper.src.Instant"))()end)newModule("Linear","ModuleScript","Orca.include.node_modules.flipper.src.Linear","Orca.include.node_modules.flipper.src",function()return setfenv(function()local cJ={}cJ.__index=cJ;function cJ.new(cI,cL)assert(cI,"Missing argument #1: targetValue")cL=cL or{}return setmetatable({_targetValue=cI,_velocity=cL.velocity or 1},cJ)end;function cJ:step(F,f_)local M=F.value;local ov=self._velocity;local cF=self._targetValue;local ow=f_*ov;local ot=ow>=math.abs(cF-M)M=M+ow*(cF>M and 1 or-1)if ot then M=self._targetValue;ov=0 end;return{complete=ot,value=M,velocity=ov}end;return cJ end,newEnv("Orca.include.node_modules.flipper.src.Linear"))()end)newModule("Signal","ModuleScript","Orca.include.node_modules.flipper.src.Signal","Orca.include.node_modules.flipper.src",function()return setfenv(function()local ox={}ox.__index=ox;function ox.new(oy,ol)return setmetatable({signal=oy,connected=true,_handler=ol},ox)end;function ox:disconnect()if self.connected then self.connected=false;for c2,ki in pairs(self.signal._connections)do if ki==self then table.remove(self.signal._connections,c2)return end end end end;local oi={}oi.__index=oi;function oi.new()return setmetatable({_connections={},_threads={}},oi)end;function oi:fire(...)for c_,ki in pairs(self._connections)do ki._handler(...)end;for c_,oz in pairs(self._threads)do coroutine.resume(oz,...)end;self._threads={}end;function oi:connect(ol)local ki=ox.new(self,ol)table.insert(self._connections,ki)return ki end;function oi:wait()table.insert(self._threads,coroutine.running())return coroutine.yield()end;return oi end,newEnv("Orca.include.node_modules.flipper.src.Signal"))()end)newModule("SingleMotor","ModuleScript","Orca.include.node_modules.flipper.src.SingleMotor","Orca.include.node_modules.flipper.src",function()return setfenv(function()local ok=require(script.Parent.BaseMotor)local cO=setmetatable({},ok)cO.__index=cO;function cO.new(bG,op)assert(bG,"Missing argument #1: initialValue")assert(typeof(bG)=="number","initialValue must be a number!")local self=setmetatable(ok.new(),cO)if op~=nil then self._useImplicitConnections=op else self._useImplicitConnections=true end;self._goal=nil;self._state={complete=true,value=bG}return self end;function cO:step(eC)if self._state.complete then return true end;local el=self._goal:step(self._state,eC)self._state=el;self._onStep:fire(el.value)if el.complete then if self._useImplicitConnections then self:stop()end;self._onComplete:fire()end;return el.complete end;function cO:getValue()return self._state.value end;function cO:setGoal(cF)self._state.complete=false;self._goal=cF;self._onStart:fire()if self._useImplicitConnections then self:start()end end;function cO:__tostring()return"Motor(Single)"end;return cO end,newEnv("Orca.include.node_modules.flipper.src.SingleMotor"))()end)newModule("Spring","ModuleScript","Orca.include.node_modules.flipper.src.Spring","Orca.include.node_modules.flipper.src",function()return setfenv(function()local oA=0.001;local oB=0.001;local oC=0.0001;local bw={}bw.__index=bw;function bw.new(cI,cL)assert(cI,"Missing argument #1: targetValue")cL=cL or{}return setmetatable({_targetValue=cI,_frequency=cL.frequency or 4,_dampingRatio=cL.dampingRatio or 1},bw)end;function bw:step(F,f_)local oD=self._dampingRatio;local g0=self._frequency*2*math.pi;local dD=self._targetValue;local g1=F.value;local g2=F.velocity or 0;local ct=g1-dD;local g3=math.exp(-oD*g0*f_)local g4,g5;if oD==1 then g4=(ct*(1+g0*f_)+g2*f_)*g3+dD;g5=(g2*(1-g0*f_)-ct*g0*g0*f_)*g3 elseif oD<1 then local oE=math.sqrt(1-oD*oD)local js=math.cos(g0*oE*f_)local oF=math.sin(g0*oE*f_)local eE;if oE>oC then eE=oF/oE else local ho=f_*g0;eE=ho+(ho*ho*oE*oE*oE*oE/20-oE*oE)*ho*ho*ho/6 end;local eD;if g0*oE>oC then eD=oF/(g0*oE)else local dE=g0*oE;eD=f_+(f_*f_*dE*dE*dE*dE/20-dE*dE)*f_*f_*f_/6 end;g4=(ct*(js+oD*eE)+g2*eD)*g3+dD;g5=(g2*(js-eE*oD)-ct*eE*g0)*g3 else local oE=math.sqrt(oD*oD-1)local oG=-g0*(oD-oE)local oH=-g0*(oD+oE)local oI=(g2-ct*oG)/(2*g0*oE)local oJ=ct-oI;local oK=oJ*math.exp(oG*f_)local oL=oI*math.exp(oH*f_)g4=oK+oL+dD;g5=oK*oG+oL*oH end;local ot=math.abs(g5)<oA and math.abs(g4-dD)<oB;return{complete=ot,value=ot and dD or g4,velocity=g5}end;return bw end,newEnv("Orca.include.node_modules.flipper.src.Spring"))()end)newModule("isMotor","ModuleScript","Orca.include.node_modules.flipper.src.isMotor","Orca.include.node_modules.flipper.src",function()return setfenv(function()local function cy(d1)local oM=tostring(d1):match("^Motor%((.+)%)$")if oM then return true,oM else return false end end;return cy end,newEnv("Orca.include.node_modules.flipper.src.isMotor"))()end)newInstance("typings","Folder","Orca.include.node_modules.flipper.typings","Orca.include.node_modules.flipper")newModule("make","ModuleScript","Orca.include.node_modules.make","Orca.include.node_modules",function()return setfenv(function()local function ap(oN,oO)local U=oO;local bb=U.Children;local mC=U.Parent;local oP=Instance.new(oN)for oQ,d1 in pairs(oO)do if oQ~="Children"and oQ~="Parent"then local dt=oP;local oR=dt[oQ]if typeof(oR)=="RBXScriptSignal"then oR:Connect(d1)else oP[oQ]=d1 end end end;if bb then for c_,f7 in ipairs(bb)do f7.Parent=oP end end;oP.Parent=mC;return oP end;return ap end,newEnv("Orca.include.node_modules.make"))()end)newInstance("node_modules","Folder","Orca.include.node_modules.make.node_modules","Orca.include.node_modules.make")newInstance("@rbxts","Folder","Orca.include.node_modules.make.node_modules.@rbxts","Orca.include.node_modules.make.node_modules")newInstance("compiler-types","Folder","Orca.include.node_modules.make.node_modules.@rbxts.compiler-types","Orca.include.node_modules.make.node_modules.@rbxts")newInstance("types","Folder","Orca.include.node_modules.make.node_modules.@rbxts.compiler-types.types","Orca.include.node_modules.make.node_modules.@rbxts.compiler-types")newModule("object-utils","ModuleScript","Orca.include.node_modules.object-utils","Orca.include.node_modules",function()return setfenv(function()local hX=game:GetService("HttpService")local oS={}function oS.keys(no)local dv=table.create(#no)for ea in pairs(no)do dv[#dv+1]=ea end;return dv end;function oS.values(no)local dv=table.create(#no)for c_,d1 in pairs(no)do dv[#dv+1]=d1 end;return dv end;function oS.entries(no)local dv=table.create(#no)for ea,d1 in pairs(no)do dv[#dv+1]={ea,d1}end;return dv end;function oS.assign(oT,...)for js=1,select("#",...)do local oU=select(js,...)if type(oU)=="table"then for ea,d1 in pairs(oU)do oT[ea]=d1 end end end;return oT end;function oS.copy(no)local dv=table.create(#no)for gH,bM in pairs(no)do dv[gH]=bM end;return dv end;local function oV(no,oW)local dv=table.create(#no)oW[no]=dv;for gH,bM in pairs(no)do if type(gH)=="table"then gH=oW[gH]or oV(gH,oW)end;if type(bM)=="table"then bM=oW[bM]or oV(bM,oW)end;dv[gH]=bM end;return dv end;function oS.deepCopy(no)return oV(no,{})end;function oS.deepEquals(ho,dE)for gH in pairs(ho)do local oX=ho[gH]local oY=dE[gH]if type(oX)=="table"and type(oY)=="table"then local dv=oS.deepEquals(oX,oY)if not dv then return false end elseif oX~=oY then return false end end;for gH in pairs(dE)do if ho[gH]==nil then return false end end;return true end;function oS.toString(hr)return hX:JSONEncode(hr)end;function oS.isEmpty(no)return next(no)==nil end;function oS.fromEntries(oZ)local o_=#oZ;local dv=table.create(o_)if oZ then for js=1,o_ do local p0=oZ[js]dv[p0[1]]=p0[2]end end;return dv end;return oS end,newEnv("Orca.include.node_modules.object-utils"))()end)newInstance("roact","Folder","Orca.include.node_modules.roact","Orca.include.node_modules")newModule("src","ModuleScript","Orca.include.node_modules.roact.src","Orca.include.node_modules.roact",function()return setfenv(function()local p1=require(script.GlobalConfig)local p2=require(script.createReconciler)local p3=require(script.createReconcilerCompat)local p4=require(script.RobloxRenderer)local p5=require(script.strict)local p6=require(script.Binding)local p7=p2(p4)local p8=p3(p7)local b=p5{Component=require(script.Component),createElement=require(script.createElement),createFragment=require(script.createFragment),oneChild=require(script.oneChild),PureComponent=require(script.PureComponent),None=require(script.None),Portal=require(script.Portal),createRef=require(script.createRef),forwardRef=require(script.forwardRef),createBinding=p6.create,joinBindings=p6.join,createContext=require(script.createContext),Change=require(script.PropMarkers.Change),Children=require(script.PropMarkers.Children),Event=require(script.PropMarkers.Event),Ref=require(script.PropMarkers.Ref),mount=p7.mountVirtualTree,unmount=p7.unmountVirtualTree,update=p7.updateVirtualTree,reify=p8.reify,teardown=p8.teardown,reconcile=p8.reconcile,setGlobalConfig=p1.set,UNSTABLE={}}return b end,newEnv("Orca.include.node_modules.roact.src"))()end)newModule("Binding","ModuleScript","Orca.include.node_modules.roact.src.Binding","Orca.include.node_modules.roact.src",function()return setfenv(function()local p9=require(script.Parent.createSignal)local pa=require(script.Parent.Symbol)local pb=require(script.Parent.Type)local pc=require(script.Parent.GlobalConfig).get()local pd=pa.named("BindingImpl")local pe={}local pf={}function pf:getValue()return pe.getValue(self)end;function pf:map(ng)return pe.map(self,ng)end;local pg={__index=pf,__tostring=function(self)return string.format("RoactBinding(%s)",tostring(self:getValue()))end}function pe.update(cC,ph)return cC[pd].update(ph)end;function pe.subscribe(cC,d8)return cC[pd].subscribe(d8)end;function pe.getValue(cC)return cC[pd].getValue()end;function pe.create(bG)local pi={value=bG,changeSignal=p9()}function pi.subscribe(d8)return pi.changeSignal:subscribe(d8)end;function pi.update(ph)pi.value=ph;pi.changeSignal:fire(ph)end;function pi.getValue()return pi.value end;return setmetatable({[pb]=pb.Binding,[pd]=pi},pg),pi.update end;function pe.map(pj,ng)if pc.typeChecks then assert(pb.of(pj)==pb.Binding,"Expected arg #1 to be a binding")assert(typeof(ng)=="function","Expected arg #1 to be a function")end;local pi={}function pi.subscribe(d8)return pe.subscribe(pj,function(ph)d8(ng(ph))end)end;function pi.update(ph)error("Bindings created by Binding:map(fn) cannot be updated directly",2)end;function pi.getValue()return ng(pj:getValue())end;return setmetatable({[pb]=pb.Binding,[pd]=pi},pg)end;function pe.join(pk)if pc.typeChecks then assert(typeof(pk)=="table","Expected arg #1 to be of type table")for ea,d1 in pairs(pk)do if pb.of(d1)~=pb.Binding then local nK=("Expected arg #1 to contain only bindings, but key %q had a non-binding value"):format(tostring(ea))error(nK,2)end end end;local pi={}local function lJ()local d1={}for ea,pl in pairs(pk)do d1[ea]=pl:getValue()end;return d1 end;function pi.subscribe(d8)local pm={}for ea,pl in pairs(pk)do pm[ea]=pe.subscribe(pl,function(ph)d8(lJ())end)end;return function()if pm==nil then return end;for c_,nQ in pairs(pm)do nQ()end;pm=nil end end;function pi.update(ph)error("Bindings created by joinBindings(...) cannot be updated directly",2)end;function pi.getValue()return lJ()end;return setmetatable({[pb]=pb.Binding,[pd]=pi},pg)end;return pe end,newEnv("Orca.include.node_modules.roact.src.Binding"))()end)newModule("Component","ModuleScript","Orca.include.node_modules.roact.src.Component","Orca.include.node_modules.roact.src",function()return setfenv(function()local pn=require(script.Parent.assign)local po=require(script.Parent.ComponentLifecyclePhase)local pb=require(script.Parent.Type)local pa=require(script.Parent.Symbol)local pp=require(script.Parent.invalidSetStateMessages)local pq=require(script.Parent.internalAssert)local pc=require(script.Parent.GlobalConfig).get()local pr=100;local ps=pa.named("InternalData")local pt=[[
The component %q is missing the `render` method.
`render` must be defined when creating a Roact component!]]local pu=[[
The component %q has reached the setState update recursion limit.
When using `setState` in `didUpdate`, make sure that it won't repeat infinitely!]]local pv={}function pv:__tostring()return self.__componentName end;local pw={}setmetatable(pw,pv)pw[pb]=pb.StatefulComponentClass;pw.__index=pw;pw.__componentName="Component"function pw:extend(hf)if pc.typeChecks then assert(pb.of(self)==pb.StatefulComponentClass,"Invalid `self` argument to `extend`.")assert(typeof(hf)=="string","Component class name must be a string")end;local o5={}for ea,d1 in pairs(self)do if ea~="extend"then o5[ea]=d1 end end;o5[pb]=pb.StatefulComponentClass;o5.__index=o5;o5.__componentName=hf;setmetatable(o5,pv)return o5 end;function pw:__getDerivedState(px,py)if pc.internalTypeChecks then pq(pb.of(self)==pb.StatefulComponentInstance,"Invalid use of `__getDerivedState`")end;local pz=self[ps]local pA=pz.componentClass;if pA.getDerivedStateFromProps~=nil then local pB=pA.getDerivedStateFromProps(px,py)if pB~=nil then if pc.typeChecks then assert(typeof(pB)=="table","getDerivedStateFromProps must return a table!")end;return pB end end;return nil end;function pw:setState(pC)if pc.typeChecks then assert(pb.of(self)==pb.StatefulComponentInstance,"Invalid `self` argument to `extend`.")end;local pz=self[ps]local pD=pz.lifecyclePhase;if pD==po.ShouldUpdate or pD==po.WillUpdate or pD==po.Render or pD==po.WillUnmount then local pE=pp[pz.lifecyclePhase]local nK=pE:format(tostring(pz.componentClass))error(nK,2)end;local pF=pz.pendingState;local pG;if typeof(pC)=="function"then pG=pC(pF or self.state,self.props)if pG==nil then return end elseif typeof(pC)=="table"then pG=pC else error("Invalid argument to setState, expected function or table",2)end;local el;if pF~=nil then el=pn(pF,pG)else el=pn({},self.state,pG)end;if pD==po.Init then local pB=self:__getDerivedState(self.props,el)self.state=pn(el,pB)elseif pD==po.DidMount or pD==po.DidUpdate or pD==po.ReconcileChildren then local pB=self:__getDerivedState(self.props,el)pz.pendingState=pn(el,pB)elseif pD==po.Idle then local pH=pz.virtualNode;local pI=pz.reconciler;if pc.tempFixUpdateChildrenReEntrancy then pI.suspendParentEvents(pH)end;self:__update(nil,el)if pc.tempFixUpdateChildrenReEntrancy then pI.resumeParentEvents(pH)end else local pE=pp.default;local nK=pE:format(tostring(pz.componentClass))error(nK,2)end end;function pw:getElementTraceback()return self[ps].virtualNode.currentElement.source end;function pw:render()local pz=self[ps]local nK=pt:format(tostring(pz.componentClass))error(nK,0)end;function pw:__getContext(ea)if pc.internalTypeChecks then pq(pb.of(self)==pb.StatefulComponentInstance,"Invalid use of `__getContext`")pq(ea~=nil,"Context key cannot be nil")end;local pH=self[ps].virtualNode;local pJ=pH.context;return pJ[ea]end;function pw:__addContext(ea,d1)if pc.internalTypeChecks then pq(pb.of(self)==pb.StatefulComponentInstance,"Invalid use of `__addContext`")end;local pH=self[ps].virtualNode;if pH.originalContext==nil then pH.originalContext=pH.context end;local pK=pH.context;pH.context=pn({},pK,{[ea]=d1})end;function pw:__validateProps(ku)if not pc.propValidation then return end;local pL=self[ps].componentClass.validateProps;if pL==nil then return end;if typeof(pL)~="function"then error(("validateProps must be a function, but it is a %s.\nCheck the definition of the component %q."):format(typeof(pL),self.__componentName))end;local mL,pM=pL(ku)if not mL then pM=pM or"<Validator function did not supply a message>"error(("Property validation failed in %s: %s\n\n%s"):format(self.__componentName,tostring(pM),self:getElementTraceback()or"<enable element tracebacks>"),0)end end;function pw:__mount(pI,pH)if pc.internalTypeChecks then pq(pb.of(self)==pb.StatefulComponentClass,"Invalid use of `__mount`")pq(pb.of(pH)==pb.VirtualNode,"Expected arg #2 to be of type VirtualNode")end;local pN=pH.currentElement;local pO=pH.hostParent;local pz={reconciler=pI,virtualNode=pH,componentClass=self,lifecyclePhase=po.Init}local oP={[pb]=pb.StatefulComponentInstance,[ps]=pz}setmetatable(oP,self)pH.instance=oP;local ku=pN.props;if self.defaultProps~=nil then ku=pn({},self.defaultProps,ku)end;oP:__validateProps(ku)oP.props=ku;local pP=pn({},pH.legacyContext)oP._context=pP;oP.state=pn({},oP:__getDerivedState(oP.props,{}))if oP.init~=nil then oP:init(oP.props)pn(oP.state,oP:__getDerivedState(oP.props,oP.state))end;pH.legacyContext=oP._context;pz.lifecyclePhase=po.Render;local pQ=oP:render()pz.lifecyclePhase=po.ReconcileChildren;pI.updateVirtualNodeWithRenderResult(pH,pO,pQ)if oP.didMount~=nil then pz.lifecyclePhase=po.DidMount;oP:didMount()end;if pz.pendingState~=nil then oP:__update(nil,nil)end;pz.lifecyclePhase=po.Idle end;function pw:__unmount()if pc.internalTypeChecks then pq(pb.of(self)==pb.StatefulComponentInstance,"Invalid use of `__unmount`")end;local pz=self[ps]local pH=pz.virtualNode;local pI=pz.reconciler;if self.willUnmount~=nil then pz.lifecyclePhase=po.WillUnmount;self:willUnmount()end;for c_,pR in pairs(pH.children)do pI.unmountVirtualNode(pR)end end;function pw:__update(pS,pT)if pc.internalTypeChecks then pq(pb.of(self)==pb.StatefulComponentInstance,"Invalid use of `__update`")pq(pb.of(pS)==pb.Element or pS==nil,"Expected arg #1 to be of type Element or nil")pq(typeof(pT)=="table"or pT==nil,"Expected arg #2 to be of type table or nil")end;local pz=self[ps]local pA=pz.componentClass;local pU=self.props;if pS~=nil then pU=pS.props;if pA.defaultProps~=nil then pU=pn({},pA.defaultProps,pU)end;self:__validateProps(pU)end;local pV=0;repeat local pW;local pF=nil;if pz.pendingState~=nil then pF=pz.pendingState;pz.pendingState=nil end;if pT~=nil or pU~=self.props then if pF==nil then pW=pT or self.state else pW=pn(pF,pT)end;local pB=self:__getDerivedState(pU,pW)if pB~=nil then pW=pn({},pW,pB)end;pT=nil else pW=pF end;if not self:__resolveUpdate(pU,pW)then return false end;pV=pV+1;if pV>pr then error(pu:format(tostring(pz.componentClass)),3)end until pz.pendingState==nil;return true end;function pw:__resolveUpdate(px,py)if pc.internalTypeChecks then pq(pb.of(self)==pb.StatefulComponentInstance,"Invalid use of `__resolveUpdate`")end;local pz=self[ps]local pH=pz.virtualNode;local pI=pz.reconciler;local pX=self.props;local pY=self.state;if px==nil then px=pX end;if py==nil then py=pY end;if self.shouldUpdate~=nil then pz.lifecyclePhase=po.ShouldUpdate;local pZ=self:shouldUpdate(px,py)if not pZ then pz.lifecyclePhase=po.Idle;return false end end;if self.willUpdate~=nil then pz.lifecyclePhase=po.WillUpdate;self:willUpdate(px,py)end;pz.lifecyclePhase=po.Render;self.props=px;self.state=py;local pQ=pH.instance:render()pz.lifecyclePhase=po.ReconcileChildren;pI.updateVirtualNodeWithRenderResult(pH,pH.hostParent,pQ)if self.didUpdate~=nil then pz.lifecyclePhase=po.DidUpdate;self:didUpdate(pX,pY)end;pz.lifecyclePhase=po.Idle;return true end;return pw end,newEnv("Orca.include.node_modules.roact.src.Component"))()end)newModule("ComponentLifecyclePhase","ModuleScript","Orca.include.node_modules.roact.src.ComponentLifecyclePhase","Orca.include.node_modules.roact.src",function()return setfenv(function()local pa=require(script.Parent.Symbol)local p5=require(script.Parent.strict)local po=p5({Init=pa.named("init"),Render=pa.named("render"),ShouldUpdate=pa.named("shouldUpdate"),WillUpdate=pa.named("willUpdate"),DidMount=pa.named("didMount"),DidUpdate=pa.named("didUpdate"),WillUnmount=pa.named("willUnmount"),ReconcileChildren=pa.named("reconcileChildren"),Idle=pa.named("idle")},"ComponentLifecyclePhase")return po end,newEnv("Orca.include.node_modules.roact.src.ComponentLifecyclePhase"))()end)newModule("Config","ModuleScript","Orca.include.node_modules.roact.src.Config","Orca.include.node_modules.roact.src",function()return setfenv(function()local p_={["internalTypeChecks"]=false,["typeChecks"]=false,["elementTracing"]=false,["propValidation"]=false,["tempFixUpdateChildrenReEntrancy"]=false}local q0={}for ea in pairs(p_)do table.insert(q0,ea)end;local q1={}function q1.new()local self={}self._currentConfig=setmetatable({},{__index=function(c_,ea)local nK=("Invalid global configuration key %q. Valid configuration keys are: %s"):format(tostring(ea),table.concat(q0,", "))error(nK,3)end})self.set=function(...)return q1.set(self,...)end;self.get=function(...)return q1.get(self,...)end;self.scoped=function(...)return q1.scoped(self,...)end;self.set(p_)return self end;function q1:set(q2)for ea,d1 in pairs(q2)do if p_[ea]==nil then local nK=("Invalid global configuration key %q (type %s). Valid configuration keys are: %s"):format(tostring(ea),typeof(ea),table.concat(q0,", "))error(nK,3)end;if typeof(d1)~="boolean"then local nK=("Invalid value %q (type %s) for global configuration key %q. Valid values are: true, false"):format(tostring(d1),typeof(d1),tostring(ea))error(nK,3)end;self._currentConfig[ea]=d1 end end;function q1:get()return self._currentConfig end;function q1:scoped(q2,d8)local q3={}for ea,d1 in pairs(self._currentConfig)do q3[ea]=d1 end;self.set(q2)local mL,dv=pcall(d8)self.set(q3)assert(mL,dv)end;return q1 end,newEnv("Orca.include.node_modules.roact.src.Config"))()end)newModule("ElementKind","ModuleScript","Orca.include.node_modules.roact.src.ElementKind","Orca.include.node_modules.roact.src",function()return setfenv(function()local pa=require(script.Parent.Symbol)local p5=require(script.Parent.strict)local q4=require(script.Parent.Portal)local q5=newproxy(true)local q6={Portal=pa.named("Portal"),Host=pa.named("Host"),Function=pa.named("Function"),Stateful=pa.named("Stateful"),Fragment=pa.named("Fragment")}function q6.of(d1)if typeof(d1)~="table"then return nil end;return d1[q5]end;local q7={["string"]=q6.Host,["function"]=q6.Function,["table"]=q6.Stateful}function q6.fromComponent(q8)if q8==q4 then return q5.Portal else return q7[typeof(q8)]end end;getmetatable(q5).__index=q6;p5(q6,"ElementKind")return q5 end,newEnv("Orca.include.node_modules.roact.src.ElementKind"))()end)newModule("ElementUtils","ModuleScript","Orca.include.node_modules.roact.src.ElementUtils","Orca.include.node_modules.roact.src",function()return setfenv(function()local pb=require(script.Parent.Type)local pa=require(script.Parent.Symbol)local function oj()return nil end;local q9={}q9.UseParentKey=pa.named("UseParentKey")function q9.iterateElements(qa)local qb=pb.of(qa)if qb==pb.Element then local qc=false;return function()if qc then return nil else qc=true;return q9.UseParentKey,qa end end end;local qd=typeof(qa)if qa==nil or qd=="boolean"then return oj end;if qd=="table"then return pairs(qa)end;error("Invalid elements")end;function q9.getElementByKey(qe,qf)if qe==nil or typeof(qe)=="boolean"then return nil end;if pb.of(qe)==pb.Element then if qf==q9.UseParentKey then return qe end;return nil end;if typeof(qe)=="table"then return qe[qf]end;error("Invalid elements")end;return q9 end,newEnv("Orca.include.node_modules.roact.src.ElementUtils"))()end)newModule("GlobalConfig","ModuleScript","Orca.include.node_modules.roact.src.GlobalConfig","Orca.include.node_modules.roact.src",function()return setfenv(function()local q1=require(script.Parent.Config)return q1.new()end,newEnv("Orca.include.node_modules.roact.src.GlobalConfig"))()end)newModule("Logging","ModuleScript","Orca.include.node_modules.roact.src.Logging","Orca.include.node_modules.roact.src",function()return setfenv(function()local qg=true;local qh={}local qi={}local function qj(qk,ql)local qm=("\t"):rep(ql)return qm..qk:gsub("\n","\n"..qm)end;local function qn(qo,ql)local qp={}for c_,qq in ipairs(qo)do table.insert(qp,qj(qq,ql))end;return table.concat(qp,"\n")end;local qr={}function qr:__tostring()local qp={"LogInfo {"}local qs=#self.errors;local qt=#self.warnings;local qu=#self.infos;if qs+qt+qu==0 then table.insert(qp,"\t(no messages)")end;if qs>0 then table.insert(qp,("\tErrors (%d) {"):format(qs))table.insert(qp,qn(self.errors,2))table.insert(qp,"\t}")end;if qt>0 then table.insert(qp,("\tWarnings (%d) {"):format(qt))table.insert(qp,qn(self.warnings,2))table.insert(qp,"\t}")end;if qu>0 then table.insert(qp,("\tInfos (%d) {"):format(qu))table.insert(qp,qn(self.infos,2))table.insert(qp,"\t}")end;table.insert(qp,"}")return table.concat(qp,"\n")end;local function qv()local qw={errors={},warnings={},infos={}}setmetatable(qw,qr)return qw end;local qx={}function qx.capture(d8)local qy=qv()local qz=qg;qg=false;qh[qy]=true;local mL,dv=pcall(d8)qh[qy]=nil;qg=qz;assert(mL,dv)return qy end;function qx.warn(pE,...)local nK=pE:format(...)for qy in pairs(qh)do table.insert(qy.warnings,nK)end;local qA=debug.traceback("",2):sub(2)local qB=("%s\n%s"):format(nK,qj(qA,1))if qg then warn(qB)end end;function qx.warnOnce(pE,...)local qA=debug.traceback()if qi[qA]then return end;qi[qA]=true;qx.warn(pE,...)end;return qx end,newEnv("Orca.include.node_modules.roact.src.Logging"))()end)newModule("None","ModuleScript","Orca.include.node_modules.roact.src.None","Orca.include.node_modules.roact.src",function()return setfenv(function()local pa=require(script.Parent.Symbol)local qC=pa.named("None")return qC end,newEnv("Orca.include.node_modules.roact.src.None"))()end)newModule("NoopRenderer","ModuleScript","Orca.include.node_modules.roact.src.NoopRenderer","Orca.include.node_modules.roact.src",function()return setfenv(function()local qD={}function qD.isHostObject(an)return an==nil end;function qD.mountHostNode(pI,nt)end;function qD.unmountHostNode(pI,nt)end;function qD.updateHostNode(pI,nt,qE)return nt end;return qD end,newEnv("Orca.include.node_modules.roact.src.NoopRenderer"))()end)newModule("Portal","ModuleScript","Orca.include.node_modules.roact.src.Portal","Orca.include.node_modules.roact.src",function()return setfenv(function()local pa=require(script.Parent.Symbol)local q4=pa.named("Portal")return q4 end,newEnv("Orca.include.node_modules.roact.src.Portal"))()end)newInstance("PropMarkers","Folder","Orca.include.node_modules.roact.src.PropMarkers","Orca.include.node_modules.roact.src")newModule("Change","ModuleScript","Orca.include.node_modules.roact.src.PropMarkers.Change","Orca.include.node_modules.roact.src.PropMarkers",function()return setfenv(function()local pb=require(script.Parent.Parent.Type)local qF={}local qG={__tostring=function(self)return("RoactHostChangeEvent(%s)"):format(self.name)end}setmetatable(qF,{__index=function(self,qH)local qI={[pb]=pb.HostChangeEvent,name=qH}setmetatable(qI,qG)qF[qH]=qI;return qI end})return qF end,newEnv("Orca.include.node_modules.roact.src.PropMarkers.Change"))()end)newModule("Children","ModuleScript","Orca.include.node_modules.roact.src.PropMarkers.Children","Orca.include.node_modules.roact.src.PropMarkers",function()return setfenv(function()local pa=require(script.Parent.Parent.Symbol)local qJ=pa.named("Children")return qJ end,newEnv("Orca.include.node_modules.roact.src.PropMarkers.Children"))()end)newModule("Event","ModuleScript","Orca.include.node_modules.roact.src.PropMarkers.Event","Orca.include.node_modules.roact.src.PropMarkers",function()return setfenv(function()local pb=require(script.Parent.Parent.Type)local qK={}local qL={__tostring=function(self)return("RoactHostEvent(%s)"):format(self.name)end}setmetatable(qK,{__index=function(self,qM)local nO={[pb]=pb.HostEvent,name=qM}setmetatable(nO,qL)qK[qM]=nO;return nO end})return qK end,newEnv("Orca.include.node_modules.roact.src.PropMarkers.Event"))()end)newModule("Ref","ModuleScript","Orca.include.node_modules.roact.src.PropMarkers.Ref","Orca.include.node_modules.roact.src.PropMarkers",function()return setfenv(function()local pa=require(script.Parent.Parent.Symbol)local qN=pa.named("Ref")return qN end,newEnv("Orca.include.node_modules.roact.src.PropMarkers.Ref"))()end)newModule("PureComponent","ModuleScript","Orca.include.node_modules.roact.src.PureComponent","Orca.include.node_modules.roact.src",function()return setfenv(function()local pw=require(script.Parent.Component)local qO=pw:extend("PureComponent")qO.extend=pw.extend;function qO:shouldUpdate(pU,el)if el~=self.state then return true end;if pU==self.props then return false end;for ea,d1 in pairs(pU)do if self.props[ea]~=d1 then return true end end;for ea,d1 in pairs(self.props)do if pU[ea]~=d1 then return true end end;return false end;return qO end,newEnv("Orca.include.node_modules.roact.src.PureComponent"))()end)newModule("RobloxRenderer","ModuleScript","Orca.include.node_modules.roact.src.RobloxRenderer","Orca.include.node_modules.roact.src",function()return setfenv(function()local p6=require(script.Parent.Binding)local qJ=require(script.Parent.PropMarkers.Children)local q5=require(script.Parent.ElementKind)local qP=require(script.Parent.SingleEventManager)local qQ=require(script.Parent.getDefaultInstanceProperty)local qN=require(script.Parent.PropMarkers.Ref)local pb=require(script.Parent.Type)local pq=require(script.Parent.internalAssert)local pc=require(script.Parent.GlobalConfig).get()local qR=[[
Error applying props:
	%s
In element:
%s
]]local qS=[[
Error updating props:
	%s
In element:
%s
]]local function qT(...)return...end;local function qU(d9,qV)if d9==nil then return end;if typeof(d9)=="function"then d9(qV)elseif pb.of(d9)==pb.Binding then p6.update(d9,qV)else error(("Invalid ref: Expected type Binding but got %s"):format(typeof(d9)))end end;local function qW(qX,ea,ph)if ph==nil then local qY=qX.ClassName;local c_,qZ=qQ(qY,ea)ph=qZ end;qX[ea]=ph;return end;local function q_(pH,ea)local nQ=pH.bindings[ea]nQ()pH.bindings[ea]=nil end;local function r0(pH,ea,r1)local function r2(ph)local mL,r3=xpcall(function()qW(pH.hostObject,ea,ph)end,qT)if not mL then local qk=pH.currentElement.source;if qk==nil then qk="<enable element tracebacks>"end;local qB=qS:format(r3,qk)error(qB,0)end end;if pH.bindings==nil then pH.bindings={}end;pH.bindings[ea]=p6.subscribe(r1,r2)r2(r1:getValue())end;local function r4(pH)if pH.bindings~=nil then for c_,nQ in pairs(pH.bindings)do nQ()end end end;local function r5(pH,ea,ph,r6)if ph==r6 then return end;if ea==qN or ea==qJ then return end;local r7=pb.of(ea)if r7==pb.HostEvent or r7==pb.HostChangeEvent then if pH.eventManager==nil then pH.eventManager=qP.new(pH.hostObject)end;local qM=ea.name;if r7==pb.HostChangeEvent then pH.eventManager:connectPropertyChange(qM,ph)else pH.eventManager:connectEvent(qM,ph)end;return end;local r8=pb.of(ph)==pb.Binding;local r9=pb.of(r6)==pb.Binding;if r9 then q_(pH,ea)end;if r8 then r0(pH,ea,ph)else qW(pH.hostObject,ea,ph)end end;local function ra(pH,ku)for rb,d1 in pairs(ku)do r5(pH,rb,d1,nil)end end;local function rc(pH,pX,pU)for rb,ph in pairs(pU)do local r6=pX[rb]r5(pH,rb,ph,r6)end;for rb,r6 in pairs(pX)do local ph=pU[rb]if ph==nil then r5(pH,rb,nil,r6)end end end;local p4={}function p4.isHostObject(an)return typeof(an)=="Instance"end;function p4.mountHostNode(pI,pH)local rd=pH.currentElement;local pO=pH.hostParent;local qf=pH.hostKey;if pc.internalTypeChecks then pq(q5.of(rd)==q5.Host,"Element at given node is not a host Element")end;if pc.typeChecks then assert(rd.props.Name==nil,"Name can not be specified as a prop to a host component in Roact.")assert(rd.props.Parent==nil,"Parent can not be specified as a prop to a host component in Roact.")end;local oP=Instance.new(rd.component)pH.hostObject=oP;local mL,r3=xpcall(function()ra(pH,rd.props)end,qT)if not mL then local qk=rd.source;if qk==nil then qk="<enable element tracebacks>"end;local qB=qR:format(r3,qk)error(qB,0)end;oP.Name=tostring(qf)local bb=rd.props[qJ]if bb~=nil then pI.updateVirtualNodeWithChildren(pH,pH.hostObject,bb)end;oP.Parent=pO;pH.hostObject=oP;qU(rd.props[qN],oP)if pH.eventManager~=nil then pH.eventManager:resume()end end;function p4.unmountHostNode(pI,pH)local rd=pH.currentElement;qU(rd.props[qN],nil)for c_,pR in pairs(pH.children)do pI.unmountVirtualNode(pR)end;r4(pH)pH.hostObject:Destroy()end;function p4.updateHostNode(pI,pH,qE)local pX=pH.currentElement.props;local pU=qE.props;if pH.eventManager~=nil then pH.eventManager:suspend()end;if pX[qN]~=pU[qN]then qU(pX[qN],nil)qU(pU[qN],pH.hostObject)end;local mL,r3=xpcall(function()rc(pH,pX,pU)end,qT)if not mL then local qk=qE.source;if qk==nil then qk="<enable element tracebacks>"end;local qB=qS:format(r3,qk)error(qB,0)end;local bb=qE.props[qJ]if bb~=nil or pX[qJ]~=nil then pI.updateVirtualNodeWithChildren(pH,pH.hostObject,bb)end;if pH.eventManager~=nil then pH.eventManager:resume()end;return pH end;return p4 end,newEnv("Orca.include.node_modules.roact.src.RobloxRenderer"))()end)newModule("SingleEventManager","ModuleScript","Orca.include.node_modules.roact.src.SingleEventManager","Orca.include.node_modules.roact.src",function()return setfenv(function()local qx=require(script.Parent.Logging)local re="Change."local rf={Disabled="Disabled",Suspended="Suspended",Enabled="Enabled"}local qP={}qP.__index=qP;function qP.new(oP)local self=setmetatable({_suspendedEventQueue={},_connections={},_listeners={},_status=rf.Disabled,_isResuming=false,_instance=oP},qP)return self end;function qP:connectEvent(ea,rg)self:_connect(ea,self._instance[ea],rg)end;function qP:connectPropertyChange(ea,rg)local mL,nO=pcall(function()return self._instance:GetPropertyChangedSignal(ea)end)if not mL then error(("Cannot get changed signal on property %q: %s"):format(tostring(ea),nO),0)end;self:_connect(re..ea,nO,rg)end;function qP:_connect(rh,nO,rg)if rg==nil then if self._connections[rh]~=nil then self._connections[rh]:Disconnect()self._connections[rh]=nil end;self._listeners[rh]=nil else if self._connections[rh]==nil then self._connections[rh]=nO:Connect(function(...)if self._status==rf.Enabled then self._listeners[rh](self._instance,...)elseif self._status==rf.Suspended then local ri=select("#",...)table.insert(self._suspendedEventQueue,{rh,ri,...})end end)end;self._listeners[rh]=rg end end;function qP:suspend()self._status=rf.Suspended end;function qP:resume()if self._isResuming then return end;self._isResuming=true;local c2=1;while c2<=#self._suspendedEventQueue do local rj=self._suspendedEventQueue[c2]local rg=self._listeners[rj[1]]local ri=rj[2]if rg~=nil then local rk=coroutine.create(rg)local mL,dv=coroutine.resume(rk,self._instance,unpack(rj,3,2+ri))if not mL then qx.warn("%s",dv)end end;c2=c2+1 end;self._isResuming=false;self._status=rf.Enabled;self._suspendedEventQueue={}end;return qP end,newEnv("Orca.include.node_modules.roact.src.SingleEventManager"))()end)newModule("Symbol","ModuleScript","Orca.include.node_modules.roact.src.Symbol","Orca.include.node_modules.roact.src",function()return setfenv(function()local pa={}function pa.named(hf)assert(type(hf)=="string","Symbols must be created using a string name!")local self=newproxy(true)local rl=("Symbol(%s)"):format(hf)getmetatable(self).__tostring=function()return rl end;return self end;return pa end,newEnv("Orca.include.node_modules.roact.src.Symbol"))()end)newModule("Type","ModuleScript","Orca.include.node_modules.roact.src.Type","Orca.include.node_modules.roact.src",function()return setfenv(function()local pa=require(script.Parent.Symbol)local p5=require(script.Parent.strict)local pb=newproxy(true)local rm={}local function rn(hf)rm[hf]=pa.named("Roact"..hf)end;rn("Binding")rn("Element")rn("HostChangeEvent")rn("HostEvent")rn("StatefulComponentClass")rn("StatefulComponentInstance")rn("VirtualNode")rn("VirtualTree")function rm.of(d1)if typeof(d1)~="table"then return nil end;return d1[pb]end;getmetatable(pb).__index=rm;getmetatable(pb).__tostring=function()return"RoactType"end;p5(rm,"Type")return pb end,newEnv("Orca.include.node_modules.roact.src.Type"))()end)newModule("assertDeepEqual","ModuleScript","Orca.include.node_modules.roact.src.assertDeepEqual","Orca.include.node_modules.roact.src",function()return setfenv(function()local function ro(ho,dE)if typeof(ho)~=typeof(dE)then local nK=("{1} is of type %s, but {2} is of type %s"):format(typeof(ho),typeof(dE))return false,nK end;if typeof(ho)=="table"then local rp={}for ea,d1 in pairs(ho)do rp[ea]=true;local mL,rq=ro(d1,dE[ea])if not mL then local nK=rq:gsub("{1}",("{1}[%s]"):format(tostring(ea))):gsub("{2}",("{2}[%s]"):format(tostring(ea)))return false,nK end end;for ea,d1 in pairs(dE)do if not rp[ea]then local mL,rq=ro(d1,ho[ea])if not mL then local nK=rq:gsub("{1}",("{1}[%s]"):format(tostring(ea))):gsub("{2}",("{2}[%s]"):format(tostring(ea)))return false,nK end end end;return true end;if ho==dE then return true end;local nK="{1} ~= {2}"return false,nK end;local function rr(ho,dE)local mL,rs=ro(ho,dE)if not mL then local rq=rs:gsub("{1}","first"):gsub("{2}","second")local nK=("Values were not deep-equal.\n%s"):format(rq)error(nK,2)end end;return rr end,newEnv("Orca.include.node_modules.roact.src.assertDeepEqual"))()end)newModule("assign","ModuleScript","Orca.include.node_modules.roact.src.assign","Orca.include.node_modules.roact.src",function()return setfenv(function()local qC=require(script.Parent.None)local function pn(an,...)for c2=1,select("#",...)do local qk=select(c2,...)if qk~=nil then for ea,d1 in pairs(qk)do if d1==qC then an[ea]=nil else an[ea]=d1 end end end end;return an end;return pn end,newEnv("Orca.include.node_modules.roact.src.assign"))()end)newModule("createContext","ModuleScript","Orca.include.node_modules.roact.src.createContext","Orca.include.node_modules.roact.src",function()return setfenv(function()local pa=require(script.Parent.Symbol)local rt=require(script.Parent.createFragment)local p9=require(script.Parent.createSignal)local qJ=require(script.Parent.PropMarkers.Children)local pw=require(script.Parent.Component)local function ru(rv)return{value=rv,onUpdate=p9()}end;local function rw(pJ)local ah=pw:extend("Provider")function ah:init(ku)self.contextEntry=ru(ku.value)self:__addContext(pJ.key,self.contextEntry)end;function ah:willUpdate(rx)if rx.value~=self.props.value then self.contextEntry.value=rx.value end end;function ah:didUpdate(ry)if ry.value~=self.props.value then self.contextEntry.onUpdate:fire(self.props.value)end end;function ah:render()return rt(self.props[qJ])end;return ah end;local function rz(pJ)local rA=pw:extend("Consumer")function rA.validateProps(ku)if type(ku.render)~="function"then return false,"Consumer expects a `render` function"else return true end end;function rA:init(ku)self.contextEntry=self:__getContext(pJ.key)end;function rA:render()local d1;if self.contextEntry~=nil then d1=self.contextEntry.value else d1=pJ.defaultValue end;return self.props.render(d1)end;function rA:didUpdate()if self.contextEntry~=nil then self.lastValue=self.contextEntry.value end end;function rA:didMount()if self.contextEntry~=nil then self.disconnect=self.contextEntry.onUpdate:subscribe(function(ph)if ph~=self.lastValue then self:setState({})end end)end end;function rA:willUnmount()if self.disconnect~=nil then self.disconnect()end end;return rA end;local rB={}rB.__index=rB;function rB.new(qZ)return setmetatable({defaultValue=qZ,key=pa.named("ContextKey")},rB)end;function rB:__tostring()return"RoactContext"end;local function rC(qZ)local pJ=rB.new(qZ)return{Provider=rw(pJ),Consumer=rz(pJ)}end;return rC end,newEnv("Orca.include.node_modules.roact.src.createContext"))()end)newModule("createElement","ModuleScript","Orca.include.node_modules.roact.src.createElement","Orca.include.node_modules.roact.src",function()return setfenv(function()local qJ=require(script.Parent.PropMarkers.Children)local q5=require(script.Parent.ElementKind)local qx=require(script.Parent.Logging)local pb=require(script.Parent.Type)local pc=require(script.Parent.GlobalConfig).get()local rD=[[
The prop `Roact.Children` was defined but was overriden by the third parameter to createElement!
This can happen when a component passes props through to a child element but also uses the `children` argument:

	Roact.createElement("Frame", passedProps, {
		child = ...
	})

Instead, consider using a utility function to merge tables of children together:

	local children = mergeTables(passedProps[Roact.Children], {
		child = ...
	})

	local fullProps = mergeTables(passedProps, {
		[Roact.Children] = children
	})

	Roact.createElement("Frame", fullProps)]]local function rE(q8,ku,bb)if pc.typeChecks then assert(q8~=nil,"`component` is required")assert(typeof(ku)=="table"or ku==nil,"`props` must be a table or nil")assert(typeof(bb)=="table"or bb==nil,"`children` must be a table or nil")end;if ku==nil then ku={}end;if bb~=nil then if ku[qJ]~=nil then qx.warnOnce(rD)end;ku[qJ]=bb end;local rF=q5.fromComponent(q8)local rd={[pb]=pb.Element,[q5]=rF,component=q8,props=ku}if pc.elementTracing then rd.source=debug.traceback("",2):sub(2)end;return rd end;return rE end,newEnv("Orca.include.node_modules.roact.src.createElement"))()end)newModule("createFragment","ModuleScript","Orca.include.node_modules.roact.src.createFragment","Orca.include.node_modules.roact.src",function()return setfenv(function()local q5=require(script.Parent.ElementKind)local pb=require(script.Parent.Type)local function rt(qe)return{[pb]=pb.Element,[q5]=q5.Fragment,elements=qe}end;return rt end,newEnv("Orca.include.node_modules.roact.src.createFragment"))()end)newModule("createReconciler","ModuleScript","Orca.include.node_modules.roact.src.createReconciler","Orca.include.node_modules.roact.src",function()return setfenv(function()local pb=require(script.Parent.Type)local q5=require(script.Parent.ElementKind)local q9=require(script.Parent.ElementUtils)local qJ=require(script.Parent.PropMarkers.Children)local pa=require(script.Parent.Symbol)local pq=require(script.Parent.internalAssert)local pc=require(script.Parent.GlobalConfig).get()local ps=pa.named("InternalData")local function p2(rG)local pI;local rH;local rI;local rJ;local function rK(pH,qE)local pO=pH.hostParent;local qf=pH.hostKey;local o3=pH.depth;local mC=pH.parent;local pJ=pH.originalContext or pH.context;local rL=pH.parentLegacyContext;rJ(pH)local rM=rH(qE,pO,qf,pJ,rL)if rM~=nil then rM.depth=o3;rM.parent=mC end;return rM end;local function rN(pH,pO,rO)if pc.internalTypeChecks then pq(pb.of(pH)==pb.VirtualNode,"Expected arg #1 to be of type VirtualNode")end;local rP={}for rQ,pR in pairs(pH.children)do local qE=q9.getElementByKey(rO,rQ)local rM=rI(pR,qE)if rM~=nil then pH.children[rQ]=rM else rP[rQ]=true end end;for rQ in pairs(rP)do pH.children[rQ]=nil end;for rQ,qE in q9.iterateElements(rO)do local rR=rQ;if rQ==q9.UseParentKey then rR=pH.hostKey end;if pH.children[rQ]==nil then local pR=rH(qE,pO,rR,pH.context,pH.legacyContext)if pR~=nil then pR.depth=pH.depth+1;pR.parent=pH;pH.children[rQ]=pR end end end end;local function rS(pH,pO,rO)rN(pH,pO,rO)end;local function rT(pH,pO,pQ)if pb.of(pQ)==pb.Element or pQ==nil or typeof(pQ)=="boolean"then rN(pH,pO,pQ)else error(("%s\n%s"):format("Component returned invalid children:",pH.currentElement.source or"<enable element tracebacks>"),0)end end;function rJ(pH)if pc.internalTypeChecks then pq(pb.of(pH)==pb.VirtualNode,"Expected arg #1 to be of type VirtualNode")end;local mF=q5.of(pH.currentElement)if mF==q5.Host then rG.unmountHostNode(pI,pH)elseif mF==q5.Function then for c_,pR in pairs(pH.children)do rJ(pR)end elseif mF==q5.Stateful then pH.instance:__unmount()elseif mF==q5.Portal then for c_,pR in pairs(pH.children)do rJ(pR)end elseif mF==q5.Fragment then for c_,pR in pairs(pH.children)do rJ(pR)end else error(("Unknown ElementKind %q"):format(tostring(mF)),2)end end;local function rU(pH,qE)local bb=qE.component(qE.props)rT(pH,pH.hostParent,bb)return pH end;local function rV(pH,qE)local rW=pH.currentElement;local rX=rW.props.target;local rY=qE.props.target;assert(rG.isHostObject(rY),"Expected target to be host object")if rY~=rX then return rK(pH,qE)end;local bb=qE.props[qJ]rS(pH,rY,bb)return pH end;local function rZ(pH,qE)rS(pH,pH.hostParent,qE.elements)return pH end;function rI(pH,qE,el)if pc.internalTypeChecks then pq(pb.of(pH)==pb.VirtualNode,"Expected arg #1 to be of type VirtualNode")end;if pc.typeChecks then assert(pb.of(qE)==pb.Element or typeof(qE)=="boolean"or qE==nil,"Expected arg #2 to be of type Element, boolean, or nil")end;if pH.currentElement==qE and el==nil then return pH end;if typeof(qE)=="boolean"or qE==nil then rJ(pH)return nil end;if pH.currentElement.component~=qE.component then return rK(pH,qE)end;local mF=q5.of(qE)local r_=true;if mF==q5.Host then pH=rG.updateHostNode(pI,pH,qE)elseif mF==q5.Function then pH=rU(pH,qE)elseif mF==q5.Stateful then r_=pH.instance:__update(qE,el)elseif mF==q5.Portal then pH=rV(pH,qE)elseif mF==q5.Fragment then pH=rZ(pH,qE)else error(("Unknown ElementKind %q"):format(tostring(mF)),2)end;if not r_ then return pH end;pH.currentElement=qE;return pH end;local function s0(rd,pO,qf,pJ,s1)if pc.internalTypeChecks then pq(rG.isHostObject(pO)or pO==nil,"Expected arg #2 to be a host object")pq(typeof(pJ)=="table"or pJ==nil,"Expected arg #4 to be of type table or nil")pq(typeof(s1)=="table"or s1==nil,"Expected arg #5 to be of type table or nil")end;if pc.typeChecks then assert(qf~=nil,"Expected arg #3 to be non-nil")assert(pb.of(rd)==pb.Element or typeof(rd)=="boolean","Expected arg #1 to be of type Element or boolean")end;return{[pb]=pb.VirtualNode,currentElement=rd,depth=1,parent=nil,children={},hostParent=pO,hostKey=qf,legacyContext=s1,parentLegacyContext=s1,context=pJ or{},originalContext=nil}end;local function s2(pH)local rd=pH.currentElement;local bb=rd.component(rd.props)rT(pH,pH.hostParent,bb)end;local function s3(pH)local rd=pH.currentElement;local rY=rd.props.target;local bb=rd.props[qJ]assert(rG.isHostObject(rY),"Expected target to be host object")rS(pH,rY,bb)end;local function s4(pH)local rd=pH.currentElement;local bb=rd.elements;rS(pH,pH.hostParent,bb)end;function rH(rd,pO,qf,pJ,s1)if pc.internalTypeChecks then pq(rG.isHostObject(pO)or pO==nil,"Expected arg #2 to be a host object")pq(typeof(s1)=="table"or s1==nil,"Expected arg #5 to be of type table or nil")end;if pc.typeChecks then assert(qf~=nil,"Expected arg #3 to be non-nil")assert(pb.of(rd)==pb.Element or typeof(rd)=="boolean","Expected arg #1 to be of type Element or boolean")end;if typeof(rd)=="boolean"then return nil end;local mF=q5.of(rd)local pH=s0(rd,pO,qf,pJ,s1)if mF==q5.Host then rG.mountHostNode(pI,pH)elseif mF==q5.Function then s2(pH)elseif mF==q5.Stateful then rd.component:__mount(pI,pH)elseif mF==q5.Portal then s3(pH)elseif mF==q5.Fragment then s4(pH)else error(("Unknown ElementKind %q"):format(tostring(mF)),2)end;return pH end;local function s5(rd,pO,qf)if pc.typeChecks then assert(pb.of(rd)==pb.Element,"Expected arg #1 to be of type Element")assert(rG.isHostObject(pO)or pO==nil,"Expected arg #2 to be a host object")end;if qf==nil then qf="RoactTree"end;local s6={[pb]=pb.VirtualTree,[ps]={rootNode=nil,mounted=true}}s6[ps].rootNode=rH(rd,pO,qf)return s6 end;local function s7(s6)local pz=s6[ps]if pc.typeChecks then assert(pb.of(s6)==pb.VirtualTree,"Expected arg #1 to be a Roact handle")assert(pz.mounted,"Cannot unmounted a Roact tree that has already been unmounted")end;pz.mounted=false;if pz.rootNode~=nil then rJ(pz.rootNode)end end;local function s8(s6,qE)local pz=s6[ps]if pc.typeChecks then assert(pb.of(s6)==pb.VirtualTree,"Expected arg #1 to be a Roact handle")assert(pb.of(qE)==pb.Element,"Expected arg #2 to be a Roact Element")end;pz.rootNode=rI(pz.rootNode,qE)return s6 end;local function s9(pH)local sa=pH.parent;while sa do if sa.eventManager~=nil then sa.eventManager:suspend()end;sa=sa.parent end end;local function sb(pH)local sa=pH.parent;while sa do if sa.eventManager~=nil then sa.eventManager:resume()end;sa=sa.parent end end;pI={mountVirtualTree=s5,unmountVirtualTree=s7,updateVirtualTree=s8,createVirtualNode=s0,mountVirtualNode=rH,unmountVirtualNode=rJ,updateVirtualNode=rI,updateVirtualNodeWithChildren=rS,updateVirtualNodeWithRenderResult=rT,suspendParentEvents=s9,resumeParentEvents=sb}return pI end;return p2 end,newEnv("Orca.include.node_modules.roact.src.createReconciler"))()end)newModule("createReconcilerCompat","ModuleScript","Orca.include.node_modules.roact.src.createReconcilerCompat","Orca.include.node_modules.roact.src",function()return setfenv(function()local qx=require(script.Parent.Logging)local sc=[[
Roact.reify has been renamed to Roact.mount and will be removed in a future release.
Check the call to Roact.reify at:
]]local sd=[[
Roact.teardown has been renamed to Roact.unmount and will be removed in a future release.
Check the call to Roact.teardown at:
]]local se=[[
Roact.reconcile has been renamed to Roact.update and will be removed in a future release.
Check the call to Roact.reconcile at:
]]local function p3(pI)local sf={}function sf.reify(...)qx.warnOnce(sc)return pI.mountVirtualTree(...)end;function sf.teardown(...)qx.warnOnce(sd)return pI.unmountVirtualTree(...)end;function sf.reconcile(...)qx.warnOnce(se)return pI.updateVirtualTree(...)end;return sf end;return p3 end,newEnv("Orca.include.node_modules.roact.src.createReconcilerCompat"))()end)newModule("createRef","ModuleScript","Orca.include.node_modules.roact.src.createRef","Orca.include.node_modules.roact.src",function()return setfenv(function()local p6=require(script.Parent.Binding)local function sg()local cC,c_=p6.create(nil)local d9={}setmetatable(d9,{__index=function(self,ea)if ea=="current"then return cC:getValue()else return cC[ea]end end,__newindex=function(self,ea,d1)if ea=="current"then error("Cannot assign to the 'current' property of refs",2)end;cC[ea]=d1 end,__tostring=function(self)return("RoactRef(%s)"):format(tostring(cC:getValue()))end})return d9 end;return sg end,newEnv("Orca.include.node_modules.roact.src.createRef"))()end)newModule("createSignal","ModuleScript","Orca.include.node_modules.roact.src.createSignal","Orca.include.node_modules.roact.src",function()return setfenv(function()local function p9()local sh={}local si={}local sj=false;local function sk(self,d8)assert(typeof(d8)=="function","Can only subscribe to signals with a function.")local ki={callback=d8,disconnected=false}if sj and not sh[d8]then si[d8]=ki end;sh[d8]=ki;local function nQ()assert(not ki.disconnected,"Listeners can only be disconnected once.")ki.disconnected=true;sh[d8]=nil;si[d8]=nil end;return nQ end;local function sl(self,...)sj=true;for d8,ki in pairs(sh)do if not ki.disconnected and not si[d8]then d8(...)end end;sj=false;for d8,c_ in pairs(si)do si[d8]=nil end end;return{subscribe=sk,fire=sl}end;return p9 end,newEnv("Orca.include.node_modules.roact.src.createSignal"))()end)newModule("createSpy","ModuleScript","Orca.include.node_modules.roact.src.createSpy","Orca.include.node_modules.roact.src",function()return setfenv(function()local rr=require(script.Parent.assertDeepEqual)local function sm(sn)local self={callCount=0,values={},valuesLength=0}self.value=function(...)self.callCount=self.callCount+1;self.values={...}self.valuesLength=select("#",...)if sn~=nil then return sn(...)end end;self.assertCalledWith=function(c_,...)local so=select("#",...)if self.valuesLength~=so then error(("Expected %d arguments, but was called with %d arguments"):format(self.valuesLength,so),2)end;for js=1,so do local sp=select(js,...)assert(self.values[js]==sp,"value differs")end end;self.assertCalledWithDeepEqual=function(c_,...)local so=select("#",...)if self.valuesLength~=so then error(("Expected %d arguments, but was called with %d arguments"):format(self.valuesLength,so),2)end;for js=1,so do local sp=select(js,...)rr(self.values[js],sp)end end;self.captureValues=function(c_,...)local so=select("#",...)local dv={}assert(self.valuesLength==so,"length of expected values differs from stored values")for js=1,so do local ea=select(js,...)dv[ea]=self.values[js]end;return dv end;setmetatable(self,{__index=function(c_,ea)error(("%q is not a valid member of spy"):format(ea))end})return self end;return sm end,newEnv("Orca.include.node_modules.roact.src.createSpy"))()end)newModule("forwardRef","ModuleScript","Orca.include.node_modules.roact.src.forwardRef","Orca.include.node_modules.roact.src",function()return setfenv(function()local pn=require(script.Parent.assign)local qC=require(script.Parent.None)local qN=require(script.Parent.PropMarkers.Ref)local pc=require(script.Parent.GlobalConfig).get()local sq={[qN]=qC}local function sr(ss)if pc.typeChecks then assert(typeof(ss)=="function","Expected arg #1 to be a function")end;return function(ku)local d9=ku[qN]local st=pn({},ku,sq)return ss(st,d9)end end;return sr end,newEnv("Orca.include.node_modules.roact.src.forwardRef"))()end)newModule("getDefaultInstanceProperty","ModuleScript","Orca.include.node_modules.roact.src.getDefaultInstanceProperty","Orca.include.node_modules.roact.src",function()return setfenv(function()local pa=require(script.Parent.Symbol)local su=pa.named("Nil")local sv={}local function qQ(oN,qH)local sw=sv[oN]if sw then local sx=sw[qH]if sx==su then return true,nil end;if sx~=nil then return true,sx end else sw={}sv[oN]=sw end;local sy=Instance.new(oN)local mR,qZ=pcall(function()return sy[qH]end)sy:Destroy()if mR then if qZ==nil then sw[qH]=su else sw[qH]=qZ end end;return mR,qZ end;return qQ end,newEnv("Orca.include.node_modules.roact.src.getDefaultInstanceProperty"))()end)newModule("internalAssert","ModuleScript","Orca.include.node_modules.roact.src.internalAssert","Orca.include.node_modules.roact.src",function()return setfenv(function()local function pq(sz,nK)if not sz then error(nK.." (This is probably a bug in Roact!)",3)end end;return pq end,newEnv("Orca.include.node_modules.roact.src.internalAssert"))()end)newModule("invalidSetStateMessages","ModuleScript","Orca.include.node_modules.roact.src.invalidSetStateMessages","Orca.include.node_modules.roact.src",function()return setfenv(function()local po=require(script.Parent.ComponentLifecyclePhase)local pp={}pp[po.WillUpdate]=[[
setState cannot be used in the willUpdate lifecycle method.
Consider using the didUpdate method instead, or using getDerivedStateFromProps.

Check the definition of willUpdate in the component %q.]]pp[po.WillUnmount]=[[
setState cannot be used in the willUnmount lifecycle method.
A component that is being unmounted cannot be updated!

Check the definition of willUnmount in the component %q.]]pp[po.ShouldUpdate]=[[
setState cannot be used in the shouldUpdate lifecycle method.
shouldUpdate must be a pure function that only depends on props and state.

Check the definition of shouldUpdate in the component %q.]]pp[po.Render]=[[
setState cannot be used in the render method.
render must be a pure function that only depends on props and state.

Check the definition of render in the component %q.]]pp["default"]=[[
setState can not be used in the current situation, because Roact doesn't know
which part of the lifecycle this component is in.

This is a bug in Roact.
It was triggered by the component %q.
]]return pp end,newEnv("Orca.include.node_modules.roact.src.invalidSetStateMessages"))()end)newModule("oneChild","ModuleScript","Orca.include.node_modules.roact.src.oneChild","Orca.include.node_modules.roact.src",function()return setfenv(function()local function sA(bb)if not bb then return nil end;local ea,f7=next(bb)if not f7 then return nil end;local sB=next(bb,ea)if sB then error("Expected at most child, had more than one child.",2)end;return f7 end;return sA end,newEnv("Orca.include.node_modules.roact.src.oneChild"))()end)newModule("strict","ModuleScript","Orca.include.node_modules.roact.src.strict","Orca.include.node_modules.roact.src",function()return setfenv(function()local function p5(gG,hf)hf=hf or tostring(gG)return setmetatable(gG,{__index=function(self,ea)local nK=("%q (%s) is not a valid member of %s"):format(tostring(ea),typeof(ea),hf)error(nK,2)end,__newindex=function(self,ea,d1)local nK=("%q (%s) is not a valid member of %s"):format(tostring(ea),typeof(ea),hf)error(nK,2)end})end;return p5 end,newEnv("Orca.include.node_modules.roact.src.strict"))()end)newInstance("roact-hooked","Folder","Orca.include.node_modules.roact-hooked","Orca.include.node_modules")newModule("out","ModuleScript","Orca.include.node_modules.roact-hooked.out","Orca.include.node_modules.roact-hooked",function()return setfenv(function()local a=_G[script]local g={}local sC=a.import(script,script,"with-hooks")local sD=sC.withHooks;local sE=sC.withHooksPure;for av,aw in pairs(a.import(script,script,"hooks"))do g[av]=aw end;local function i(sF)return sD(sF)end;local function kx(sF)return sE(sF)end;g.hooked=i;g.pure=kx;return g end,newEnv("Orca.include.node_modules.roact-hooked.out"))()end)newModule("hooks","ModuleScript","Orca.include.node_modules.roact-hooked.out.hooks","Orca.include.node_modules.roact-hooked.out",function()return setfenv(function()local a=_G[script]local g={}g.useBinding=a.import(script,script,"use-binding").useBinding;g.useCallback=a.import(script,script,"use-callback").useCallback;g.useContext=a.import(script,script,"use-context").useContext;g.useEffect=a.import(script,script,"use-effect").useEffect;g.useMemo=a.import(script,script,"use-memo").useMemo;g.useReducer=a.import(script,script,"use-reducer").useReducer;g.useState=a.import(script,script,"use-state").useState;g.useMutable=a.import(script,script,"use-mutable").useMutable;g.useRef=a.import(script,script,"use-ref").useRef;return g end,newEnv("Orca.include.node_modules.roact-hooked.out.hooks"))()end)newModule("use-binding","ModuleScript","Orca.include.node_modules.roact-hooked.out.hooks.use-binding","Orca.include.node_modules.roact-hooked.out.hooks",function()return setfenv(function()local a=_G[script]local cz=a.import(script,a.getModule(script,"@rbxts","roact").src).createBinding;local sG=a.import(script,script.Parent.Parent,"utils","memoized-hook").memoizedHook;local function cc(bG)return sG(function()local sH={cz(bG)}return sH end).state end;return{useBinding=cc}end,newEnv("Orca.include.node_modules.roact-hooked.out.hooks.use-binding"))()end)newModule("use-callback","ModuleScript","Orca.include.node_modules.roact-hooked.out.hooks.use-callback","Orca.include.node_modules.roact-hooked.out.hooks",function()return setfenv(function()local a=_G[script]local l=a.import(script,script.Parent,"use-memo").useMemo;local function j(d8,ds)return l(function()return d8 end,ds)end;return{useCallback=j}end,newEnv("Orca.include.node_modules.roact-hooked.out.hooks.use-callback"))()end)newModule("use-context","ModuleScript","Orca.include.node_modules.roact-hooked.out.hooks.use-context","Orca.include.node_modules.roact-hooked.out.hooks",function()return setfenv(function()local a=_G[script]local sI=a.import(script,script.Parent.Parent,"utils","memoized-hook")local sG=sI.memoizedHook;local sJ=sI.resolveCurrentComponent;local k=a.import(script,script.Parent,"use-effect").useEffect;local aH=a.import(script,script.Parent,"use-state").useState;local function sK(q8)return setmetatable({},{__index=q8})end;local function e7(pJ)local sL=pJ;local U=sG(function()local nD=sK(sJ())sL.Consumer.init(nD)return nD.contextEntry end)local sM=U.state;if sM then local dt=aH(sM.value)local d1=dt[1]local lx=dt[2]k(function()return sM.onUpdate:subscribe(lx)end,{})return d1 else return sL.defaultValue end end;return{useContext=e7}end,newEnv("Orca.include.node_modules.roact-hooked.out.hooks.use-context"))()end)newModule("use-effect","ModuleScript","Orca.include.node_modules.roact-hooked.out.hooks.use-effect","Orca.include.node_modules.roact-hooked.out.hooks",function()return setfenv(function()local a=_G[script]local sN=a.import(script,script.Parent.Parent,"utils","are-deps-equal").areDepsEqual;local sI=a.import(script,script.Parent.Parent,"utils","memoized-hook")local sG=sI.memoizedHook;local sJ=sI.resolveCurrentComponent;local function sO(eg)local U=sJ()local sP=U.effects;if sP.tail==nil then sP.tail=eg;sP.head=sP.tail else local ax=sP.tail;ax.next=eg;sP.tail=ax.next end;return eg end;local function k(d8,ds)local sQ=sG(nil)local sR=sQ.state;if sR~=nil then sR=sR.deps end;local sS=sR;if ds and sN(ds,sS)then return nil end;sQ.state=sO({id=sQ.id,callback=d8,deps=ds})end;return{useEffect=k}end,newEnv("Orca.include.node_modules.roact-hooked.out.hooks.use-effect"))()end)newModule("use-memo","ModuleScript","Orca.include.node_modules.roact-hooked.out.hooks.use-memo","Orca.include.node_modules.roact-hooked.out.hooks",function()return setfenv(function()local a=_G[script]local sN=a.import(script,script.Parent.Parent,"utils","are-deps-equal").areDepsEqual;local sG=a.import(script,script.Parent.Parent,"utils","memoized-hook").memoizedHook;local function l(sT,ds)local sQ=sG(function()return{}end)local U=sQ.state;local sU=U[1]local sS=U[2]if sU~=nil and(ds and sN(ds,sS))then return sU end;local sV=sT()sQ.state={sV,ds}return sV end;return{useMemo=l}end,newEnv("Orca.include.node_modules.roact-hooked.out.hooks.use-memo"))()end)newModule("use-mutable","ModuleScript","Orca.include.node_modules.roact-hooked.out.hooks.use-mutable","Orca.include.node_modules.roact-hooked.out.hooks",function()return setfenv(function()local a=_G[script]local sG=a.import(script,script.Parent.Parent,"utils","memoized-hook").memoizedHook;local function m(bG)return sG(function()return{current=bG}end).state end;return{useMutable=m}end,newEnv("Orca.include.node_modules.roact-hooked.out.hooks.use-mutable"))()end)newModule("use-reducer","ModuleScript","Orca.include.node_modules.roact-hooked.out.hooks.use-reducer","Orca.include.node_modules.roact-hooked.out.hooks",function()return setfenv(function()local a=_G[script]local sI=a.import(script,script.Parent.Parent,"utils","memoized-hook")local sG=sI.memoizedHook;local sJ=sI.resolveCurrentComponent;local function dk(dq,sW,sX)local sY=sJ()local sQ=sG(function()local b0;if sX then b0=sX(sW)else b0=sW end;return b0 end)local function aW(aR)local sZ=dq(sQ.state,aR)if sQ.state~=sZ then sY:setHookState(sQ.id,function()sQ.state=sZ;return sQ.state end)end end;return{sQ.state,aW}end;return{useReducer=dk}end,newEnv("Orca.include.node_modules.roact-hooked.out.hooks.use-reducer"))()end)newModule("use-ref","ModuleScript","Orca.include.node_modules.roact-hooked.out.hooks.use-ref","Orca.include.node_modules.roact-hooked.out.hooks",function()return setfenv(function()local a=_G[script]local sg=a.import(script,a.getModule(script,"@rbxts","roact").src).createRef;local sG=a.import(script,script.Parent.Parent,"utils","memoized-hook").memoizedHook;local function s_()return sG(function()return sg()end).state end;return{useRef=s_}end,newEnv("Orca.include.node_modules.roact-hooked.out.hooks.use-ref"))()end)newModule("use-state","ModuleScript","Orca.include.node_modules.roact-hooked.out.hooks.use-state","Orca.include.node_modules.roact-hooked.out.hooks",function()return setfenv(function()local a=_G[script]local dk=a.import(script,script.Parent,"use-reducer").useReducer;local function aH(dz)local U=dk(function(F,aR)local b0;if type(aR)=="function"then b0=aR(F)else b0=aR end;return b0 end,nil,function()local b0;if type(dz)=="function"then b0=dz()else b0=dz end;return b0 end)local F=U[1]local aW=U[2]return{F,aW}end;return{useState=aH}end,newEnv("Orca.include.node_modules.roact-hooked.out.hooks.use-state"))()end)newModule("types","ModuleScript","Orca.include.node_modules.roact-hooked.out.types","Orca.include.node_modules.roact-hooked.out",function()return setfenv(function()return nil end,newEnv("Orca.include.node_modules.roact-hooked.out.types"))()end)newInstance("utils","Folder","Orca.include.node_modules.roact-hooked.out.utils","Orca.include.node_modules.roact-hooked.out")newModule("are-deps-equal","ModuleScript","Orca.include.node_modules.roact-hooked.out.utils.are-deps-equal","Orca.include.node_modules.roact-hooked.out.utils",function()return setfenv(function()local function sN(t0,sS)if sS==nil then return false end;if#t0~=#sS then return false end;do local js=0;local hK=false;while true do if hK then js=js+1 else hK=true end;if not(js<#t0)then break end;if t0[js+1]==sS[js+1]then continue;end;return false end end;return true end;return{areDepsEqual=sN}end,newEnv("Orca.include.node_modules.roact-hooked.out.utils.are-deps-equal"))()end)newModule("memoized-hook","ModuleScript","Orca.include.node_modules.roact-hooked.out.utils.memoized-hook","Orca.include.node_modules.roact-hooked.out.utils",function()return setfenv(function()local t1=table.concat({"Invalid hook call. Hooks can only be called inside of the body of a function component.","This is usually the result of conflicting versions of roact-hooked.","See https://reactjs.org/link/invalid-hook-call for tips about how to debug and fix this problem."},"\n")local t2="Failed to render hook! (Another hooked component is rendering)"local t3="Failed to render hook! (Another hooked component rendered during this one)"local t4;local t5;local function t6(q8)local y=t5==nil;assert(y,t2)t5=q8 end;local function t7(q8)local y=t5==q8;assert(y,t3)t5=nil;t4=nil end;local function sJ()return t5 or error(t1,3)end;local function sG(bG)local t5=sJ()local b0;if t4 then b0=t4.next else b0=t5.firstHook end;local t8=b0;if t8 then t4=t8 else local b1;if type(bG)=="function"then b1=bG()else b1=bG end;local F=b1;local t9={id=t4 and t4.id+1 or 0,state=F,baseState=F}if not t4 then t4=t9;t5.firstHook=t4 else t4.next=t9;t4=t4.next end end;return t4 end;return{renderReady=t6,renderDone=t7,resolveCurrentComponent=sJ,memoizedHook=sG}end,newEnv("Orca.include.node_modules.roact-hooked.out.utils.memoized-hook"))()end)newModule("with-hooks","ModuleScript","Orca.include.node_modules.roact-hooked.out.with-hooks","Orca.include.node_modules.roact-hooked.out",function()return setfenv(function()local a=_G[script]local g={}local sC=a.import(script,script,"with-hooks")g.withHooks=sC.withHooks;g.withHooksPure=sC.withHooksPure;return g end,newEnv("Orca.include.node_modules.roact-hooked.out.with-hooks"))()end)newModule("component-with-hooks","ModuleScript","Orca.include.node_modules.roact-hooked.out.with-hooks.component-with-hooks","Orca.include.node_modules.roact-hooked.out.with-hooks",function()return setfenv(function()local a=_G[script]local sI=a.import(script,script.Parent.Parent,"utils","memoized-hook")local t7=sI.renderDone;local t6=sI.renderReady;local ta;do ta={}function ta:constructor()end;function ta:init()self.effects={}self.effectHandles={}end;function ta:setHookState(dh,dq)self:setState(function(F)return{[dh]=dq(F[dh])}end)end;function ta:render()t6(self)local tb=self.functionComponent;local tc=self.props;local td,te=pcall(tb,tc)local dv=td and{success=true,value=te}or{success=false,error=te}t7(self)if not dv.success then error("(ComponentWithHooks) "..dv.error)end;return dv.value end;function ta:didMount()self:flushEffects()end;function ta:didUpdate()self:flushEffects()end;function ta:willUnmount()self:unmountEffects()self.effects.head=nil end;function ta:flushEffectsHelper(eg)if not eg then return nil end;local tf=self.effectHandles;local tg=eg.id;local b0=tf[tg]if b0~=nil then b0()end;local ao=eg.callback()if ao then local th=self.effectHandles;local ti=eg.id;th[ti]=ao end;self:flushEffectsHelper(eg.next)end;function ta:flushEffects()self:flushEffectsHelper(self.effects.head)self.effects.head=nil;self.effects.tail=nil end;function ta:unmountEffects()local tf=self.effectHandles;local y=function(ao)return ao()end;for av,aw in pairs(tf)do y(aw,av,tf)end;table.clear(self.effectHandles)end end;return{ComponentWithHooks=ta}end,newEnv("Orca.include.node_modules.roact-hooked.out.with-hooks.component-with-hooks"))()end)newModule("with-hooks","ModuleScript","Orca.include.node_modules.roact-hooked.out.with-hooks.with-hooks","Orca.include.node_modules.roact-hooked.out.with-hooks",function()return setfenv(function()local a=_G[script]local ta=a.import(script,script.Parent,"component-with-hooks").ComponentWithHooks;local b=a.import(script,a.getModule(script,"@rbxts","roact").src)local function tj(tk)for gH,bM in pairs(ta)do tk[gH]=bM end end;local function sD(sF)local tl;do tl=b.Component:extend("ComponentClass")function tl:init()end;tl.functionComponent=sF end;tj(tl)return tl end;local function sE(sF)local tl;do tl=b.PureComponent:extend("ComponentClass")function tl:init()end;tl.functionComponent=sF end;tj(tl)return tl end;return{withHooks=sD,withHooksPure=sE}end,newEnv("Orca.include.node_modules.roact-hooked.out.with-hooks.with-hooks"))()end)newInstance("roact-rodux-hooked","Folder","Orca.include.node_modules.roact-rodux-hooked","Orca.include.node_modules")newModule("out","ModuleScript","Orca.include.node_modules.roact-rodux-hooked.out","Orca.include.node_modules.roact-rodux-hooked",function()return setfenv(function()local a=_G[script]local g={}g.Provider=a.import(script,script,"components","provider").Provider;g.useDispatch=a.import(script,script,"hooks","use-dispatch").useDispatch;g.useSelector=a.import(script,script,"hooks","use-selector").useSelector;g.useStore=a.import(script,script,"hooks","use-store").useStore;g.shallowEqual=a.import(script,script,"helpers","shallow-equal").shallowEqual;g.RoactRoduxContext=a.import(script,script,"components","context").RoactRoduxContext;return g end,newEnv("Orca.include.node_modules.roact-rodux-hooked.out"))()end)newInstance("components","Folder","Orca.include.node_modules.roact-rodux-hooked.out.components","Orca.include.node_modules.roact-rodux-hooked.out")newModule("context","ModuleScript","Orca.include.node_modules.roact-rodux-hooked.out.components.context","Orca.include.node_modules.roact-rodux-hooked.out.components",function()return setfenv(function()local a=_G[script]local b=a.import(script,a.getModule(script,"@rbxts","roact").src)local tm=b.createContext(nil)return{RoactRoduxContext=tm}end,newEnv("Orca.include.node_modules.roact-rodux-hooked.out.components.context"))()end)newModule("provider","ModuleScript","Orca.include.node_modules.roact-rodux-hooked.out.components.provider","Orca.include.node_modules.roact-rodux-hooked.out.components",function()return setfenv(function()local a=_G[script]local tm=a.import(script,script.Parent,"context").RoactRoduxContext;local h=a.import(script,a.getModule(script,"@rbxts","roact-hooked").out)local i=h.hooked;local l=h.useMemo;local b=a.import(script,a.getModule(script,"@rbxts","roact").src)local ah=i(function(C)local ek=C.store;local bb=C[b.Children]local tn=l(function()return{store=ek}end,{ek})local to={value=tn}local tp={}local bf=#tp;if bb then for av,aw in pairs(bb)do if type(av)=="number"then tp[bf+av]=aw else tp[av]=aw end end end;return b.createElement(tm.Provider,to,tp)end)return{Provider=ah}end,newEnv("Orca.include.node_modules.roact-rodux-hooked.out.components.provider"))()end)newInstance("helpers","Folder","Orca.include.node_modules.roact-rodux-hooked.out.helpers","Orca.include.node_modules.roact-rodux-hooked.out")newModule("shallow-equal","ModuleScript","Orca.include.node_modules.roact-rodux-hooked.out.helpers.shallow-equal","Orca.include.node_modules.roact-rodux-hooked.out.helpers",function()return setfenv(function()local a=_G[script]local oS=a.import(script,a.getModule(script,"@rbxts","object-utils"))local function hl(tq,tr)if tq==tr then return true end;if not(type(tq)=="table")or not(type(tr)=="table")then return false end;local ts=oS.keys(tq)local tt=oS.keys(tr)if#ts~=#tt then return false end;local y=function(d1,c2)return d1==tr[c2]end;local b0=true;for av,aw in ipairs(ts)do if not y(aw,av-1,ts)then b0=false;break end end;return b0 end;return{shallowEqual=hl}end,newEnv("Orca.include.node_modules.roact-rodux-hooked.out.helpers.shallow-equal"))()end)newInstance("hooks","Folder","Orca.include.node_modules.roact-rodux-hooked.out.hooks","Orca.include.node_modules.roact-rodux-hooked.out")newModule("use-dispatch","ModuleScript","Orca.include.node_modules.roact-rodux-hooked.out.hooks.use-dispatch","Orca.include.node_modules.roact-rodux-hooked.out.hooks",function()return setfenv(function()local a=_G[script]local m=a.import(script,a.getModule(script,"@rbxts","roact-hooked").out).useMutable;local cT=a.import(script,script.Parent,"use-store").useStore;local function cR()local ek=cT()return m(function(aR)return ek:dispatch(aR)end).current end;return{useDispatch=cR}end,newEnv("Orca.include.node_modules.roact-rodux-hooked.out.hooks.use-dispatch"))()end)newModule("use-selector","ModuleScript","Orca.include.node_modules.roact-rodux-hooked.out.hooks.use-selector","Orca.include.node_modules.roact-rodux-hooked.out.hooks",function()return setfenv(function()local a=_G[script]local h=a.import(script,a.getModule(script,"@rbxts","roact-hooked").out)local k=h.useEffect;local m=h.useMutable;local dk=h.useReducer;local cT=a.import(script,script.Parent,"use-store").useStore;local function cS(tu,tv)if tv==nil then tv=function(ho,dE)return ho==dE end end;local U=dk(function(bd)return bd+1 end,0)local tw=U[2]local ek=cT()local tx=m()local ty=m()local tz=m()local tA=m()local tB=ek:getState()local tC;a.try(function()local tD=tu~=ty.current or tB~=tz.current or tx.current;if tD~=""and tD then local tE=tu(tB)if tA.current==nil or not tv(tE,tA.current)then tC=tE else tC=tA.current end else tC=tA.current end end,function(du)if tx.current~=nil then du=du.."\nThe error may be correlated with this previous error:\n"..tx.current.."\n\n"end;error(du)end)k(function()ty.current=tu;tz.current=tB;tA.current=tC;tx.current=nil end)k(function()local function tF(tG)local mn,mo=a.try(function()if tG==tz.current then return a.TRY_RETURN,{}end;local tE=ty.current(tG)if tv(tE,tA.current)then return a.TRY_RETURN,{}end;tA.current=tE;tz.current=tG end,function(du)tx.current=du end)if mn then return unpack(mo)end;task.spawn(tw)end;local tH=ek.changed:connect(tF)tF(ek:getState())return function()return tH:disconnect()end end,{ek})return tC end;return{useSelector=cS}end,newEnv("Orca.include.node_modules.roact-rodux-hooked.out.hooks.use-selector"))()end)newModule("use-store","ModuleScript","Orca.include.node_modules.roact-rodux-hooked.out.hooks.use-store","Orca.include.node_modules.roact-rodux-hooked.out.hooks",function()return setfenv(function()local a=_G[script]local tm=a.import(script,script.Parent.Parent,"components","context").RoactRoduxContext;local e7=a.import(script,a.getModule(script,"@rbxts","roact-hooked").out).useContext;local function cT()return e7(tm).store end;return{useStore=cT}end,newEnv("Orca.include.node_modules.roact-rodux-hooked.out.hooks.use-store"))()end)newModule("types","ModuleScript","Orca.include.node_modules.roact-rodux-hooked.out.types","Orca.include.node_modules.roact-rodux-hooked.out",function()return setfenv(function()return nil end,newEnv("Orca.include.node_modules.roact-rodux-hooked.out.types"))()end)newInstance("rodux","Folder","Orca.include.node_modules.rodux","Orca.include.node_modules")newModule("src","ModuleScript","Orca.include.node_modules.rodux.src","Orca.include.node_modules.rodux",function()return setfenv(function()local tI=require(script.Store)local tJ=require(script.createReducer)local tK=require(script.combineReducers)local tL=require(script.makeActionCreator)local tM=require(script.loggerMiddleware)local tN=require(script.thunkMiddleware)return{Store=tI,createReducer=tJ,combineReducers=tK,makeActionCreator=tL,loggerMiddleware=tM.middleware,thunkMiddleware=tN}end,newEnv("Orca.include.node_modules.rodux.src"))()end)newModule("NoYield","ModuleScript","Orca.include.node_modules.rodux.src.NoYield","Orca.include.node_modules.rodux.src",function()return setfenv(function()local function tO(og,mR,...)if not mR then local nK=...error(debug.traceback(og,nK),2)end;if coroutine.status(og)~="dead"then error(debug.traceback(og,"Attempted to yield inside changed event!"),2)end;return...end;local function tP(d8,...)local og=coroutine.create(d8)return tO(og,coroutine.resume(og,...))end;return tP end,newEnv("Orca.include.node_modules.rodux.src.NoYield"))()end)newModule("Signal","ModuleScript","Orca.include.node_modules.rodux.src.Signal","Orca.include.node_modules.rodux.src",function()return setfenv(function()local function tQ(n8,...)local tR={}local so=#n8;for ea=1,so do tR[ea]=n8[ea]end;for js=1,select("#",...)do tR[so+js]=select(js,...)end;return tR end;local function tS(n8,tT)local tR={}for js=1,#n8 do if n8[js]~=tT then table.insert(tR,n8[js])end end;return tR end;local oi={}oi.__index=oi;function oi.new(ek)local self={_listeners={},_store=ek}setmetatable(self,oi)return self end;function oi:connect(d8)if typeof(d8)~="function"then error("Expected the listener to be a function.")end;if self._store and self._store._isDispatching then error('You may not call store.changed:connect() while the reducer is executing. '..'If you would like to be notified after the store has been updated, subscribe from a '..'component and invoke store:getState() in the callback to access the latest state. ')end;local rg={callback=d8,disconnected=false,connectTraceback=debug.traceback(),disconnectTraceback=nil}self._listeners=tQ(self._listeners,rg)local function nQ()if rg.disconnected then error(("Listener connected at: \n%s\n".."was already disconnected at: \n%s\n"):format(tostring(rg.connectTraceback),tostring(rg.disconnectTraceback)))end;if self._store and self._store._isDispatching then error("You may not unsubscribe from a store listener while the reducer is executing.")end;rg.disconnected=true;rg.disconnectTraceback=debug.traceback()self._listeners=tS(self._listeners,rg)end;return{disconnect=nQ}end;function oi:fire(...)for c_,rg in ipairs(self._listeners)do if not rg.disconnected then rg.callback(...)end end end;return oi end,newEnv("Orca.include.node_modules.rodux.src.Signal"))()end)newModule("Store","ModuleScript","Orca.include.node_modules.rodux.src.Store","Orca.include.node_modules.rodux.src",function()return setfenv(function()local en=game:GetService("RunService")local oi=require(script.Parent.Signal)local tP=require(script.Parent.NoYield)local tU=3;local tV={reportReducerError=function(tW,aR,tX)error(string.format("Received error: %s\n\n%s",tX.message,tX.thrownValue))end,reportUpdateError=function(tW,tY,tZ,tX)error(string.format("Received error: %s\n\n%s",tX.message,tX.thrownValue))end}local function t_(nK)return debug.traceback(tostring(nK))end;local tI={}tI._flushEvent=en.Heartbeat;tI.__index=tI;function tI.new(dq,dz,u0,u1)assert(typeof(dq)=="function","Bad argument #1 to Store.new, expected function.")assert(u0==nil or typeof(u0)=="table","Bad argument #3 to Store.new, expected nil or table.")if u0~=nil then for js=1,#u0,1 do assert(typeof(u0[js])=="function",("Expected the middleware ('%s') at index %d to be a function."):format(tostring(u0[js]),js))end end;local self={}self._errorReporter=u1 or tV;self._isDispatching=false;self._reducer=dq;local u2={type="@@INIT"}self._actionLog={u2}local mR,dv=xpcall(function()self._state=dq(dz,u2)end,t_)if not mR then self._errorReporter.reportReducerError(dz,u2,{message="Caught error in reducer with init",thrownValue=dv})self._state=dz end;self._lastState=self._state;self._mutatedSinceFlush=false;self._connections={}self.changed=oi.new(self)setmetatable(self,tI)local ki=self._flushEvent:Connect(function()self:flush()end)table.insert(self._connections,ki)if u0 then local u3=self.dispatch;local aW=function(...)return u3(self,...)end;for js=#u0,1,-1 do local u4=u0[js]aW=u4(aW,self)end;self.dispatch=function(u5,...)return aW(...)end end;return self end;function tI:getState()if self._isDispatching then error(("You may not call store:getState() while the reducer is executing. ".."The reducer (%s) has already received the state as an argument. ".."Pass it down from the top reducer instead of reading it from the store."):format(tostring(self._reducer)))end;return self._state end;function tI:dispatch(aR)if typeof(aR)~="table"then error(("Actions must be tables. ".."Use custom middleware for %q actions."):format(typeof(aR)),2)end;if aR.type==nil then error("Actions may not have an undefined 'type' property. ".."Have you misspelled a constant? \n"..tostring(aR),2)end;if self._isDispatching then error("Reducers may not dispatch actions.")end;local mR,dv=pcall(function()self._isDispatching=true;self._state=self._reducer(self._state,aR)self._mutatedSinceFlush=true end)self._isDispatching=false;if not mR then self._errorReporter.reportReducerError(self._state,aR,{message="Caught error in reducer",thrownValue=dv})end;if#self._actionLog==tU then table.remove(self._actionLog,1)end;table.insert(self._actionLog,aR)end;function tI:destruct()for c_,ki in ipairs(self._connections)do ki:Disconnect()end;self._connections=nil end;function tI:flush()if not self._mutatedSinceFlush then return end;self._mutatedSinceFlush=false;local F=self._state;local mR,tX=xpcall(function()tP(function()self.changed:fire(F,self._lastState)end)end,t_)if not mR then self._errorReporter.reportUpdateError(self._lastState,F,self._actionLog,{message="Caught error flushing store updates",thrownValue=tX})end;self._lastState=F end;return tI end,newEnv("Orca.include.node_modules.rodux.src.Store"))()end)newModule("combineReducers","ModuleScript","Orca.include.node_modules.rodux.src.combineReducers","Orca.include.node_modules.rodux.src",function()return setfenv(function()local function tK(q)return function(F,aR)if F==nil then F={}end;local el={}for ea,dq in pairs(q)do el[ea]=dq(F[ea],aR)end;return el end end;return tK end,newEnv("Orca.include.node_modules.rodux.src.combineReducers"))()end)newModule("createReducer","ModuleScript","Orca.include.node_modules.rodux.src.createReducer","Orca.include.node_modules.rodux.src",function()return setfenv(function()return function(dz,u6)return function(F,aR)if F==nil then F=dz end;local ol=u6[aR.type]if ol then return ol(F,aR)end;return F end end end,newEnv("Orca.include.node_modules.rodux.src.createReducer"))()end)newModule("loggerMiddleware","ModuleScript","Orca.include.node_modules.rodux.src.loggerMiddleware","Orca.include.node_modules.rodux.src",function()return setfenv(function()local u7=require(script.Parent.prettyPrint)local tM={outputFunction=print}function tM.middleware(u8,ek)return function(aR)local dv=u8(aR)tM.outputFunction(("Action dispatched: %s\nState changed to: %s"):format(u7(aR),u7(ek:getState())))return dv end end;return tM end,newEnv("Orca.include.node_modules.rodux.src.loggerMiddleware"))()end)newModule("makeActionCreator","ModuleScript","Orca.include.node_modules.rodux.src.makeActionCreator","Orca.include.node_modules.rodux.src",function()return setfenv(function()local function tL(hf,jJ)assert(type(hf)=="string","Bad argument #1: Expected a string name for the action creator")assert(type(jJ)=="function","Bad argument #2: Expected a function that creates action objects")return setmetatable({name=hf},{__call=function(self,...)local dv=jJ(...)assert(type(dv)=="table","Invalid action: An action creator must return a table")dv.type=hf;return dv end})end;return tL end,newEnv("Orca.include.node_modules.rodux.src.makeActionCreator"))()end)newModule("prettyPrint","ModuleScript","Orca.include.node_modules.rodux.src.prettyPrint","Orca.include.node_modules.rodux.src",function()return setfenv(function()local qj="    "local function u7(d1,ql)ql=ql or 0;local u9={}if typeof(d1)=="table"then table.insert(u9,"{\n")for ua,ub in pairs(d1)do table.insert(u9,qj:rep(ql+1))table.insert(u9,tostring(ua))table.insert(u9," = ")table.insert(u9,u7(ub,ql+1))table.insert(u9,"\n")end;table.insert(u9,qj:rep(ql))table.insert(u9,"}")elseif typeof(d1)=="string"then table.insert(u9,string.format("%q",d1))table.insert(u9," (string)")else table.insert(u9,tostring(d1))table.insert(u9," (")table.insert(u9,typeof(d1))table.insert(u9,")")end;return table.concat(u9,"")end;return u7 end,newEnv("Orca.include.node_modules.rodux.src.prettyPrint"))()end)newModule("thunkMiddleware","ModuleScript","Orca.include.node_modules.rodux.src.thunkMiddleware","Orca.include.node_modules.rodux.src",function()return setfenv(function()local function t_(nK)return debug.traceback(nK)end;local function tN(u8,ek)return function(aR)if typeof(aR)=="function"then local mR,dv=xpcall(function()return aR(ek)end,t_)if not mR then ek._errorReporter.reportReducerError(ek:getState(),aR,{message="Caught error in thunk",thrownValue=dv})return nil end;return dv end;return u8(aR)end end;return tN end,newEnv("Orca.include.node_modules.rodux.src.thunkMiddleware"))()end)newModule("services","ModuleScript","Orca.include.node_modules.services","Orca.include.node_modules",function()return setfenv(function()return setmetatable({},{__index=function(self,uc)local ud=game:GetService(uc)self[uc]=ud;return ud end})end,newEnv("Orca.include.node_modules.services"))()end)newInstance("types","Folder","Orca.include.node_modules.types","Orca.include.node_modules")newInstance("include","Folder","Orca.include.node_modules.types.include","Orca.include.node_modules.types")newInstance("generated","Folder","Orca.include.node_modules.types.include.generated","Orca.include.node_modules.types.include")

init()